c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine Adapt_Check_UpDown

      !integer status(MPI_STATUS_SIZE)   
      
      include 'common.3D'
      
      integer i_BC_Possible_global(n_procs_max),i_BC(n_procs_max)
            
      itime_check = 10e8     !-1    !10e8     !0    !10e8     !
      
      !-- Adaptive algorithm --
      !i_Above_Boundary_Change =  0  : No Change
      !i_Above_Boundary_Change = -1  : Shift boundary -2h
      !i_Above_Boundary_Change =  1  : Shift boundary +2h
      i_Above_Boundary_Change_Possible = 0
      i_Above_Boundary_Change = 0
      i_Below_Boundary_Change = 0

        zmin_rank_old = zmin_rank
        zmax_rank_old = zmax_rank
        ncz_local_old = ncz_local
        nsheet_local_old = nsheet_local
c        !if(rank_id.lt.n_procs-1.and.(.NOT.iCartTop_periodicity(1)))then
c        if(rank_id.lt.n_procs-1)then    !CHECK THIS!!!!!!!!!!!!!!!!!!!!!
c          if(nFP_local_Above.gt.nFP_local + nFP_difference_max)then
c            if(zmax_rank_Above-zmin_rank_Above.gt.zrank_length_max)then   !8.05*h)then
c              i_Above_Boundary_Change =  1
c            end if
c          end if
c          if(nFP_local_Above.lt.nFP_local - nFP_difference_max)then
c            if(zmax_rank-zmin_rank.gt.zrank_length_max)then   !8.05*h)then
c              i_Above_Boundary_Change = -1
c            end if
c          end if
c        end if
        !-- Checking between procs not adjacent --
        if(rank_idz.lt.n_procs_z-1.and.rank_idz.gt.0)then
         if(nFP_local_Above -nFP_local_Below.gt.nFP_difference_max)then
           if(zmax_rank_Above-zmin_rank_Above.gt.zrank_length_max)then
             i_Above_Boundary_Change_Possible =  1
           end if
         end if
         if(nFP_local_Above -nFP_local_Below.lt.-nFP_difference_max)then
           if(zmax_rank-zmin_rank.gt.zrank_length_max)then
             i_Above_Boundary_Change_Possible = -1
           end if
         end if
        end if
        !-- Checking first & final processors --
        if(rank_idz.eq.0)then
         if(nFP_local_Above -nFP_local.gt.nFP_difference_max)then
           if(zmax_rank_Above-zmin_rank_Above.gt.zrank_length_max)then
             i_Above_Boundary_Change_Possible =  1
           end if
         end if
         if(nFP_local_Above - nFP_local.lt.-nFP_difference_max)then
           if(zmax_rank-zmin_rank.gt.zrank_length_max)then   !8.05*h)then
             i_Above_Boundary_Change_Possible = -1
           end if
         end if
        end if
        !-- JUST MESSING TO TRY AND DEBUG --
        !if(itime.eq.0)then
        !  if(rank_id.eq.1)i_Above_Boundary_Change = -1
        !  if(rank_id.eq.2)i_Above_Boundary_Change =  1
        !if(rank_id.eq.1)then
        !  i_Above_Boundary_Change = -1
        !elseif(rank_id.eq.2)then
        !  i_Above_Boundary_Change =  1
        !else
        !  i_Above_Boundary_Change = 0
        !endif

        !-- For initial balancing --
        if(itime.eq.0)then

         !-- Don't reverse previous partition shift for 3 previous shifts --
         if( (abs(nFP_local-nFP_local_previous1).gt.int(0.1*np/n_procs)
     &   .or.abs(nFP_local-nFP_local_previous2).gt.int(0.1*np/n_procs)
     &   .or.abs(nFP_local-nFP_local_previous3).gt.int(0.1*np/n_procs)
     &       ).and.
     &      (abs(nFP_local-nFP_local_previous1).lt.int(0.2*np/n_procs))
     &      )then
            i_Above_Boundary_Change_Possible = 0
          endif

        endif

        !- Check Numbers of Particles either side of column -
        call MPI_GATHER(
     &        i_Above_Boundary_Change_Possible , 1, MPI_INTEGER,
     &        i_BC_Possible_global(rank_id+1)  , 1, MPI_INTEGER,
     &        0, grid_comm, ierr)
c        if(rank_id.eq.0)then
c          print*,'i_BC_Possible_global ',
c     &            i_BC_Possible_global(1:n_procs)
c        endif
        do i_rank_z = 1,n_procs_z
          i_BC_sheet_stay = 0
          i_BC_sheet_moveDown   = 0
          i_BC_sheet_moveUp     = 0
          do i_rank_x = 1,n_procs_x
          do i_rank_y = 1,n_procs_y
            i_rank = i_rank_x + (i_rank_y - 1)*n_procs_x
     &                        + (i_rank_z - 1)*n_procs_x*n_procs_y
            !Check i_Above_Boundary_Change_Possible
            if(i_BC_Possible_global(i_rank).gt.0)then
              i_BC_sheet_moveUp = i_BC_sheet_moveUp + 1
            elseif(i_BC_Possible_global(i_rank).lt.0)then
              i_BC_sheet_moveDown = i_BC_sheet_moveDown + 1
            else
              i_BC_sheet_stay = i_BC_sheet_stay + 1
            endif
          enddo
          enddo
          !- Determine which way entire sheet should move -
          i_BC_sheet  = 0
          if(i_rank_z.lt.n_procs_z)then
            if(i_BC_sheet_moveDown .ge.i_BC_sheet_stay)then
              i_BC_sheet  = -1
            endif
            if(i_BC_sheet_moveUp   .ge.i_BC_sheet_moveDown .and.
     &         i_BC_sheet_moveUp   .ge.i_BC_sheet_stay)then
              i_BC_sheet  = 1
            endif
          endif
          i_BC(i_rank_z) = i_BC_sheet
c          if(rank_id.eq.0)
c     &    print*,'rank_id, i_BC_sheet ',rank_id, i_BC_sheet,
c     &    i_BC_sheet_moveDown,i_BC_sheet_stay,i_BC_sheet_moveUp
        enddo

        !- Transmit movements to sheet -
        call MPI_BCast(i_BC, n_procs_max, MPI_INTEGER,
     &                 0, grid_comm, ierr)
        i_Above_Boundary_Change = i_BC(rank_idz+1)
c        print*,'rank_id, i_Above_Boundary_Change ',
c     &          rank_id, i_Above_Boundary_Change
c
c        !stop


        call MPI_SENDRECV(
     &    i_Above_Boundary_Change , 1, MPI_INTEGER, above, 1,
     &    i_Below_Boundary_Change , 1, MPI_INTEGER, below, 1,
     &    grid_comm, status, ierr)
        if(i_Above_Boundary_Change.eq.1)then
          zmax_rank  = zmax_rank  + two_h
          zmax_local = zmax_local + two_h
          ncz_local  = ncz_local + 1
          nsheet_local = nsheet_local !remains unchanged for a vertical increase in ncz_local
          nct_local = nsheet_local*ncz_local
        end if
        if(i_Above_Boundary_Change.eq.-1)then
          zmax_rank  = zmax_rank  - two_h
          zmax_local = zmax_local - two_h
          ncz_local  = ncz_local - 1
          nsheet_local = nsheet_local !remains unchanged for a vertical increase in ncz_local
          nct_local = nsheet_local*ncz_local
        end if
        if(i_Below_Boundary_Change.eq.1)then
          zmin_rank  = zmin_rank  + two_h
          zmin_local = zmin_local + two_h
          ncz_local  = ncz_local - 1
          nsheet_local = nsheet_local !remains unchanged for a vertical increase in ncz_local
          nct_local = nsheet_local*ncz_local
        end if
        if(i_Below_Boundary_Change.eq.-1)then
          zmin_rank  = zmin_rank  - two_h
          zmin_local = zmin_local - two_h
          ncz_local  = ncz_local + 1
          nsheet_local = nsheet_local !remains unchanged for a vertical increase in ncz_local
          nct_local = nsheet_local*ncz_local
        end if
c      end if

      if(nct_local .ge. nct_max) then
        print*
        print*,'ERROR in Adapt_MPI_Check_3D.f'
        print*,'No. of cells exceeds nct_max in common.3D'
        print*,'rank_id  ',rank_id
        print*,'nct_local ',nct_local
        print*,'nct_max   ',nct_max
        print*
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      endif 
      
!      !- Diagnostic Info -
!       if(itime.ge.itime_check)then
! c     &   .and.itime/n_itime_Adapt*n_itime_Adapt.eq.itime)then
!         do i=0,n_procs-1
!           if(i.eq.rank_id.and.itime.gt.itime_check.and.
!      &      (i_Above_Boundary_Change.ne.0.or.
!      &       i_Below_Boundary_Change.ne.0)   )then
!             print*
!             print*,'Index_check - Adaptive Check, itime, n_shifts ', 
!      &              itime, n_shifts
!             print*,'rank_id, above, below ',rank_id, above, below 
!             print*,'i_Above_Boundary_Change_Possible ',
!      &              i_Above_Boundary_Change_Possible
!             print*,'i_Above&Below_Boundary_Change ',
!      &              i_Above_Boundary_Change, i_Below_Boundary_Change
!             print*,'nFP_local, nFP_local_Above, nFP_local_Below ',
!      &              nFP_local, nFP_local_Above, nFP_local_Below
!             !print*,'i_Above_Boundary_Change ',i_Above_Boundary_Change
!             !print*,'i_Below_Boundary_Change ',i_Below_Boundary_Change
!             !print*,'nFP_local      ',nFP_local
!             !print*,'nFP_local_Above ',nFP_local_Above
!             !print*,'two_h, 8.0*h ',two_h, 8.0*h
!             print*,'zrank_length_max ',zrank_length_max
!             print*,'zmin_rank_old, zmin_rank ',zmin_rank_old, zmin_rank
!             print*,'zmax_rank_old, zmax_rank ',zmax_rank_old, zmax_rank
!             print*,'ncz_local_old, ncz_local ',ncz_local_old, ncz_local
!             print*,'nsheet_local_old, nsheet_local ',
!      &              nsheet_local_old, nsheet_local
!             print*
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!         call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         !stop
!       end if
      
      
      end subroutine
