c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.
      
      subroutine SendRecv_Data_toBelow

      include 'common.3D'

      integer iabsolute_BP_going_Below(nGuestmax)
      integer iabsolute_BP_from_Above(nGuestmax)
      
      !-- Derived DataTypes --
      real(kind=kind_XYZ)  P_xyz_data_going_Below(nGuestmax,3)
      real(kind=kind_XYZ)  P_xyz_data_from_Above(nGuestmax,3)
      real P_data_going_Below(nGuestmax,23)
      real P_data_from_Above(nGuestmax,23)
      real BP_data_going_Below(nGuestmax,13)
      real BP_data_from_Above(nGuestmax,13)
      real Tau_data_going_Below(nGuestmax,6)
      real Tau_data_from_Above(nGuestmax,6)

      integer nps_in_lz_2(4), nps_from_Above(4)
c
      
      itime_check = 10e8   !0   !10e8
      irank_check = 6


      !SendRecv numbers of Guest Particles Between Host Processors

!      !- Diagnostic Info -
!       if(itime.ge.itime_check+10e8)then 
!         if(rank_id.eq.0.and.itime.ge.0)then   !if(rank_id.eq.-10)then
!           print*
!           print*,'In SendRecv_Data'
!           !print*,'Particles to be exported'
!         end if
!         do i=0,n_procs-1
!           if(i.eq.rank_id.and.itime.ge.itime_check)then   !if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
!             print*
!             print*,'rank_id ', rank_id
!             print*,'itime   ', itime
!             print*,'nb_local       ',nb_local
!             print*,'np_local       ',np_local
!             print*,'nbf_in_lz_2    ',nbf_in_lz_2
!             print*,'nbfreem_in_lz_2  ',nbfreem_in_lz_2
!             print*,'nb_in_lz_2     ',nb_in_lz_2
!             print*,'nFP_in_lz_2    ',nFP_in_lz_2
!             print*,'np_in_lz_2     ',np_in_lz_2
!             print*,'nbf_in_lz_ncz_localminus1 ',
!      &              nbf_in_lz_ncz_localminus1
!             print*,'nbfreem_in_lz_ncz_localminus1  ',
!      &              nbfreem_in_lz_ncz_localminus1
!             print*,'nb_in_lz_ncz_localminus1   ',
!      &              nb_in_lz_ncz_localminus1
!             print*,'nFP_in_lz_ncz_localminus1  ',
!      &              nFP_in_lz_ncz_localminus1
!             print*,'np_in_lz_ncz_localminus1   ',
!      &              np_in_lz_ncz_localminus1
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!         call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
!       endif

      !-- Zero non-communicating processes --
      if(rank_idz.eq.0
     &   .and.(.NOT.iCartTop_periodicity(3)))then
        nbf_from_Below = 0
        nbfm_from_Below = 0
        nbfreem_from_Below = 0
        np_from_Below = 0
        if(n_procs_z.eq.1)then
          nbf_from_Above = 0
          nbfm_from_Above = 0
          nbfreem_from_Above = 0
          np_from_Above = 0
          nps_from_Above = 0
        end if
      else if(rank_idz.eq.n_procs_z-1
     &   .and.(.NOT.iCartTop_periodicity(3)))then
        nbf_from_Above = 0
        nbfm_from_Above = 0
        nbfreem_from_Above = 0
        np_from_Above = 0
        nps_from_Above = 0
        if(n_procs_z.eq.1)then
          nbf_from_Below = 0
          nbfm_from_Below = 0
          nbfreem_from_Below = 0
          np_from_Below = 0
        end if
      end if

!       if(itime.ge.itime_check)then
!         if(rank_id.eq.-10)then
!           print*,'Cartesian Topology'
!         end if
!         do i=0,n_procs-1
!           if(i.eq.-rank_id)then   !if(i.eq.rank_id)then
!             write(*,*),'rank_id, above, below ',rank_id, above, below 
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!       end if
            
      !--- Up-Down Communications ---
        nbf_from_Below        = 0  
        nbfm_from_Below       = 0  
        nbfreem_from_Below    = 0  
        np_from_Below         = 0 

      !- Pack incoming particle numbers -
      nps_in_lz_2(1) = nbf_in_lz_2
      nps_in_lz_2(2) = nbfm_in_lz_2
      nps_in_lz_2(3) = nbfreem_in_lz_2
      nps_in_lz_2(4) = np_in_lz_2
      !Send to Below Neighbour
        call MPI_SENDRECV(
     &    nps_in_lz_2    , 1, iInt_IntegerType4, below, 107,
     &    nps_from_Above , 1, iInt_IntegerType4, above, 107,
     &    grid_comm, status, ierr)
      !- UNPack incoming particle numbers -
      nbf_from_Above     = nps_from_Above(1)
      nbfm_from_Above    = nps_from_Above(2)
      nbfreem_from_Above = nps_from_Above(3)
      np_from_Above      = nps_from_Above(4)
      
      !-- Temporary values after East->West transfer --
      nb_image_temp0      =  nb_image_local
      nFP_image_temp0     =  np_image_local - nb_image_local           
      nbf_image_temp0     =  nbf_image_local
      nbfm_image_temp0    =  nbfm_image_local - nbf_image_local
      nbfreem_image_temp0 =  nbfreem_image_local - nbfm_image_local

      !- Zero additional counter for travelling guest particles (from East to Down) -          
      if(ndim.gt.1)then
        nbf_in_ly_2_temp = 0
        nbfm_in_ly_2_temp = 0
        nbfreem_in_ly_2_temp = 0
      endif      

      !With no Open Boundary Water Particles (OBWPs)
      nb_from_Above = nbfreem_from_Above
      nb_from_Below = nbfreem_from_Below
          
      !-- Set Particle Numbers of Image on each Processor --    
      nbf_image_local  = nbf_image_local+ nbf_from_Above+ nbf_from_Below
      nbfm_image_local = nbfm_image_local
     &                      + nbfm_from_Above + nbfm_from_Below
      nbfreem_image_local= nbfreem_image_local
     &                      + nbfreem_from_Above + nbfreem_from_Below
      nb_image_local   = nb_image_local + nb_from_Above + nb_from_Below
      np_image_local   = np_image_local + np_from_Above + np_from_Below    
       
      nbp1_image_local = nb_image_local + 1
      
      !Error catching
      if(np_from_Above.gt.nGuestmax)then
        print*
        print*,'ERROR in SendRecv_Data.f'
        print*,'np_from_Above.gt.nGuestmax'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_from_Above ',np_from_Above
        print*,'nGuestmax    ',nGuestmax
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      else if(np_from_Below.gt.nGuestmax)then
        print*
        print*,'ERROR in SendRecv_Data.f'
        print*,'np_from_Below.gt.nGuestmax'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_from_Below ',np_from_Below
        print*,'nGuestmax    ',nGuestmax
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      end if
      if(np_image_local.gt.npar)then
        print*
        print*,'ERROR in SendRecv_Data.f'
        print*,'np_image_local.gt.npar'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_image_local ',np_image_local
        print*,'npar           ',npar
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      endif
      if(nbfreem_image_local.ne.nb_image_local)then
        print*
        print*,'ERROR in SendRecv_Data.f'
        print*,'nbfreem_image_local.ne.nb_image_local'
        print*,'rank_id, itime ',rank_id, itime
        print*,'nbfreem_image_local ',nbfreem_image_local
        print*,'nb_image_local    ',nb_image_local
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      endif
            
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
498   format(5('  ',I5,'    '))     
      !--------------------------

      !Synchronize ip_index pointer array for resident particles
      nb_image_temp      = nb_image_temp0
      nFP_image_temp     = nFP_image_temp0
            
      nbf_image_temp     = nbf_image_temp0
      nbfm_image_temp    = nbfm_image_temp0
      nbfreem_image_temp = nbfreem_image_temp0
      
      
      !--- PREPARE DATA PACKAGES FOR SENDRECVing ---
      
      !-- Pack Particle data to be sent Below--
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!       if(itime.ge.itime_check.and.rank_id.eq.12)then
!         print*
!         print*,'Packing Particle Data to go Below'
!         print*,'rank_id, np_in_lz_2, nb_going_Below, np_going_Below ',
!      &          rank_id, np_in_lz_2, nb_going_Below, np_going_Below
!       end if
      nbfm_start    = nbf_in_lz_2 + 1
      nbfreem_start = nbfm_in_lz_2 + 1
      nFP_start     = nb_going_Below + 1
      do ii=1,np_going_Below     !do ii=1,np_in_lz_2
        if(ii.lt.nbfm_start)then        
          i = iBP_going_Below_1(ii)
        elseif(ii.lt.nbfreem_start)then        
          i = iBP_going_Below_2(ii-nbf0_in_lz_2)
        elseif(ii.lt.nFP_start)then        
          i = iBP_going_Below_3(ii-(nbf0_in_lz_2+nbfm0_in_lz_2))
        !if(ii.le.nb_going_Below)then        
        !  i = iBP_going_Below(ii)
        else
          i = iFP_going_Below(ii-nb_going_Below)
        end if                
        P_xyz_data_going_Below(ii,1)  = xp(i)
        P_xyz_data_going_Below(ii,2)  = yp(i)        
        P_xyz_data_going_Below(ii,3)  = zp(i)        
        P_data_going_Below(ii,1)  = up(i)
        P_data_going_Below(ii,2)  = vp(i)        
        P_data_going_Below(ii,3)  = wp(i)        
        P_data_going_Below(ii,4)  = rhop(i)
        P_data_going_Below(ii,5)  = p(i)        
        P_data_going_Below(ii,6)  = pm(i)        
        P_data_going_Below(ii,7)  = pVol(i)        
        P_data_going_Below(ii,8)  = cs(i)        
        P_data_going_Below(ii,9)  = dudx_CSPH(i)
        P_data_going_Below(ii,10) = dudy_CSPH(i)
        P_data_going_Below(ii,11) = dudz_CSPH(i)
        P_data_going_Below(ii,12) = dvdx_CSPH(i)
        P_data_going_Below(ii,13) = dvdy_CSPH(i)
        P_data_going_Below(ii,14) = dvdz_CSPH(i)
        P_data_going_Below(ii,15) = dwdx_CSPH(i)
        P_data_going_Below(ii,16) = dwdy_CSPH(i)
        P_data_going_Below(ii,17) = dwdz_CSPH(i)
        P_data_going_Below(ii,18) = drhodx_CSPH(i)
        P_data_going_Below(ii,19) = drhody_CSPH(i)
        P_data_going_Below(ii,20) = drhodz_CSPH(i)
        P_data_going_Below(ii,21) = dTEdx_CSPH(i)
        P_data_going_Below(ii,22) = dTEdy_CSPH(i)
        P_data_going_Below(ii,23) = dTEdz_CSPH(i)
        Tau_data_going_Below(ii,1) = tau_xx_uno_rho2(i)
        Tau_data_going_Below(ii,2) = tau_xy_uno_rho2(i)
        Tau_data_going_Below(ii,3) = tau_xz_uno_rho2(i)
        Tau_data_going_Below(ii,4) = tau_yy_uno_rho2(i)
        Tau_data_going_Below(ii,5) = tau_yz_uno_rho2(i)
        Tau_data_going_Below(ii,6) = tau_zz_uno_rho2(i)
        if(ii.le.nb_going_Below)then
          BP_data_going_Below(ii,1) = xnb(i)
          BP_data_going_Below(ii,2) = ynb(i)
          BP_data_going_Below(ii,3) = znb(i)
          BP_data_going_Below(ii,4) = xtb(i)
          BP_data_going_Below(ii,5) = ytb(i)
          BP_data_going_Below(ii,6) = ztb(i)
          BP_data_going_Below(ii,7) = xsb(i)
          BP_data_going_Below(ii,8) = ysb(i)
          BP_data_going_Below(ii,9) = zsb(i)
          BP_data_going_Below(ii,10) = deltaptb(i,1)
          BP_data_going_Below(ii,11) = deltaptb(i,2)
          BP_data_going_Below(ii,12) = deltapsb(i,1)
          BP_data_going_Below(ii,13) = deltapsb(i,2)
          iabsolute_BP_going_Below(ii) = iabsolute_BP_Pointer_index(i)          
        end if
c        !-- Debug Code------
!         if(rank_id.eq.12.and.itime.ge.itime_check)then
!           print*,'ii, i',ii, i
! c          print*,'xp(i), yp(i) ',
! c     &            xp(i), yp(i) 
!            print*,
!      &          'P_xyz_data_going_Below(ii, 1:3) ',
!      &           ii, i,P_xyz_data_going_Below(ii,1:3)
!      
! !           print*,
! !      &          'P_data_going_Below(ii,1), P_data_going_Below(ii,2) '
! !           print*,P_data_going_Below(ii,1), P_data_going_Below(ii,2),
! !      &           P_data_going_Below(ii,3), P_data_going_Below(ii,4)
! !           print*,P_data_going_Below(ii,5)
! !           print*,P_data_going_Below(ii,6), P_data_going_Below(ii,7)
! !           
! !           if(i_particleType(i).le.2)then
! !             print*,'iabsolute_BP_going_Below(ii) ',
! !      &              iabsolute_BP_going_Below(ii)
! !           end if
!         end if
      end do
     
      !call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
            
c            
c      !- Send to Neighbour Below -
      call MPI_SENDRECV(
     & iabsolute_BP_going_Below, nb_going_Below, MPI_INTEGER,below, 131,
     & iabsolute_BP_from_Above , nb_from_Above , MPI_INTEGER,above, 131,
     & grid_comm, status, ierr)      
      !---Combined SendRecv's to Neighbour Below ---
      call MPI_SENDRECV(
     &  P_xyz_data_going_Below  , 1 , iP_xyzDataTypeA, below, 143,
     &  P_xyz_data_from_Above   , 1 , iP_xyzDataTypeA, above, 143,
     &  grid_comm, status, ierr)
      call MPI_SENDRECV(
     &  P_data_going_Below   , 1 , iP_DataTypeSR , below, 144,
     &  P_data_from_Above    , 1 , iP_DataTypeSR , above, 144,
     &  grid_comm, status, ierr)
      call MPI_SENDRECV(
     &  BP_data_going_Below, 1 , iBP_DataType  , below, 145,
     &  BP_data_from_Above , 1 , iBP_DataType  , above, 145,
     &  grid_comm, status, ierr)
      call MPI_SENDRECV(
     &  Tau_data_going_Below, 1 , iTau_DataType  , below, 146,
     &  Tau_data_from_Above , 1 , iTau_DataType  , above, 146,
     &  grid_comm, status, ierr)

c      call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
      
c      !-- Debug Code------
c      if(itime.ge.itime_check)then
c        if(rank_id.eq.0)then
c          print*
c          print*,'In SendRecv_Data'
c          print*,'Particles numbers to be swapped'
c        end if
c        do i=0,n_procs-1
c          if(i.eq.-rank_id)then
c            write(*,*)
c            write(*,*),'rank_id ', rank_id
c            write(*,*),'nb_going_East ',nb_going_East
c            write(*,*),'np_going_East ',np_going_East
c            write(*,*),'nb_going_Below ',nb_going_Below
c            write(*,*),'np_going_Below ',np_going_Below
c            write(*,*),'nb_from_Above ',nb_from_Above
c            write(*,*),'np_from_Above ',np_from_Above
c            write(*,*),'nb_from_Below ',nb_from_Below
c            write(*,*),'np_from_Below ',np_from_Below
c          end if
c          call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
c        end do
c      end if



496   format(i5,3('     ',i5,'  '),'  ',2('   ',e12.6))  

      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
                       
!       !-- Debug Code------
!       if(rank_id.eq.0.and.itime.ge.itime_check)then
!         print*
!         print*,'Unpacking Particle Data from Above'
!         print*,'rank_id, itime, np_from_Above ',
!      &          rank_id,itime,np_from_Above
!         print*,'nbf_local          ',nbf_local
!         print*,'nbfm_local         ',nbfm_local
!         print*,'nbfreem_local      ',nbfreem_local
!         print*,'nb_local           ',nb_local
!         print*,'nbf_from_Above       ',nbf_from_Above
!         print*,'nbfm_from_Above      ',nbfm_from_Above
!         print*,'nbfreem_from_Above   ',nbfreem_from_Above
!         print*,'nb_from_Above        ',nb_from_Above
!         print*,'np_from_Above        ',np_from_Above
!         print*,'nb_from_East        ',nb_from_East
!         print*,'np_from_East        ',np_from_East
!         print*,'nbf_image_local      ',nbf_image_local
!         print*,'nbfm_image_local     ',nbfm_image_local
!         print*,'nbfreem_image_local  ',nbfreem_image_local
!         print*,'nb_image_local       ',nb_image_local
!         print*,'nbf_image_temp       ',nbf_image_temp
!         print*,'nbfm_image_temp      ',nbfm_image_temp
!         print*,'nbfreem_image_temp   ',nbfreem_image_temp
!         print*,'nb_image_temp        ',nb_image_temp
!         print*,'np_local ',np_local
!         print*,'kk_highest ',kk_highest
!         print*,'kk_highest_after_SR_toWest    ',
!      &          kk_highest_after_SR_toWest
!         print*,'ii, i_image, nb/FP_image_temp, ip_index_#P_local,
!      &xp(i_image), zp(i_image)'
!       end if
      !-- Unpack Particle data --
      do ii=1,np_from_Above
        !i_image = np_local + np_from_Below + ii    !CORRECT THIS FOR DISORDERED PARTICLES!!!!
        !i_image = kk_highest + np_from_Below + ii
        i_image = kk_highest_after_SR_toWest + ii
          if(i_image.gt.npar)then
            print*
            print*,'ERROR in SendRecv_Data_toBelow_3D.f'
            print*,'i_image.gt.npar '
            print*,'Adjust npar in common.3D'
            print*,'rank_id, itime ',rank_id, itime
            print*,'i_image   ',i_image
            print*,'npar    ',npar
            print*,'kk_highest                    ',kk_highest
            print*,'kk_highest_after_SR_toWest    ',
     &              kk_highest_after_SR_toWest
            print*,'nb_local      ',nb_local
            print*,'np_local      ',np_local
            print*,'nb_from_Above    ',nb_from_Above
            print*,'np_from_Above    ',np_from_Above
            print*,'nb_from_Above    ',nb_from_Above
            print*,'np_from_Above    ',np_from_Above
            print*,'nb_image_local      ',nb_image_local
            print*,'np_image_local      ',np_image_local
            print*
            stop
          endif
        xp(i_image)             = P_xyz_data_from_Above(ii,1)
        yp(i_image)             = P_xyz_data_from_Above(ii,2)
        zp(i_image)             = P_xyz_data_from_Above(ii,3)
        up(i_image)             = P_data_from_Above(ii,1)
        vp(i_image)             = P_data_from_Above(ii,2)
        wp(i_image)             = P_data_from_Above(ii,3)
        rhop(i_image)           = P_data_from_Above(ii,4)
        p(i_image)              = P_data_from_Above(ii,5)
        pm(i_image)             = P_data_from_Above(ii,6)
        pVol(i_image)           = P_data_from_Above(ii,7)
        cs(i_image)             = P_data_from_Above(ii,8)
        dudx_CSPH(i_image)      = P_data_from_Above(ii,9)
        dudy_CSPH(i_image)      = P_data_from_Above(ii,10)        
        dudz_CSPH(i_image)      = P_data_from_Above(ii,11)
        dvdx_CSPH(i_image)      = P_data_from_Above(ii,12)        
        dvdy_CSPH(i_image)      = P_data_from_Above(ii,13)       
        dvdz_CSPH(i_image)      = P_data_from_Above(ii,14)        
        dwdx_CSPH(i_image)      = P_data_from_Above(ii,15)
        dwdy_CSPH(i_image)      = P_data_from_Above(ii,16)        
        dwdz_CSPH(i_image)      = P_data_from_Above(ii,17)
        drhodx_CSPH(i_image)    = P_data_from_Above(ii,18)
        drhody_CSPH(i_image)    = P_data_from_Above(ii,19)        
        drhodz_CSPH(i_image)    = P_data_from_Above(ii,20)
        dTEdx_CSPH(i_image)     = P_data_from_Above(ii,21)
        dTEdy_CSPH(i_image)     = P_data_from_Above(ii,22)        
        dTEdz_CSPH(i_image)     = P_data_from_Above(ii,23)
        tau_xx_uno_rho2(i_image) = Tau_data_from_Above(ii,1)
        tau_xy_uno_rho2(i_image) = Tau_data_from_Above(ii,2)
        tau_xz_uno_rho2(i_image) = Tau_data_from_Above(ii,3)
        tau_yy_uno_rho2(i_image) = Tau_data_from_Above(ii,4)
        tau_yz_uno_rho2(i_image) = Tau_data_from_Above(ii,5)
        tau_zz_uno_rho2(i_image) = Tau_data_from_Above(ii,6)
        iflag(i_image) = 1
        !-- Append to ip_index pointer arrays --
        if(ii.le.nb_from_Above)then
          if(i_image.gt.nb_max)then
            print*
            print*,'ERROR in SendRecv_Data_toBelow_3D.f'
            print*,'i_image.gt.nb_max '
            print*,'Adjust nb_max in common.3D'
            print*,'rank_id, itime ',rank_id, itime
            print*,'i_image   ',i_image
            print*,'nb_max    ',nb_max
            print*
            stop
          endif
          nb_image_temp = nb_image_temp + 1
          ip_index_BP_local(nb_image_temp) = i_image
          !Normals
          xnb(i_image)        = BP_data_from_Above(ii,1)
          ynb(i_image)        = BP_data_from_Above(ii,2)
          znb(i_image)        = BP_data_from_Above(ii,3)
          xtb(i_image)        = BP_data_from_Above(ii,4)
          ytb(i_image)        = BP_data_from_Above(ii,5)
          ztb(i_image)        = BP_data_from_Above(ii,6)
          xsb(i_image)        = BP_data_from_Above(ii,7)
          ysb(i_image)        = BP_data_from_Above(ii,8)
          zsb(i_image)        = BP_data_from_Above(ii,9)
          deltaptb(i_image,1) = BP_data_from_Above(ii,10)
          deltaptb(i_image,2) = BP_data_from_Above(ii,11)
          deltapsb(i_image,1) = BP_data_from_Above(ii,12)
          deltapsb(i_image,2) = BP_data_from_Above(ii,13)
         iabsolute_BP_Pointer_index(i_image)=iabsolute_BP_from_Above(ii)
c          !- Array & Pointer printout -
c          if(rank_id.eq.0.and.itime.ge.itime_check)then
c            write(*,496),ii, i_image, nb_image_temp,  
c     &       ip_index_BP_local(nb_image_temp),xp(i_image), zp(i_image)
c            print*,'P_data_from_Above'
c            write(*,*)P_xyz_data_from_Above(ii,1),
c     &                P_xyz_data_from_Above(ii,2)
c            
c            write(*,*)P_data_from_Above(ii,1), P_data_from_Above(ii,2)
c            write(*,*)P_data_from_Above(ii,3), P_data_from_Above(ii,4)
c            write(*,*)P_data_from_Above(ii,5), P_data_from_Above(ii,6)
c            write(*,*)P_data_from_Above(ii,7)
c            write(*,*)'iabsolute_BP_Pointer_index(i_image) ',
c     &                 iabsolute_BP_Pointer_index(i_image)
c          end if
          !- Indexing -
          nb_image_temp2 = nb_image_temp - nb_image_temp0   !nb_image_temp2 = nb_image_temp - nb_local
          if(nb_image_temp2.le.nbf_from_Above)then
            i_particleType(i_image) = 1   !Fixed Boundary Particle
            nbf_image_temp = nbf_image_temp + 1
            ip_index_BP_local_1(nbf_image_temp) = i_image
          else if(nb_image_temp2.le.nbfm_from_Above)then
            i_particleType(i_image) = 2   !Forced Moving Boundary Particle
            nbfm_image_temp = nbfm_image_temp + 1
            ip_index_BP_local_2(nbfm_image_temp) = i_image
          else if(nb_image_temp2.le.nbfreem_from_Above)then
            i_particleType(i_image) = 3   !Free Moving Boundary Particle
            nbfreem_image_temp = nbfreem_image_temp + 1
            ip_index_BP_local_3(nbfreem_image_temp) = i_image
          end if
        else
          nFP_image_temp = nFP_image_temp + 1
          ip_index_FP_local(nFP_image_temp) = i_image
c          !- Array & Pointer printout -
c          if(rank_id.eq.0.and.itime.ge.itime_check)then   !if(rank_id.eq.-12)then
c            write(*,496),ii, i_image, nFP_image_temp,  
c     &       ip_index_FP_local(nFP_image_temp),xp(i_image), zp(i_image)
c            print*,'P_data_from_Above'
c            write(*,*)P_xyz_data_from_Above(ii,1),
c     &                P_xyz_data_from_Above(ii,2)
c            
c            write(*,*)P_data_from_Above(ii,1), P_data_from_Above(ii,2)
c            write(*,*)P_data_from_Above(ii,3), P_data_from_Above(ii,4)
c            write(*,*)P_data_from_Above(ii,5), P_data_from_Above(ii,6)
c            write(*,*)P_data_from_Above(ii,7)
c          end if
          i_particleType(i_image) = 4   !Fluid Particle
        end if
        if(ndim.gt.2.and.n_procs_y.gt.1)then   !- 3-D MPI Cartesian Topology -
          if(yp(i_image).lt.ymin_rank+two_h)then
            if(i_particleType(i_image).lt.4)then          !Boundary Particle
              if(i_particleType(i_image).eq.1)then        !Fixed BP 
                nbf_in_ly_2_temp = nbf_in_ly_2_temp + 1
                nb_in_ly_2 = nb_in_ly_2 + 1
                nbf0_in_ly_2 = nbf0_in_ly_2 + 1
                iBP_going_South_1(nbf0_in_ly_2) = i_image
              else if(i_particleType(i_image).eq.2)then   !Forced Moving BP
                nbfm_in_ly_2_temp  = nbfm_in_ly_2_temp  + 1
                nb_in_ly_2 = nb_in_ly_2 + 1
                nbfm0_in_ly_2 = nbfm0_in_ly_2 + 1
                iBP_going_South_2(nbfm0_in_ly_2) = i_image
              else if(i_particleType(i_image).eq.3)then    !Free moving BP
                nbfreem_in_ly_2_temp  = nbfreem_in_ly_2_temp  + 1
                nb_in_ly_2 = nb_in_ly_2 + 1
                nbfreem0_in_ly_2 = nbfreem0_in_ly_2 + 1
                iBP_going_South_3(nbfreem0_in_ly_2) = i_image
              end if                
              iBP_going_South(nb_in_ly_2) = i_image
            else if(i_particleType(i_image).eq.4)then      !Fluid Particle
              nFP_in_ly_2  = nFP_in_ly_2   + 1
              iFP_going_South(nFP_in_ly_2) = i_image
            endif
          endif
        endif
c        !-- Debug Code------
c        if(rank_id.eq.0.and.itime.ge.itime_check)then
c          print*,'i_particleType(i_image) ',i_particleType(i_image)
c          print*
c        endif
      end do
      
      kk_highest_after_SR_toBelow = kk_highest_after_SR_toWest
     &                            + np_from_Above

      if(ndim.gt.2)then
        !Make numbers absolute in reference to start of local list
        !This makes the nomenclature consistent
        nbf_in_ly_2 = nbf_in_ly_2  + nbf_in_ly_2_temp
        nbfm_in_ly_2 = nbfm_in_ly_2 + nbf_in_ly_2_temp
     &                              + nbfm_in_ly_2_temp
        nbfreem_in_ly_2 = nbfreem_in_ly_2 + nbf_in_ly_2_temp
     &                                    + nbfm_in_ly_2_temp
     &                                    + nbfreem_in_ly_2_temp
        np_in_ly_2 = nFP_in_ly_2  + nb_in_ly_2
c        nbfm_in_ly_ncy_localminus1 = nbf_in_ly_ncy_localminus1 
c     &                            + nbfm_in_ly_ncy_localminus1
c        nbfreem_in_ly_ncy_localminus1 = nbfm_in_ly_ncy_localminus1 
c     &                             + nbfreem_in_ly_ncy_localminus1
c        np_in_ly_ncy_localminus1 = nFP_in_ly_ncy_localminus1
c     &                           + nb_in_ly_ncy_localminus1
        nb_going_North = nb_in_ly_ncy_localminus1
        np_going_North = np_in_ly_ncy_localminus1
        nb_going_South = nb_in_ly_2
        np_going_South = np_in_ly_2
      endif      
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
!       !-- Printout Check for Image
!       if(itime.ge.itime_check.and.rank_id.eq.irank_check)then
!       !if(itime.ge.0.and.rank_id.eq.2)then
!         print*
!         print*,'rank_id         ',rank_id
!         print*,'itime           ',itime
!         print*,'nbf_local       ',nbf_local
!         print*,'nbfm_local      ',nbfm_local
!         print*,'nbfreem_local   ',nbfreem_local
!         print*,'nb_local        ',nb_local
!         print*,'np_local        ',np_local
!         print*,'nbf_from_Below    ',nbf_from_Below
!         print*,'nbf_from_Above    ',nbf_from_Above
!         print*,'nbfm_from_Below   ',nbfm_from_Below
!         print*,'nbfm_from_Above   ',nbfm_from_Above
!         print*,'nbfreem_from_Below  ',nbfreem_from_Below
!         print*,'nbfreem_from_Above  ',nbfreem_from_Above
!         print*,'nb_from_Below    ',nb_from_Below
!         print*,'nb_from_Above    ',nb_from_Above
!         print*,'np_from_Below    ',np_from_Below
!         print*,'np_from_Above    ',np_from_Above
!         print*,'nb_from_East    ',nb_from_East
!         print*,'np_from_East    ',np_from_East
!         print*,'nbf_image_temp0      ',nbf_image_local
!         print*,'nbfm_image_temp0     ',nbfm_image_local
!         print*,'nbfreem_image_temp0  ',nb_image_local
!         print*,'nb_image_temp0       ',nb_image_local
!         print*,'np_image_temp0       ',np_image_local
!         print*,'nb_image_temp0       ',nb_image_temp
!         print*,'nFP_image_temp0      ',nFP_image_temp
!         print*,'nbf_image_local     ',nbf_image_local
!         print*,'nbfm_image_local    ',nbfm_image_local
!         print*,'nbfreem_image_local ',nb_image_local
!         print*,'nb_image_local      ',nb_image_local
!         print*,'np_image_local      ',np_image_local
!         print*,'nb_image_temp       ',nb_image_temp
!         print*,'nFP_image_temp      ',nFP_image_temp
!         if(ndim.gt.1)then
!           print*,'nbf_in_ly_2      ',nbf_in_ly_2
!           print*,'nbfm_in_ly_2     ',nbfm_in_ly_2
!           print*,'nbfreem_in_ly_2  ',nbfreem_in_ly_2
!           print*,'nb_going_South    ',nb_going_South
!           print*,'nb_going_North    ',nb_going_North
!           print*,'np_going_South    ',np_going_South
!           print*,'np_going_North    ',np_going_North
!           !print*,'nbf_going_Above      ',nbf_going_Above
!           !print*,'nbfm_going_Above     ',nbfm_going_Above
!           !print*,'nbfreem_going_Above  ',nbfreem_going_Above
!         endif
!         if(1.eq.1)then
!           !do ipcount=1,np_image_local
!           do ipcount=np_local + 1,np_image_local
!             if(ipcount.le.nbf_image_local)then
!               i = ip_index_BP_local_1(ipcount)
!             else if(ipcount.le.nbfm_image_local)then
!               i = ip_index_BP_local_2(ipcount-nbf_image_local)
!             else if(ipcount.le.nbfreem_image_local)then
!               i = ip_index_BP_local_3(ipcount-nbfm_image_local)
!             else
!               i = ip_index_FP_local(ipcount-nb_image_local)
!             end if
! c            write(*,494),'ipcount -> i, xp, zp ',
! c     &                  ipcount,i,xp(i),zp(i)
!             write(*,494),'ipcount -> i, xp, yp, zp',
!      &                  ipcount,i,xp(i),yp(i),zp(i)
!           end do
!         end if
!         !call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
!       end if
! 494   format(1(a21,'  '),2(i6,'  '),3(f12.6,' '))
! 495   format(2(i6,'  '),8(f10.6,' '))

c      call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
      
c      !-- Debug Code------
c      if(1.eq.2.and.rank_id.eq.1.and.itime.ge.itime_check)then
c        print*
c        print*,'Image Normals, end of SendRecv_Data, rank_id ',rank_id
c        print*,
c     &' i    xp     zp     xnb     znb   deltaptb(i,1)   deltaptb(i,2)'
c        do ipcount = 1, nb_image_local 
c          i = ip_index_BP_local(ipcount)
c          write(*,495),ipcount,i,xp(i),zp(i),xnb(i),znb(i),
c     &               xtb(i),ztb(i),deltaptb(i,1),deltaptb(i,2)
c        end do
c        print*
c      end if
      
      !stop
      
      end subroutine
