c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine ac		!ac_KGC_3D.f
c
      include 'common.3D'
      
      itime_check = 10e8     !0    !10e8   !0    !
      i_rank_check = 0
      i_ParticleCheck = 1831
c
c  ...  store useful arrays
c
      icall=0     !Calculate normalising kernels
      i_Shepard_typeMin = 3

      !- MPI Version -
      if(num_FB.gt.0)then
        if(iBC.eq.1)then
          nstart_ac = nbfm_local+1
        else
          nstart_ac = nstart  !=1
        endif
      else
        nstart_ac = nstart
      endif
      do ipcount=nstart_ac,np_image_local
         if(ipcount.le.nbf_image_local)then
           i = ip_index_BP_local_1(ipcount)
         else if(ipcount.le.nbfm_image_local)then
           i = ip_index_BP_local_2(ipcount-nbf_image_local)
         else if(ipcount.le.nbfreem_image_local)then
           i = ip_index_BP_local_3(ipcount-nbfm_image_local)
         else
           i = ip_index_FP_local(ipcount-nb_image_local)
         end if

      enddo
      do i=1,npar
c       -- Kernel ReNormalisation ARRAYS --
     
        aM_a11(i)=0.    !Mi(1,1)
        aM_a12(i)=0.    !Mi(1,2)
        aM_a13(i)=0.    !Mi(1,3)
        aM_a21(i)=0.    !Mi(2,1)
        aM_a22(i)=0.    !Mi(2,2)
        aM_a23(i)=0.    !Mi(2,3)
        aM_a33(i)=0.    !Mi(3,3)
        aL_a11(i)=0.    !Li(1,1)
        aL_a12(i)=0.    !Li(1,2)
        aL_a13(i)=0.    !Li(1,3)
        aL_a21(i)=0.    !Li(2,1)
        aL_a22(i)=0.    !Li(2,2)
        aL_a23(i)=0.    !Li(2,3)
        aL_a33(i)=0.    !Li(3,3)


      enddo
      
      !- MPI Version -
      if(iBC.eq.1)then
        do ipcount=1,nb_image_local
           i = ip_index_BP_local(ipcount)
c          -- Kernel ReNormalisation ARRAYS --
     
           aM_a11(i)=0.    !Mi(1,1)
           aM_a12(i)=0.    !Mi(1,2)
           aM_a13(i)=0.    !Mi(1,3)
           aM_a21(i)=0.    !Mi(2,1)
           aM_a22(i)=0.    !Mi(2,2)
           aM_a23(i)=0.    !Mi(2,3)
           aM_a33(i)=0.    !Mi(3,3)
           aL_a11(i)=0.    !Li(1,1)
           aL_a12(i)=0.    !Li(1,2)
           aL_a13(i)=0.    !Li(1,3)
           aL_a21(i)=0.    !Li(2,1)
           aL_a22(i)=0.    !Li(2,2)
           aL_a23(i)=0.    !Li(2,3)
           aL_a33(i)=0.    !Li(3,3)

        enddo
      endif

      !-- X-Direction MPI Topology Periodicity --
      if(iCartTop_periodicity(1).or.
     &   (rank_idx.gt.0.and.rank_idx.lt.n_procs_x-1))then
        ncx_start = 2
        ncx_finish = ncx_local - 1
      else if(rank_idx.eq.0)then
        ncx_start = 1
        ncx_finish = ncx_local - 1
      else if(rank_idx.eq.n_procs_x-1)then
        ncx_start = 2
        ncx_finish = ncx_local
      else !Just incase-error catching
        ncx_start = 2
        ncx_finish = ncx_local
        print*
        print*,'ac.f'
        print*,'itime ',itime
        print*,'rank_id ',rank_id
        print*,'rank_idx, rank_idy, rank_idz ',
     &          rank_idx, rank_idy, rank_idz
        print*,'ncx_start = ',ncx_start
        print*,'ncx_finish= ',ncx_finish
        stop
      end if
      !-- Y-Direction MPI Topology Periodicity --
      if(iCartTop_periodicity(2).or.
     &   (rank_idy.gt.0.and.rank_idy.lt.n_procs_y-1))then
        ncy_start = 2
        ncy_finish = ncy_local - 1
      else if(rank_idy.eq.0)then
        ncy_start = 1
        ncy_finish = ncy_local - 1
      else if(rank_idy.eq.n_procs_y-1)then
        ncy_start = 2
        ncy_finish = ncy_local
      else !Just incase-error catching
        ncy_start = 2
        ncy_finish = ncy_local
        print*
        print*,'ac.f'
        print*,'itime ',itime
        print*,'rank_id ',rank_id
        print*,'rank_idx, rank_idy, rank_idz ',
     &          rank_idx, rank_idy, rank_idz
        print*,'ncy_start = ',ncy_start
        print*,'ncy_finish= ',ncy_finish
        stop
      end if
      !-- Z-Direction MPI Topology Periodicity --
      if(iCartTop_periodicity(3).or.
     &   (rank_idz.gt.0.and.rank_idz.lt.n_procs_z-1))then
        ncz_start = 2
        ncz_finish = ncz_local - 1
      else if(rank_idz.eq.0)then
        ncz_start = 1
        ncz_finish = ncz_local - 1
      else if(rank_idz.eq.n_procs_z-1)then
        ncz_start = 2
        ncz_finish = ncz_local
      else if(ndim.eq.2.and.n_procs_x.eq.1)then
        if(rank_idz.eq.0)then
          ncz_start = 1
          ncz_finish = ncz_local - 1
        elseif(rank_idz.lt.n_procs_z-1)then
          ncz_start = 2
          ncz_finish = ncz_local-1
        else
          ncz_start = 2
          ncz_finish = ncz_local
        endif
      else !Just incase-error catching
        ncz_start = 2
        ncz_finish = ncz_local
        print*
        print*,'ERROR in ac_MPI_2D.f'
        print*,'itime ',itime
        print*,'rank_id ',rank_id
        print*,'rank_idx, rank_idy, rank_idz ',
     &          rank_idx, rank_idy, rank_idz
        print*,'ncz_start = ',ncz_start
        print*,'ncz_finish= ',ncz_finish
        stop
      end if
c      ncy_start = 1
c      ncy_finish = ncy_local
c      ncz_start = 1
c      ncz_finish = ncz_local
      lz2_min = ncz_start + 1  !2
      ly2_min = ncy_start + 1  !2      
       
       
c      !- Diagnostic Info -
c      if(itime.ge.itime_check.and.rank_id.eq.1)then
c        print*
c        print*,'In AC.f before pre_celij calls'
c        i =  i_ParticleCheck
c        print*,'i, xp, zp ',i,xp(i),zp(i)
c        print*,'up, wp ',up(i),wp(i)
c        print*,'ax, az ',ax(i),az(i)
c        print*,'ar     ',ar(i)
c        print*,'rhop(i) ',rhop(i)
c        print*,'p(i)    ',p(i)
c        print*,'sum_wab(i) ',sum_wab(i)
c        print*
c      end if
       

       do kind_p1=1,2
       ini_kind_p2=mod(kind_p1,2)+1  !Gives the alternative value to kind_p2 of kind_p1
              
       do lz=ncz_start,ncz_finish
       do ly=ncy_start,ncy_finish
       do lx=ncx_start,ncx_finish
       
         j1 = lx + (ly-1)*ncx_local + (lz-1)*nsheet_local

         if(nc(j1,kind_p1).gt.0) then
c                            ! if the cell is not empty, then
c                            ! loop over it and over neighboring
c                            ! cells

c         print*,'kind_p1, lx, lz, j1 ',kind_p1,lx, lz, j1

c         !-- Cells in the same XY sheet --
          lx2 = lx+1
          ly2 = ly+1
          lz2 = lz+1

          !- Special correction for MPI Cartesian Topology -
          lx2t = lx2
          ly2t = ly2
          lz2t = lz2
          if(iCartTop_periodicity(1))then
            lx2t = lx2t+1   !Add one to activate periodicity correction 
          endif
          if(iCartTop_periodicity(2))then
            ly2t = ly2t+1   !Add one to activate periodicity correction 
          endif
          if(iCartTop_periodicity(3))then
            lz2t = lz2t+1   !Add one to activate periodicity correction
          endif
          !------------------------------------------------
          
          !- EAST -
          if(lx2.le.ncx_local)then
            call pre_celij(j1,j1+1,kind_p1,ini_kind_p2,
     &                             lx2t,ly2t,lz2t,1)     !East
          end if

          !- NORTH -
          if(ly2.le.ncy_local)then
            call pre_celij(j1,j1+ncx_local,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,3)     !North
          !- NORTH-EAST -  
            if(lx2.le.ncx_local)then 
            call pre_celij(j1,j1+ncall2,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,5)     !North-East
            endif
          endif

          !- SOUTH-EAST -
          if(lx2.le.ncx_local.and.ly2.gt.ly2_min)then
            call pre_celij(j1,j1+ncall1,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,9)     !South-East
          endif

          !-- XY Sheet Above: UP --
          lz2=lz+1
          if(lz2.le.ncz_local)then
            call pre_celij(j1,j1+nsheet_local,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,13)    !Up only
            !- EAST -
            if(lx2.le.ncx_local)then
              call pre_celij(j1,j1+ncall4,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,14)    !Up & East
            !- NORTH-EAST -
              if(ly2.le.ncy_local)then
              call pre_celij(j1,j1+ncall7,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,20)    !Up & North-East
              endif
            !- SOUTH-EAST -
              if(ly2.gt.2)then
              call pre_celij(j1,j1+ncall10,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,24)    !Up & South-East
              endif
            end if

            !- NORTH -
            if(ly2.le.ncy_local)then
              call pre_celij(j1,j1+ncall5,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,16)    !Up & North
            end if

            !- SOUTH -
            if(ly2.gt.ly2_min) then
              call pre_celij(j1,j1+ncall8,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,18)    !Up & South
            end if


          endif   !End of:  if(lz2.le.ncz_local)then

          !-- XY Sheet Below: DOWN --
          lz2=lz+1
          if(lz2.gt.lz2_min)then   !if(lz.gt.1)then

            !- EAST -
            if(lx2.le.ncx_local)then
              call pre_celij(j1,j1+ncall3,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,28)    !Down & East
            !- NORTH-EAST -                          
              if(ly2.le.ncy_local)then
              call pre_celij(j1,j1+ncall6,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,30)    !Down & North-East
              endif
            !- SOUTH-EAST -
              if(ly2.gt.ly2_min)then
              call pre_celij(j1,j1+ncall9,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,34)    !Down & South-East
              endif
            end if

          end if   !End of:  if(lz2.eq.2)then


          !-- PERIODIC CALLS ---
          
          !- Z-periodicity Info - 
          if(i_periodicOBs(3).eq.1)then
            ncall_zdiff_up   = -nct_local
            ncall_zdiff_down =  nct_local
            lz2_max = ncz_local + 1
            lz2_min = 0
          else
            ncall_zdiff_up   =  0
            ncall_zdiff_down =  0
            lz2_max = ncz_local
            lz2_min = 1
          endif
          
          !-- Cells in the same XY sheet --
          !- X-Dir Periodic -
          if(i_periodicOBs(1).eq.1.and.lx.eq.ncx_local)then
            call pre_celij(j1,j1+1-ncx_local,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,2)                        !East        Periodic X-Dir only
            if(ly2.le.ncy_local)then
              call pre_celij(j1,j1+ncall2-ncx_local,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,6)                        !North-East  Periodic X-Dir only
            endif
            if(ly2.gt.2)then
              call pre_celij(j1,j1+ncall1-ncx_local,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,10)                       !South-East  Periodic X-Dir only
            endif
            if(i_periodicOBs(2).eq.1)then
              if(ly.eq.ncy_local)then
                call pre_celij
     &                (j1,j1+ncall2-ncx_local-nsheet_local,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,7)                        !North-East  Periodic X-Dir & Y-Dir
              else if(ly.eq.1)then
                call pre_celij
     &                (j1,j1+ncall1-ncx_local+nsheet_local,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,11)                       !South-East  Periodic X-Dir & Y-Dir
              endif
            endif
          endif
          !- Y-Dir Periodic Only -
          if(i_periodicOBs(2).eq.1)then 
            if(ly.eq.ncy_local)then
              call pre_celij(j1,j1+ncx_local-nsheet_local,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,4)                        !North       Periodic Y-Dir only
              if(lx2.le.ncx_local)then
                call pre_celij(j1,j1+ncall2-nsheet_local,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,8)                        !North-East  Periodic Y-Dir only
              end if
            endif
            if(ly2.eq.2.and.lx2.le.ncx_local)then
              call pre_celij(j1,j1+ncall1+nsheet_local,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,12)                       !South-East  Periodic Y-Dir only
            end if
          end if
          !-- XY Sheet Above: UP --
          lz2=lz+1
          if(lz2.le.lz2_max)then
            !- X-Dir Periodic -
            if(i_periodicOBs(1).eq.1.and.lx.eq.ncx_local)then
              call pre_celij
     &                (j1,j1+ncall4-ncx_local+ncall_zdiff_up,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,15)                       !Up & East        Periodic X-Dir only
              if(ly2.le.ncy_local)then
                call pre_celij
     &                (j1,j1+ncall7-ncx_local+ncall_zdiff_up,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,21)                       !Up & North-East  Periodic X-Dir only
              endif
              if(ly2.gt.2)then
                call pre_celij
     &                (j1,j1+ncall10-ncx_local+ncall_zdiff_up,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,25)                       !Up & South-East  Periodic X-Dir only
              endif
              if(i_periodicOBs(2).eq.1)then
                if(ly.eq.ncy_local)then
                  call pre_celij
     &                (j1,j1+ncall7-nsheet_local+ncall_zdiff_up,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,22)                       !Up & North-East  Periodic X-Dir & Y-Dir
                else if(ly.eq.1)then
                  call pre_celij(j1,
     &                 j1+ncall10-ncx_local+nsheet_local+ncall_zdiff_up,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,26)                       !Up & South-East  Periodic X-Dir & Y-Dir
                end if
              endif
            endif
            !- Y-Dir Periodic Only -
            if(i_periodicOBs(2).eq.1)then
              if(ly.eq.ncy_local)then 
                call pre_celij
     &                (j1,j1+ncall5-nsheet_local+ncall_zdiff_up,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,17)                       !Up & North       Periodic Y-Dir only
                if(lx2.le.ncx_local)then
                  call pre_celij
     &                (j1,j1+ncall7-nsheet_local+ncall_zdiff_up,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,23)                       !Up & North-East  Periodic Y-Dir only
                endif
              endif
              if(ly.eq.1)then 
                call pre_celij
     &                (j1,j1+ncall8+nsheet_local+ncall_zdiff_up,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,19)                       !Up & South       Periodic Y-Dir only
              endif
              if(ly2.eq.2.and.lx2.le.ncx_local)then
                call pre_celij
     &                (j1,j1+ncall10+nsheet_local+ncall_zdiff_up,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,27)                       !Up & South-East  Periodic Y-Dir only
              end if
            endif
          endif   !End of: if(lz2.le.ncz_local)then
          
          !-- XY Sheet Below: DOWN --
          lz2=lz+1
          if(lz.gt.lz2_min)then
            !- X-Dir Periodic -
            if(i_periodicOBs(1).eq.1.and.lx.eq.ncx_local)then
              call pre_celij
     &                (j1,j1+ncall3-ncx_local+ncall_zdiff_down,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,29)                       !Down & East        Periodic X-Dir only
              if(ly2.le.ncy_local)then
                call pre_celij
     &                (j1,j1+ncall6-ncx_local+ncall_zdiff_down,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,31)                       !Down & North-East  Periodic X-Dir only
              endif
              if(ly2.gt.2)then
                call pre_celij
     &                (j1,j1+ncall9-ncx_local+ncall_zdiff_down,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,35)                       !Down & South-East  Periodic X-Dir only
              endif
              if(i_periodicOBs(2).eq.1)then
                if(ly.eq.ncy_local)then
                  call pre_celij
     &                (j1,j1+ncall6-nsheet_local+ncall_zdiff_down,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,32)                       !Down & North-East  Periodic X-Dir & Y-Dir
                else if(ly.eq.1)then
                 call pre_celij(j1,
     &                j1+ncall9-ncx_local+nsheet_local+ncall_zdiff_down,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,36)                       !Down & South-East  Periodic X-Dir & Y-Dir
                end if
              end if
            end if
            !- Y-Dir Periodic Only -
            if(i_periodicOBs(2).eq.1.and.lx2.le.ncx_local)then
              if(ly.eq.ncy_local)then
                call pre_celij
     &                (j1,j1+ncall6-nsheet_local+ncall_zdiff_down,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,33)    !Down & North-East  Periodic Y-Dir only
              endif
              if(ly2.eq.2)then
                call pre_celij
     &                (j1,j1+ncall9+nsheet_local+ncall_zdiff_down,
     &                 kind_p1,ini_kind_p2,lx2,ly2,lz2,37)  !Down & South-East  Periodic Y-Dir only
              end if
            endif
          
          endif    !End of:  if(lz.gt.1)then

        endif  !End of: if(nc(j1,kind_p1).gt.0)then

      enddo
      enddo
      enddo


      !- Extra SOUTH calls for Y-dir Cartesian MPI Topology -
      if(iCartTop_periodicity(2).or.
     &   (rank_idy.lt.n_procs_y-1.and.n_procs_y.gt.1))then
        if(iCartTop_periodicity(3).or.
     &   (n_procs_z.gt.1.and.rank_idz.lt.n_procs_z-1))then
         ncz_finish_2 = ncz_finish + 1
        else
         ncz_finish_2 = ncz_finish
        endif
        ly=ncy_finish + 1
        do lx=ncx_start,ncx_finish      
        do lz=ncz_start,ncz_finish_2
          j1 = lx + (ly-1)*ncx_local + (lz-1)*nsheet_local
          if(nc(j1,kind_p1).gt.0) then
c           !-- Cells in the same XY sheet --
            lx2 = lx+1
            ly2 = ly+1
            lz2 = lz+1
            !- Special correction for MPI Cartesian Topology -
            lx2t = lx2
            ly2t = ly2
            lz2t = lz2       
            if(iCartTop_periodicity(1))then
              lx2t = lx2t+1   !Add one to activate periodicity correction 
            endif
            if(iCartTop_periodicity(2))then
              ly2t = 0   !Set to zero to activate periodicity correction for this special case
            endif
            if(iCartTop_periodicity(3))then
              lz2t = lz2t+1   !Add one to activate periodicity correction
            endif
            !- SOUTH-EAST -
            if(ly2.gt.ly2_min.and.lx2.le.ncx_local
     &                       .and.lz .lt.ncz_local)then
              call pre_celij(j1,j1+ncall1,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,41)     !South-East
            endif
            !-- XY Sheet Above: UP --
            if(lz2.le.ncz_local)then
              if(lx2.le.ncx_local)then
              !- SOUTH-EAST -
                if(ly2.gt.ly2_min)then
                  call pre_celij(j1,j1+ncall10,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,42)    !Up & South-East
                endif
              end if
              !- SOUTH -
              if(ly2.gt.ly2_min) then
                call pre_celij(j1,j1+ncall8,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,43)    !Up & South
              end if
            endif   !End of:  if(lz2.le.ncz_local)then
            !if(ndim.eq.3)then
              if(lx2.le.ncx_local)then
                !- SOUTH-EAST -
                if(ly2.gt.ly2_min.and.lz2.gt.lz2_minn)then
                  call pre_celij(j1,j1+ncall9,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,44)    !Down & South-East
                endif
              endif
            !endif
          endif
        enddo
        enddo
      endif

      !- Extra DOWN & EAST for Z-dir Cartesian MPI Topology -
      if(iCartTop_periodicity(3).or.
     &   (n_procs_z.gt.1.and.rank_idz.lt.n_procs_z-1))then
        lz=ncz_finish + 1
        do lx=ncx_start,ncx_finish      
        do ly=ncy_start,ncy_finish      
          j1 = lx + (ly-1)*ncx_local + (lz-1)*nsheet_local
          if(nc(j1,kind_p1).gt.0) then
c           !-- Cells in the same XY sheet --
            lx2 = lx+1
            ly2 = ly+1
            lz2 = lz+1
            !- Special correction for MPI Cartesian Topology -
            lx2t = lx2
            ly2t = ly2
            lz2t = lz2       
            if(iCartTop_periodicity(1))then
              lx2t = lx2t+1   !Add one to activate periodicity correction 
            endif
            if(iCartTop_periodicity(2))then
              ly2t = ly2t+1   !Add one to activate periodicity correction 
            endif
            if(iCartTop_periodicity(3))then
              lz2t = 0   !Set to zero to activate periodicity correction for this special case
            endif
            if(lx2.le.ncx_local)then
              call pre_celij(j1,j1+ncall3,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,38)    !Down & East
            !- NORTH-EAST -                          
              if(ly2.le.ncy_local)then
              call pre_celij(j1,j1+ncall6,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,39)    !Down & North-East
              endif
              if(ndim.gt.1)then
                !- SOUTH-EAST -
                if(ly2.gt.ly2_min.and.lz2.gt.lz2_min)then
                  call pre_celij(j1,j1+ncall9,
     &                 kind_p1,ini_kind_p2,lx2t,ly2t,lz2t,40)    !Down & South-East
                endif
              endif
            end if
          endif
        enddo
        enddo
      endif
              
       do j1x = ncx_start, ncx_finish
       do j1y = ncy_start, ncy_finish
       do j1z = ncz_start, ncz_finish
         j1 = j1x + (j1y-1)*ncx_local + (j1z-1)*nsheet_local
           if(nc(j1,kind_p1).gt.0)
     +       call pre_self(j1,kind_p1,ini_kind_p2)
       enddo
       enddo
       enddo
              
       enddo   !End of:  do kind_p1=1,2
       
       
      !SendRecv all acceleration summations back to origin processors
      if(i_call_NorthSouth.eq.1) call update_KGC_Summations_fromSouth
      if(i_call_UpDown    .eq.1) call update_KGC_Summations_fromBelow
      call update_KGC_Summations_fromWest
                     
      !-- Invert gradient correction Matrix --

      do ipcount=nstart_ac,np_local
         call ipcount_to_i(ipcount,i)
         if(i_particleType(i).eq.4)then   !if (i.gt.nb.and.iflag(i).gt.0) then !Only for Fluid particles
                                                !inside the limits
             aM_a12(i)=0.5*(aM_a12(i)+aM_a21(i)) ! M should be symmetric
             aM_a21(i)=aM_a12(i)    
             aM_a13(i)=0.5*(aM_a13(i)+aM_a31(i)) ! M should be symmetric
             aM_a31(i)=aM_a13(i)
             aM_a23(i)=0.5*(aM_a23(i)+aM_a32(i)) ! M should be symmetric
             aM_a32(i)=aM_a23(i)                             
             detM=aM_a11(i)*aM_a22(i)*aM_a33(i)+
     +            aM_a12(i)*aM_a23(i)*aM_a31(i)+
     +            aM_a13(i)*aM_a21(i)*aM_a32(i)-
     +            aM_a31(i)*aM_a22(i)*aM_a13(i)-
     +            aM_a11(i)*aM_a32(i)*aM_a23(i)-
     +            aM_a21(i)*aM_a12(i)*aM_a33(i) !Determinant of matrix M det(M)

             control=0.0
             if(abs(detM).gt.0.001.and.abs(aM_a11(i)).gt.control
     +         .and.abs(aM_a22(i)).gt.control
     +         .and.abs(aM_a33(i)).gt.control) then  !Only for "well conditioned" matrices  
       one_over_detM = 1.0/detM

	!inverse matriz coefficients
       aL_a11(i)=(aM_a22(i)*aM_a33(i)-aM_a23(i)*aM_a32(i))*one_over_detM  
       aL_a21(i)=(aM_a31(i)*aM_a23(i)-aM_a21(i)*aM_a33(i))*one_over_detM  
       aL_a31(i)=(aM_a21(i)*aM_a32(i)-aM_a22(i)*aM_a31(i))*one_over_detM  
       aL_a12(i)=(aM_a13(i)*aM_a32(i)-aM_a12(i)*aM_a33(i))*one_over_detM  
       aL_a22(i)=(aM_a11(i)*aM_a33(i)-aM_a13(i)*aM_a31(i))*one_over_detM  
       aL_a32(i)=(aM_a12(i)*aM_a31(i)-aM_a11(i)*aM_a32(i))*one_over_detM  
       aL_a13(i)=(aM_a12(i)*aM_a23(i)-aM_a13(i)*aM_a22(i))*one_over_detM  
       aL_a23(i)=(aM_a13(i)*aM_a21(i)-aM_a11(i)*aM_a23(i))*one_over_detM  
       aL_a33(i)=(aM_a11(i)*aM_a22(i)-aM_a12(i)*aM_a21(i))*one_over_detM  
c	         if_cor(i)=1
c             else    !No correction
               aL_a11(i) = 1.
               aL_a12(i) = 0.
               aL_a13(i) = 0.
               aL_a21(i) = 0.
               aL_a22(i) = 1.
               aL_a23(i) = 0.
               aL_a31(i) = 0.
               aL_a32(i) = 0.
               aL_a33(i) = 1.
c	         if_cor(i)=0
             endif
           else !No correction
               aL_a11(i) = 1.
               aL_a12(i) = 0.
               aL_a13(i) = 0.
               aL_a21(i) = 0.
               aL_a22(i) = 1.
               aL_a23(i) = 0.
               aL_a31(i) = 0.
               aL_a32(i) = 0.
               aL_a33(i) = 1.
c	        if_cor(i)=0
           endif

      enddo

      call SendRecv_KGC_Matrices_toWest
      if(i_call_UpDown    .eq.1) call SendRecv_KGC_Matrices_toBelow
      if(i_call_NorthSouth.eq.1) call SendRecv_KGC_Matrices_toSouth  !3-D only

      call ac_main

      return
      end
      
      
