c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine densityFilter
c
      include 'common.3D'

!      !- Diagnostic Info -
!       itime_check = 10e8   !0    !10e8   !0    !
!       i_rank_check = 0
!       i_ParticleCheck = 23197
!       if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
!         rhop_old = rhop(i_ParticleCheck)
!         p_old = p(i_ParticleCheck)
!       endif
       
      i_Shepard_typeMin = 3
      nstart_Shepard = nbp1_local   !nstart

      call ac_Shepard

!      !- Diagnostic Info -
!       if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
!         i =  i_ParticleCheck
!         sum_wab_check = sum_wab(i)
!       endif

      do ipcount=nstart_Shepard,np_local
         i = ip_index_FP_local(ipcount-nb_local)
         sum_wab(i) = sum_wab(i) + adh*pm(i)/rhop(i)  !self contribution
         rhop_sum(i) = rhop_sum(i) + adh*pm(i)  !self contribution
         rhop(i) = rhop_sum(i)/sum_wab(i)
         pVol(i) = pm(i)/rhop(i)
         call equation_of_state(rhop(i),TEp(i),p(i),cs(i))
      enddo

      call SendRecv_filteredDensities_toWest
      if(i_call_UpDown    .eq.1) call SendRecv_filteredDensities_toBelow
      if(i_call_NorthSouth.eq.1) call SendRecv_filteredDensities_toSouth  !3-D only

!      !- Diagnostic Info -
!        if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
!         print*
!         print*,'In shepard.f,itime = ',itime
!         i =  i_ParticleCheck
!         print*,'i, xp, yp, zp ',i,xp(i),yp(i),zp(i)
!         print*,'rhop_old, p_old ',rhop_old, p_old
!         print*,'rhop(i)  ',rhop(i)
!         print*,'p(i)    ',p(i)
!         print*,'sum_wab_check  ',sum_wab_check 
!         print*,'adh*pm(i)/rhop(i) ',adh*pm(i)/rhop(i)
!         print*,'sum_wab(i)  ',sum_wab(i)
!         print*,'rhop_sum(i) ',rhop_sum(i)
!         print*,'pVol(i) ',pVol(i)
!         print*,'nb_local ',nb_local
!         print*,'np_local ',np_local
!         print*
!         !read(*,*)
!         if(itime.gt.0)stop
!        end if
       
       return
       end

