c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine getdata

      logical ltemp1,ltemp2,ltemp3
      
      include 'common.3D'

      real(kind=kind_XYZ) xp_temp,yp_temp,zp_temp
      real(kind=kind_XYZ) BP_temp1,BP_temp2,BP_temp3


      character supp_ini*4,name_ini*40,normals_ini*40,BPs_ptr*40
      character (LEN=40) :: paddle_fileName, MovingObjectsFile
      
      integer nbf_start_global(n_procs_max)
      integer nb_finish_global(n_procs_max)
      integer nbf_start_global_temp(n_procs_max)
      integer iBP_Pointer_Info_Type

      !- Variables for updating normal info on Root processor -
      real(kind=kind_XYZ) xp_togoto_Root(nb_max),yp_togoto_Root(nb_max)
      real(kind=kind_XYZ) zp_togoto_Root(nb_max)      
      integer i_BPP_togoto_Root(nb_max)


c
      open(11,file='INDAT')
 
      read(11,*)i_kernel
      read(11,*)i_algorithm
      read(11,*)i_densityFilter
      read(11,*)i_viscos
      read(11,*)iBC              !BC
      read(11,*)i_periodicOBs(1)
      read(11,*)i_periodicOBs(2)
      read(11,*)i_periodicOBs(3)
      read(11,*)lattice
      read(11,*)i_EoS
      read(11,*)h_SWL 
      read(11,*)B
      read(11,*)gamma
      read(11,*)coef
      read(11,*)eps   ! epsilon XSPH
      read(11,*)rho0
      read(11,*)viscos_val
      read(11,*)visc_wall
      read(11,*)vlx    !Dimensions of container box
      read(11,*)vly
      read(11,*)vlz
      read(11,*)dx0
      read(11,*)dy0     ! dy=0  for 2D
      read(11,*)dz0
      read(11,*)h
      read(11,*)np	
      read(11,*)nb
      read(11,*)nbf
      read(11,*)ivar_dt
      read(11,*) dt
      read(11,*)tmax     ! End of the run(seconds)
      read(11,*)out      ! output every out seconds
      read(11,*)trec_ini ! Initial output 
      read(11,*)dtrec_det !Detailed recording
      read(11,*)t_sta_det
      read(11,*)t_end_det 
      read(11,*)i_restartRun
      read(11,*)CFL_number
      read(11,*)TE0
      read(11,*)i_kernelcorrection
      read(11,*)iRiemannSolver 
      read(11,*)iTVD
      read(11,*)beta_lim
      read(11,*)i_vort
      read(11,*)ndt_VerletPerform
      read(11,*)ndt_FilterPerform
      read(11,*)ndt_DBCPerform
 
          
      if(rank_id.eq.0)then
        print*
        print*,'Periodicity '
        print*,'i_periodicOBs'
        print*,'X-Direction: ',i_periodicOBs(1)
        print*,'Y-Direction: ',i_periodicOBs(2)
        print*,'Z-Direction: ',i_periodicOBs(3)
        print*
      endif
      
      !-- Checking for periodicity errors --
      if(i_periodicOBs(1).eq.1.and.iCartTop_periodicity(1))then
        print*
        print*,'ERROR in getdata.f'
        print*,'i_periodicOBs(1) is activated in X-Direction'
        print*,'in addition to iCartTop_periodicity(1)'
        print*,'X-Direction: '
        print*,'i_periodicOBs(1)        = ',i_periodicOBs(1)
        print*,'iCartTop_periodicity(1) = ',iCartTop_periodicity(1)
        print*    
        print*,'Only one periodicity can be activated at any one time.'    
        print*,'You need to change one of these values.'    
        print* 
        stop   
      end if
      if(i_periodicOBs(2).eq.1.and.iCartTop_periodicity(2))then
        print*
        print*,'ERROR in getdata.f'
        print*,'i_periodicOBs(2) is activated in Y-Direction'
        print*,'in addition to iCartTop_periodicity(2)'
        print*,'Y-Direction: '
        print*,'i_periodicOBs(2)        = ',i_periodicOBs(2)
        print*,'iCartTop_periodicity(2) = ',iCartTop_periodicity(2)
        print*    
        print*,'Only one periodicity can be activated at any one time.'    
        print*,'You need to change one of these values.'    
        print* 
        stop   
      end if
      if(i_periodicOBs(3).eq.1.and.iCartTop_periodicity(3))then
        print*
        print*,'ERROR in getdata.f'
        print*,'i_periodicOBs(3) is activated in Z-Direction'
        print*,'in addition to iCartTop_periodicity(3)'
        print*,'Z-Direction: '
        print*,'i_periodicOBs(3)        = ',i_periodicOBs(3)
        print*,'iCartTop_periodicity(3) = ',iCartTop_periodicity(3)
        print*    
        print*,'Only one periodicity can be activated at any one time.'    
        print*,'You need to change one of these values.'    
        print* 
        stop   
      end if
       
      if (nb .ge. nb_max ) then
        write(*,*) 'Number of Boundary particles exceeds'
        write(*,*) 'nb_max in common!'
        print*,'rank_id  ',rank_id
        print*,'np_local ',np_local
        print*,'nb       ',nb
        print*,'nb_max   ',nb_max
        print*
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      endif
      
      if(rank_id.eq.0)then
        write(*,*) 'np, nb, nbf, ivar_dt, dt ',np,nb,nbf,ivar_dt,dt
        write(*,*) 'h = ',h
        write(*,*) '(dx0,dy0,dz0)=',dx0,dy0,dz0
        write(*,*) B,viscos_val,gamma, rho0
        write(*,*) 'Still Water Depth h_SWL = ',h_SWL
        write(*,*) 'CFL_number = ',CFL_number
        if(iTVD.eq.1)write(*,*) 'Using TVD, beta_lim =  ',beta_lim
      endif

       
      close(11)
       
c      ----  MPI SECTION ----
      !--- Define geometry parameters for partitioning ---
      open(11,file='MPI_container_Limits.txt')
        read(11,*) ltemp1,ltemp2,ltemp3
        read(11,*) xb_min,xb_max
        read(11,*) yb_min,yb_max
        read(11,*) zb_min,zb_max
        read(11,*) i_MPI_Adapt, nFP_difference_max,
     &             n_itime_Adapt, n_ini_Adapt
        read(11,*) nbfm
        read(11,*) MPI_CartDims
      close(11)
      if(rank_id.eq.0)then
        print*
        print*,'File MPI_container_Limits.txt read'
        print*,'xb_min, xb_max ',xb_min, xb_max
        print*,'yb_min, yb_max ',yb_min, yb_max
        print*,'zb_min, zb_max ',zb_min, zb_max
        print*,'nbfm ',nbfm
        if(i_MPI_Adapt.eq.1)then
          print*
          print*,'Using Adaptive MPI Scheme'
          print*,'i_MPI_Adapt ',i_MPI_Adapt
          print*,'nFP_difference_max, n_itime_Adapt ', 
     &            nFP_difference_max, n_itime_Adapt
        else
          print*
          print*,'NOT using Adaptive MPI Scheme'
          print*,'i_MPI_Adapt ',i_MPI_Adapt
        endif
        print*
      endif

      !-- X-Dir lengths --
      xmin_global = xb_min               !real(xb_min_double)
      xmax_global = xb_max               !real(xb_max_double)
      xmin_globalDouble = dble(xb_min)   !xb_min_double
      xmax_globalDouble = dble(xb_max)   !xb_max_double
      xlength_rank = (xmax_global - xmin_global)/real(n_procs_x)
      xlength_rankDouble = (xmax_globalDouble - xmin_globalDouble)
     &                     /dble(n_procs_x)
      !-- Y-Dir lengths --
      ymin_global = yb_min               !real(yb_min_double)
      ymax_global = yb_max               !real(yb_max_double)
      ymin_globalDouble = dble(yb_min)   !yb_min_double
      ymax_globalDouble = dble(zb_max)   !yb_max_double
      ylength_rank = (ymax_global - ymin_global)/real(n_procs_y)
      ylength_rankDouble = (ymax_globalDouble - ymin_globalDouble)
     &                     /dble(n_procs_y)
      !-- Z-Dir lengths --
      zmin_global = zb_min               !real(zb_min_double)
      zmax_global = zb_max               !real(zb_max_double)
      zmin_globalDouble = dble(zb_min)   !zb_min_double
      zmax_globalDouble = dble(zb_max)   !zb_max_double
      zlength_rank = (zmax_global - zmin_global)/real(n_procs_z)
      zlength_rankDouble = (zmax_globalDouble - zmin_globalDouble)
     &                     /dble(n_procs_z)

      !-- resize to be an integral number of 2h's --
      one_over_2h_temp = 1.0/(2.0*h)

      !-- X-dir rank length --
      xlength_rank = real(int(xlength_rank*one_over_2h_temp) + 1)*2.0*h
      xlength_rankDouble = dble(int(xlength_rankDouble/(2d0*h))+1)*2d0*h

      xmin_rank = xmin_global + real(rank_idx  ) * xlength_rank
      xmax_rank = xmin_global + real(rank_idx+1) * xlength_rank
      xmin_rankDouble = xmin_globalDouble + dble(rank_idx  ) 
     &                  * xlength_rankDouble
      xmax_rankDouble = xmin_globalDouble + dble(rank_idx+1) 
     &                  * xlength_rankDouble     
      xmax_rank_temp = xmax_rank

      !-- Y-dir rank length --
      ylength_rank = real(int(ylength_rank*one_over_2h_temp) + 1)*2.0*h
      ylength_rankDouble = dble(int(ylength_rankDouble/(2d0*h))+1)*2d0*h

      ymin_rank = ymin_global + real(rank_idy  ) * ylength_rank
      ymax_rank = ymin_global + real(rank_idy+1) * ylength_rank
      ymin_rankDouble = ymin_globalDouble + dble(rank_idy  ) 
     &                  * ylength_rankDouble
      ymax_rankDouble = ymin_globalDouble + dble(rank_idy+1) 
     &                  * ylength_rankDouble
      ymax_rank_temp = ymax_rank

      !-- Z-dir rank length --
      zlength_rank = real(int(zlength_rank*one_over_2h_temp) + 1)*2.0*h
      zlength_rankDouble = dble(int(zlength_rankDouble/(2d0*h))+1)*2d0*h

      zmin_rank = zmin_global + real(rank_idz  ) * zlength_rank
      zmax_rank = zmin_global + real(rank_idz+1) * zlength_rank
      zmin_rankDouble = zmin_globalDouble + dble(rank_idz  ) 
     &                  * zlength_rankDouble
      zmax_rankDouble = xmin_globalDouble + dble(rank_idz+1) 
     &                  * zlength_rankDouble
      zmax_rank_temp = zmax_rank
      
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      do i=0,n_procs -1
        if(i.eq.rank_id)then
          open(44,file='MPI_DomainProcs.txt',
     &               STATUS='old',POSITION='append')
          write(44,483)'rank_id, rank_idx, xmin_rank, xmax_rank ',
     &                 rank_id, rank_idx, xmin_rank, xmax_rank 
          close(44)
        end if
        call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      end do
      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      do i=0,n_procs -1
        if(i.eq.rank_id)then
          open(44,file='MPI_DomainProcs.txt',
     &               STATUS='old',POSITION='append')
          write(44,483)'rank_id, rank_idy, ymin_rank, ymax_rank ',
     &                 rank_id, rank_idy, ymin_rank, ymax_rank 
          close(44)
        end if
        call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      end do
      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      do i=0,n_procs -1
        if(i.eq.rank_id)then
          open(44,file='MPI_DomainProcs.txt',
     &               STATUS='old',POSITION='append')
          write(44,483)'rank_id, rank_idz, zmin_rank, zmax_rank ',
     &                 rank_id, rank_idz, zmin_rank, zmax_rank 
          close(44)
        end if
        call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      end do
483   format(a40,2(' ',i3),2(' ',f12.6))
      ymin = yb_min
      ymax = yb_max
      zmin = zb_min
      zmax = zb_max
c     ----------------------       
       
       nbfp1=nbf+1
       nbp1=nb+1

c     speed of sound at the reference density 

       if(i_EoS.eq.1)then
         cs0 = sqrt(gamma*B/rho0)
         i_gamma = nint(gamma)
         if(rank_id.eq.0)then
           write(*,*) 'cs0=sqrt(gamma*B/rho0)= ',cs0
           write(*,*) 'Integer gamma, i_gamma = nint(gamma) = ',i_gamma
         endif
       endif

       ddt_c=dt   ! To be used with variable time step
       ddt_p=dt   ! and predictor corrector
       
       
       if(i_algorithm.eq.2)then
         nstep_verlet = 0  !Initialisation of verlet counter
       end if
       
       if(iBC.eq.2)then	!Hughes & Grahams (2009) correction 
         nstep_DBC=0       !Initialisation of DBC correction counter
         if(rank_id.eq.0)write(*,*)'ndt_DBCPerform ',ndt_DBCPerform
       else
         nstep_DBC=-1      !when iBC=1
       endif
       
c      -- Parameters for repulsive force BC --       
       if(lattice.eq.1)then
         vnorm_mass = 1.0
       else if(lattice.eq.2)then
         vnorm_mass = 0.5
       end if
       if(rank_id.eq.0)then
         print*,'lattice    ',lattice
         print*,'vnorm_mass ',vnorm_mass
       endif
       if(iBC.eq.1)then
         beta_coef2 = (coef/10.)**2
         beta_coef  = (coef/10.)
         one_over_beta_coef2 = 1.0/beta_coef2
         one_over_beta_coef  = 1.0/beta_coef
       else
         one_over_beta_coef2 = 0.
         one_over_beta_coef  = 0.
       end if

       if(i_densityFilter.gt.0)then
         if(rank_id.eq.0)then
          print*
          write(*,*) 'Initialising ndt_FilterPerform ',ndt_FilterPerform
          print*
         endif
       endif

      !--- MPI Particle Numbers ---
      nbf_local             = 0
      nb_local              = 0
      np_local              = 0
      nFP_local             = 0
      nbfm_local_temp       = 0
      nbfreem_local_temp    = 0
      !----------------------------

C     Initializing thermal energy
      do i=1,npar
        TEp(i)=0.
      enddo    
       
      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point

C     -- Initial image to RUN --
     
c      i_restartRun > 1 is used for Checkpointing = repetitive restarting of code (for clusters)
c        i_restartRun = 0   :   Start new run, once only
c        i_restartRun = 1   : reStart old run, once only
c        i_restartRun = 2   :   Start new run, with repetitive restarts (Checkpointing)
c        i_restartRun = 3   : reStart old run, with repetitive restarts (Checkpointing)
 
       if(i_restartRun.ge.1) then   !if(i_restartRun.eq.1) then  

         i_RESTART_exists = 1
         open(44,file='RESTART',err=45)
         read(44,*,err=45)itime,time,ngrab,dt
         close(44)

         i_RESTART_exists = i_RESTART_exists + 1
45       i_RESTART_exists = i_RESTART_exists - 1


         if(i_RESTART_exists.eq.1.and.itime.gt.0)then
           write(supp_ini,'(i4.4)') ngrab
           name_ini='PART_'//supp_ini
           !write(*,*) name_ini
           normals_ini='NORMALS.RESTART'
           BPs_ptr='BoundaryPs_MPI_Pointer.RESTART'
           MovingObjectsFile='Floating_Bodies.RESTART'
         else
           itime = 0
           ngrab = 0
           grab_P = 0.0
           grab_E = 0.0
           name_ini='IPART'
           !write(*,*) name_ini
           normals_ini='NORMALS.init'
           BPs_ptr='BoundaryPs_MPI_Pointer.init'
           MovingObjectsFile='Floating_Bodies.txt'
         endif

      else
         itime = 0
         ngrab = 0
         grab_P = 0.0
         grab_E = 0.0
         name_ini='IPART'
         normals_ini='NORMALS.init'
         BPs_ptr='BoundaryPs_MPI_Pointer.init'
         MovingObjectsFile='Floating_Bodies.txt'

      endif
      itime_init = itime
100   format(i8,e16.8,i8,e16.8)
      if(rank_id.eq.0)then
        write(*,*)
        write(*,*)'i_restartRun ',i_restartRun 
        write(*,*)'Reading in '
        write(*,*)' 1: ',name_ini
        write(*,*)' 2: ',normals_ini
        write(*,*)' 3: ',BPs_ptr
        write(*,*)'Using dt ', dt
        write(*,*)
      endif

      if(iBC.eq.1) then
        open(15,file=normals_ini)
      endif
      open(16,file=BPs_ptr)
       
      iminus1_temp = 0 
      iplus1_temp  = 0 
      jminus1_temp = 0 
      jplus1_temp  = 0 
       
       open(13,file=name_ini)
       npp=0 ! keeps track of number of particles
c     --- Load Particle Position Data ---       
196    format(12e16.8)
       do i=1,np
         read(13,196,end=300) 
     &        xp_temp,yp_temp,zp_temp,up_temp,vp_temp,wp_temp,
     &        rhop_temp,p_temp,pm_temp 
         npp = npp + 1
    
                                                                
         if(iBC.eq.1.and.i.le.nb)then
          read(15,*)
     &     xnb_temp,ynb_temp,znb_temp,
     &     xtb_temp,ytb_temp,ztb_temp,
     &     xsb_temp,ysb_temp,zsb_temp,
     &     i_default, irank_default, 
     &     iminus1_temp, iplus1_temp,jminus1_temp, jplus1_temp,
     &     BP_temp1,BP_temp2,BP_temp3
c
         end if

         if(i.le.nb)read(16,*)i_absNormalsPtr_temp  !Needed for repetitive restarts
         
         if(xp_temp.ge.xmin_rank.and.xp_temp.lt.xmax_rank.and.
     &      yp_temp.ge.ymin_rank.and.yp_temp.lt.ymax_rank.and.
     &      zp_temp.ge.zmin_rank.and.zp_temp.lt.zmax_rank)then
          np_local = np_local + 1
          if(np_local.gt.npar)then
            print*
            print*,'ERROR in getdata_MPI_3D.f'
            print*,'np_local.gt.npar'
            write(*,*) 'Number of particles exceeds npar in common!'
            print*,'rank_id ',rank_id
            print*,'np_local, npar ',np_local, npar
            print*,'--> INCREASE npar in common.3D'
            print*
            call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
            stop
          endif
          xp(np_local) = xp_temp
          yp(np_local) = yp_temp
          zp(np_local) = zp_temp
          up(np_local) = up_temp
          vp(np_local) = vp_temp
          wp(np_local) = wp_temp
          rhop(np_local) = rhop_temp
          p(np_local) = p_temp
          pm(np_local) = pm_temp
          iarray_loc_in_use(np_local) = 1
          
          if(i_algorithm.eq.2) then ! To be used with Verlet algorithm
            xo(np_local)=xp(np_local)
            yo(np_local)=yp(np_local)
            zo(np_local)=zp(np_local)
            rhoo(np_local)=rhop(np_local)
            uo(np_local)=up(np_local)
            vo(np_local)=vp(np_local)
            wo(np_local)=wp(np_local)
            pr(np_local) = p(np_local)/(rhop(np_local)*rhop(np_local))
            TEo(np_local)=TEp(np_local)
          elseif (i_algorithm.eq.4) then  !to be used with Beeman algorithm
            udot(i)=0.0   !Check it for hot starts !!!!!!!            
            vdot(i)=0.0
            wdot(i)=0.0
            udoto(i)=0.0
            vdoto(i)=0.0
            wdoto(i)=0.0
            udotm1(i)=0.0
            vdotm1(i)=0.0
            wdotm1(i)=0.0
            rdot(i)=0.0
            rdoto(i)=0.0
            rdotm1(i)=0.0
          endif

          !Set index pointers
          if(i.lt.nbp1)then
            nb_local = nb_local + 1
            if(i.le.nbf)then
              nbf_local = nbf_local + 1
              i_particleType(nb_local) = 1   !Fixed Particle
              ip_index_BP_local_1(nbf_local) = np_local
            else if(i.gt.nbf.and.i.le.nbfm)then
              nbfm_local_temp = nbfm_local_temp + 1
              i_particleType(np_local) = 2   !Forced Moving Particle (i.e. a moving boundary particle)
              ip_index_BP_local_2(nbfm_local_temp) = np_local
            else !if(i.gt.nbfm.and.i.le.nb)then
              nbfreem_local_temp = nbfreem_local_temp + 1
              i_particleType(np_local) = 3   !Free Moving Particle (i.e. a moving Floating Body boundary particle)
              ip_index_BP_local_3(nbfreem_local_temp) = np_local
            end if
            ip_index_BP_local(np_local) = np_local
          else 
            nFP_local = nFP_local + 1
            ip_index_FP_local(nFP_local) = np_local
            i_particleType(np_local) = 4  !Fluid particle
          end if

          if(iBC.eq.1.and.i.le.nb)then
           xnb(np_local) = xnb_temp
           ynb(np_local) = ynb_temp
           znb(np_local) = znb_temp
           xtb(np_local) = xtb_temp
           ytb(np_local) = ytb_temp
           ztb(np_local) = ztb_temp
           xsb(np_local) = xsb_temp
           ysb(np_local) = ysb_temp
           zsb(np_local) = zsb_temp
          end if
          if(i.le.nb)then 
            iabsolute_BP_Pointer_Index(np_local) = i_absNormalsPtr_temp   !i_absolute  !i                      
          endif
         
          iflag(np_local)=1 ! To detect particles inside the container
       
          pVol(np_local)      = pm(np_local)/rhop(np_local)
          call equation_of_state
     &         (rhop(np_local),TEp(np_local),p(np_local),cs(np_local))
        
          !- Particle Locator -
          if(i.eq.-24207.or.i.eq.-24506.or.
     &       i.eq.-117774.or.i.eq.-117764)then
            print*
            print*,'Found it!'
            print*,'i, rank_id, np_local ',i, rank_id, np_local
            print*,'rank_idx, rank_idy, rank_idz ',
     &              rank_idx, rank_idy, rank_idz
            print*,'xmin_rank, xmax_rank ', xmin_rank, xmax_rank
            print*,'ymin_rank, ymax_rank ', ymin_rank, ymax_rank
            print*,'zmin_rank, zmax_rank ', zmin_rank, zmax_rank
            print*,'xp_temp, yp_temp, zp_temp ',xp_temp,yp_temp,zp_temp
            print*,'up_temp, vp_temp, wp_temp ',up_temp,vp_temp,wp_temp
            print*,'xp(np_local), yp(np_local), zp(np_local) ',
     &              xp(np_local), yp(np_local), zp(np_local)
            print*,'rhop(np_local), cs(np_local) ',
     &              rhop(np_local), cs(np_local)
            print*,'p(np_local), p_temp ',
     &              p(np_local), p_temp
            !- Boundary Particle Locator -
            if(i.le.nb)then
              print*,'iabsolute_BP_Pointer_Index(np_local)',
     &                i_absNormalsPtr_temp
             if(iBC.eq.1)then
              print*,'xnb(np_local), znb(np_local) ',
     &                xnb(np_local), znb(np_local)
              print*,'iminus1_temp, iplus1_temp ',
     &                iminus1_temp, iplus1_temp
              print*,'BP_temp1,BP_temp2 ',
     &                BP_temp1,BP_temp2
             endif              
            endif
            print*
            !stop
          end if
          !--------------------
          
          !-- For Conservative Formulation --
          if(iRiemannSolver.eq.1)then          
            Volrho(np_local)    = pm(np_local)
            Volrhou(np_local)   = Volrho(np_local)*up(np_local)
            Volrhov(np_local)   = Volrho(np_local)*vp(np_local)
            Volrhow(np_local)   = Volrho(np_local)*wp(np_local)
            TotalE(np_local)    = rhop(np_local)*(TEp(np_local)
     &      + 0.5*( up(np_local)*up(np_local) +vp(np_local)*vp(np_local)
     &             +wp(np_local)*wp(np_local)))
            VolTotalE(np_local) = pVol(np_local)*TotalE(np_local)
          else
            Volrho(np_local)    = 0.0
            Volrhou(np_local)   = 0.0
            Volrhov(np_local)   = 0.0
            Volrhow(np_local)   = 0.0
            TotalE(np_local)    = 0.0
            VolTotalE(np_local) = 0.0
          endif 
       
        end if    !End of:  if(xp_temp.ge.xmin_rank.and.xp_temp.lt.xmax_rank)then         
       
        if(iBC.eq.1.and.rank_id.eq.0.and.i.le.nb)then
          do i_rankx = 0,n_procs_x - 1   !do i_rank = 0,n_procs-1
          do i_ranky = 0,n_procs_y - 1
          do i_rankz = 0,n_procs_z - 1
            i_rank = (i_rankx+1) + (i_ranky+1 - 1)*n_procs_x
     &                           + (i_rankz+1 - 1)*n_procs_x*n_procs_y
            xmin_rank_temp = xmin_global + real(i_rankx  )*xlength_rank
            xmax_rank_temp = xmin_global + real(i_rankx+1)*xlength_rank
            ymin_rank_temp = ymin_global + real(i_ranky  )*ylength_rank
            ymax_rank_temp = ymin_global + real(i_ranky+1)*ylength_rank
            zmin_rank_temp = zmin_global + real(i_rankz  )*zlength_rank
            zmax_rank_temp = zmin_global + real(i_rankz+1)*zlength_rank
            if(xp_temp.ge.xmin_rank_temp.and.
     &         xp_temp.lt.xmax_rank_temp.and.
     &         yp_temp.lt.ymax_rank_temp.and.
     &         yp_temp.lt.ymax_rank_temp.and.
     &         zp_temp.lt.zmax_rank_temp.and.
     &         zp_temp.lt.zmax_rank_temp)then
              iBP_Pointer_Info(i,1) = i              !Local index on i_rank    !!DO NOT UNCOMMENT (see below)
              iBP_Pointer_Info(i,2) = i_rank         !Rank of BP
              iBP_Pointer_Info(i,3) = iminus1_temp   !Absolute index of i-1 neighbour BP
              iBP_Pointer_Info(i,4) = iplus1_temp    !Absolute index of i+1 neighbour BP
              iBP_Pointer_Info(i,5) = jminus1_temp   !Absolute index of j-1 neighbour BP
              iBP_Pointer_Info(i,6) = jplus1_temp    !Absolute index of j+1 neighbour BP
              BP_xyz_Data(i,1) = BP_temp1            !xp coordinate of i
              BP_xyz_Data(i,2) = BP_temp2            !yp coordinate of i
              BP_xyz_Data(i,3) = BP_temp3            !zp coordinate of i
            end if
          end do
          end do
          end do
        end if
       
       enddo
       close(13) 
300    if(i.lt.nb)then
         write(*,*)
     &   'Number of particles smaller than nb!'
        print*,'i ',i
        print*,'nb_local ',nb_local
        print*,'nb_max   ',nb_max
        print*,'nb',nb
        print*,'np',np
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
       else
        if(rank_id.eq.0.and.npp.lt.np)then
          print*,'Correcting np'
        endif
        np=npp
       endif
       nbfp1_local = nbf_local + 1   
       nbp1_local  = nb_local  + 1

c      ---  Process NORMALS Info ---  SERIAL CODE NOW AFTER MPI_BCAST BELOW
c      -----------------------------

      if(nb .ge. nb_max ) then
        write(*,*)
     &  'Number of boundary particles exceeds nb_max in common!'
        print*,'rank_id ',rank_id
        print*,'nb_local ',nb_local
        print*,'nb_max   ',nb_max
        print*,'nb',nb
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      endif 

c     ----------------------------------
      nbfm_local    = nbf_local + nbfm_local_temp
      nbfreem_local = nbfm_local + nbfreem_local_temp
      if(rank_id.eq.0)print*,'nbfreem_local_temp    ',nbfreem_local_temp
      if(rank_id.eq.0)print*,'nbfm_local_temp ',
     &                        nbfm_local_temp
      if(rank_id.eq.0)print*,'nbfm_local      ',nbfm_local
      nb_image_local   = nb_local
      np_image_local   = np_local
      nbf_image_local  = nbf_local
      nbfm_image_local = nbfm_local
      nbfreem_image_local = nbfreem_local
      if(rank_id.eq.0)print*,'rank_id = ',rank_id,' nstart = ',nstart
      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
c     --- Image Check --------------------------      
      if(rank_id.eq.-10)then
        print*
        print*,'rank_id, nbf_local, nbfreem_local, nb_local, np_local '
        print*, rank_id, nbf_local, nbfreem_local, nb_local, np_local 
        do ipcount=1,np_local
          if(ipcount.le.nbf_local)then
            i = ip_index_BP_local_1(ipcount)
          else if(ipcount.le.nbfm_local)then
            i = ip_index_BP_local_2(ipcount-nbf_local)
          else if(ipcount.le.nbfreem_local)then
            i = ip_index_BP_local_3(ipcount-nbfm_local)
          else
            i = ip_index_FP_local(ipcount-nb_local)
          end if
          write(486,*),'ipcount -> i, xp, yp, zp ',
     &                ipcount,i,xp(i),yp(i),zp(i)
        end do
      end if
486   format(a26,2(' ',i6,3(' ',f12.6)))
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
c     -------------------------------------------      
       
              
c     ----- Print out Particle Numbers for each Processor -----             
      ymin_global = ymin
      ymax_global = ymax
      zmin_global = zmin
      zmax_global = zmax
      if(rank_id.eq.0)then
        print*
        print*,'xmin_global, xmax_global ',xmin_global, xmax_global 
        print*,'ymin_global, ymax_global ',ymin_global, ymax_global 
        print*,'zmin_global, zmax_global ',zmin_global, zmax_global 
        print*,'xmin_global + xlength_rank*real(n_procs_x)',
     &          xmin_global + xlength_rank*real(n_procs_x)   
        print*
      end if

      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      !- Print screen information -
      if(1.eq.2)then
        do i=0,n_procs -1
          if(i.eq.rank_id)then
            print*,'rank_id, xmin_rank, xmax_rank ',
     &              rank_id, xmin_rank, xmax_rank 
          end if
          call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
        end do
        if(rank_id.eq.0)then
          print*
          print*,
     &    ' rank_id,  nbf_local,  nbfm_local,  nbfreem_local, nb_local,
     &    np_local '
        end if
        do i=0,n_procs -1
          if(i.eq.rank_id)then
            print*,rank_id, nbf_local, nbfm_local, nbfreem_local, 
     &             nb_local, np_local 
          end if
          call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
        end do
      endif   !End of:  if(.1eq.2)then
499   format(a42,4(' ',i8))
      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      !stop    !<==================STOP HERE!!


c----------------------------------------------------------------------------------
c      -- Store globally the numbers of particle types on each processor --
      !-- THIS DOES NOT WORK --!!!!
      call MPI_GATHER(nbf_local                  , 1, MPI_INTEGER, 
     &                nbf_start_global(rank_id+1), 1, MPI_INTEGER, 
     &                0, MPI_COMM_WORLD, ierr)
      call MPI_GATHER(nb_local                  , 1, MPI_INTEGER, 
     &                nb_finish_global(rank_id+1), 1, MPI_INTEGER, 
     &                0, MPI_COMM_WORLD, ierr)
      if(rank_id.eq.0)then
        nbf_start_global_temp = nbf_start_global
        nbf_start_global(1) = 1
        do i_rank = 0,n_procs-1
          if(i_rank.gt.0)then
            nbf_start_global(i_rank+1) = nbf_start_global(i_rank)
     &                     + nbf_start_global_temp(i_rank)
            nb_finish_global(i_rank+1) = nb_finish_global(i_rank+1)
     &                     + nb_finish_global(i_rank)
          end if
c          nbf_start_global(i_rank+1) = nbf_start_global(i_rank+1)
c     &                                - nbf_start_global(1)
        end do
      end if
      call MPI_BCast(nbf_start_global, n_procs, MPI_INTEGER, 
     &               0, MPI_COMM_WORLD, ierr)
      call MPI_BCast(nb_finish_global , n_procs, MPI_INTEGER, 
     &               0, MPI_COMM_WORLD, ierr)
      if(rank_id.eq.n_procs-1)then
        print*
        !print*,'nbf_start_global = ',nbf_start_global
        !print*,'nb_finish_global = ',nb_finish_global
      end if
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
c----------------------------------------------------------------------------------


      !-- BroadCast BP_Pointer_Info to all processes --
      !--Create Derived DataTypes for transmitting 2-D arrays--
      if(kind_XYZ.eq.kind(0.0))then
        MPI_TYPE_XYZ  = MPI_REAL
      elseif(kind_XYZ.eq.kind(0D0))then
        MPI_TYPE_XYZ  = MPI_DOUBLE_PRECISION
      endif
      call MPI_TYPE_VECTOR(6, nb_max, nb_max, MPI_INTEGER,  
     &                     iBP_Pointer_Info_Type, ierr)
      call MPI_TYPE_VECTOR(3, nb_max, nb_max, MPI_TYPE_XYZ,  
     &                     iBP_xyz_Data_Type, ierr)
      call MPI_TYPE_COMMIT(iBP_Pointer_Info_Type, ierr)
      call MPI_TYPE_COMMIT(iBP_xyz_Data_Type      , ierr)


      call MPI_BCast(iBP_Pointer_Info, 1, iBP_Pointer_Info_Type, 
     &               0, MPI_COMM_WORLD, ierr)
      call MPI_BCast(BP_xyz_Data     , 1, iBP_xyz_Data_Type, 
     &               0, MPI_COMM_WORLD, ierr)
      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      call MPI_TYPE_FREE(iBP_Pointer_Info_Type, ierr)


      !-- Screen Info Printout ---------------------------------------
      if(rank_id.eq.-10)then   !if(rank_id.eq.n_procs-1)then
        print*
        print*,'Checking BPs NORMALS connectivity in getData.f'
        print*,' i  rank_id index_on_rank i-/+1,    j-/+1,         xp,  
     &yp,       zp'
        do i=1,nb
          write(*,498),i,(iBP_Pointer_Info(i,j),j=1,6),
     &                (BP_xyz_Data(i,k),k=1,3)
        end do
      end if
      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
498   format(3(i7,'   '),('   '),4(i7,'   '),3(f10.4,'   '))
497   format(1(i4,'  '),10(f8.4,' '))
484   format(1(i4,'  '),6(f12.6,' '),5(i5,' '),3(f12.6,' '))
c     ----------------------------------------------------------------

c      ---  Process BPs & NORMALS Info ---
       nb_togoto_Root = 0
       do ipcount=1,nb_local
          call ipcount_to_i(ipcount,i)
          !Pack xyz data for sending to Root processor
          nb_togoto_Root = nb_togoto_Root + 1
          xp_togoto_Root(nb_togoto_Root)   = xp(i)
          yp_togoto_Root(nb_togoto_Root)   = yp(i)
          zp_togoto_Root(nb_togoto_Root)   = zp(i)
          i_BPP_togoto_Root(nb_togoto_Root) = 
     &                iabsolute_BP_Pointer_Index(i)          
       end do        
       call update_BPInfo_onRoot(
     &      1, nb_local, i_BPP_togoto_Root,
     &      xp_togoto_Root, yp_togoto_Root, zp_togoto_Root)
       if(iBC.eq.1) then
         nstart=nbp1_local
         close(15)
         close(16)
         i_particleTypeChoice = 0   !All Boundary Particles
         call updateNormals_3D(1,nb_local,i_particleTypeChoice)   

         !- Angular Momentum Correction -
         !two_alpha_h_over_4 = 2.0*1.5/4.0
         alpha_h = h/sqrt(dx0*dx0 + dy0*dy0 + dz0*dz0)
         two_alpha_h_over_4 = 2.0*alpha_h/4.0
         rNum_h = 3.0*h  !*vnorm_mass
         one_over_rNum_h = 1.0/rNum_h 
         one_over_r_ij_dot_n = alpha_h /h
         equilibrium_factor = 0.4   !Proportion of vnorm_mass*dx for particle in perpendicular equilibrium
         !if(lattice.eq.1)then
         !  equilibrium_factor = 0.25
         !endif
         q = (vnorm_mass*dx0/(2.0*h)) * equilibrium_factor
         Q_of_deltax = (1.0 - q)/sqrt(q)
         one_over_Q_of_deltax= 1.0/Q_of_deltax
         if(lattice.eq.1)then
           one_over_Q_of_deltax = one_over_Q_of_deltax *0.75
         endif
       else
         nstart=1
       endif
       nstart_minus1 = nstart - 1
!       print*,'rank_id = ',rank_id,' nstart = ',nstart
c     -----------------------------

      if(rank_id.eq.-10)then   !if(rank_id.eq.n_procs-1)then
        print*
        print*,'Checking BPs NORMALS  in getData.f'
        print*,'rank_id = ',rank_id
        print*,' i  xp,   zp, xnb, znb'        
        do ipcount=1,nb_local
          call ipcount_to_i(ipcount,i)
          i_absolute = iabsolute_BP_Pointer_Index(i)
          iminus1 = iBP_Pointer_Info(i_absolute,3)
          iplus1  = iBP_Pointer_Info(i_absolute,4)          
          jminus1 = iBP_Pointer_Info(i_absolute,5)
          jplus1  = iBP_Pointer_Info(i_absolute,6)          
          xp_temp = BP_xyz_Data(i_absolute,1)              !xp coordinate of i
          yp_temp = BP_xyz_Data(i_absolute,2)             !zp coordinate of i
          zp_temp = BP_xyz_Data(i_absolute,3)             !zp coordinate of i
          write(*,484)i,xp(i),yp(i),zp(i),xnb(i),ynb(i),znb(i)
     &               ,i_absolute,iminus1,iplus1,jminus1,jplus1
     &               ,xp_temp,yp_temp,zp_temp
        end do
      end if
      !stop

      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point

      !- Initialise certain variables -
      ihighest_np = np_local
      kk_highest = np_local+1
      itop_free_index = 0
      itrackOneWPswitch = 0
      iBPs_top_free_index = 0
      iFPs_top_free_index = 0
      do i=1,npar
        iBPs_free_index(i) = 0 
        iFPs_free_index(i) = 0 
        tau_xx_uno_rho2(i) = 0.0
        tau_xy_uno_rho2(i) = 0.0
        tau_xz_uno_rho2(i) = 0.0
        tau_yy_uno_rho2(i) = 0.0
        tau_yz_uno_rho2(i) = 0.0
        tau_zz_uno_rho2(i) = 0.0
        
        dudx_CSPH(i)       = 0.0
        dudy_CSPH(i)       = 0.0
        dudz_CSPH(i)       = 0.0
        dvdx_CSPH(i)       = 0.0
        dvdy_CSPH(i)       = 0.0
        dvdz_CSPH(i)       = 0.0
        dwdx_CSPH(i)       = 0.0
        dwdy_CSPH(i)       = 0.0
        dwdz_CSPH(i)       = 0.0
        drhodx_CSPH(i)     = 0.0
        drhody_CSPH(i)     = 0.0
        drhodz_CSPH(i)     = 0.0
        drhoudx_CSPH(i)    = 0.0
        drhoudy_CSPH(i)    = 0.0
        drhoudz_CSPH(i)    = 0.0
        drhovdx_CSPH(i)    = 0.0
        drhovdy_CSPH(i)    = 0.0
        drhovdz_CSPH(i)    = 0.0
        drhowdx_CSPH(i)    = 0.0
        drhowdy_CSPH(i)    = 0.0
        drhowdz_CSPH(i)    = 0.0
        dTEdx_CSPH(i)      = 0.0
        dTEdy_CSPH(i)      = 0.0
        dTEdz_CSPH(i)      = 0.0
        dTotalEdx_CSPH(i)  = 0.0
        dTotalEdy_CSPH(i)  = 0.0
        dTotalEdz_CSPH(i)  = 0.0
      end do

      do i=1,nct_max
        nc(i,1) = 0   !WHAT ???
        nc(i,2) = 0   !WHAT ???
      end do

c     ------ Load Moving Object Data Files ---------
c
c     - (Note files will be empty for no objects) -
              
              
c     --- The gate ----------------
       open(77,file='gate')
       read(77,*) iopt_gate       
       if(iopt_gate.eq.1) then
         read(77,*) ngate_ini
         read(77,*) ngate_end
         read(77,*) VXgate,VYgate,VZgate
         read(77,*) tgate
       else
         ngate_ini=1  ! If ngate_ini > ngate_end the loop 
         ngate_end=0  ! in AC doesn't work 
       endif       
       close(77)

       !-- The wavemaker --
       open(66,file='wavemaker')
       read(66,*) iopt_wavemaker       
       if(iopt_wavemaker.eq.1)then
         read(66,*) i_paddleType
         read(66,*) nwavemaker_ini
         read(66,*) nwavemaker_end
         read(66,*) X_PaddleCentre
         read(66,*) X_PaddleStart
         read(66,*) paddle_SWL
         read(66,*) flap_length
         read(66,*) stroke
         read(66,*) twavemaker
         read(66,*) paddle_fileName
         read(66,*) Nfreq
       
       
         do n=1,Nfreq
           read(66,*) A_wavemaker(n)
           read(66,*) Period(n)
           read(66,*) phase(n)
           read(66,*) twinitial(n)
         enddo
       
         do i=1,nb_local
           xp_ini(i)=xp(i)  ! X initial of two layers of wavemaker
         end do
         
         A_wavemaker(Nfreq+1)=A_wavemaker(Nfreq)
         Period(Nfreq+1)=Period(Nfreq)
         phase(Nfreq+1)=0.
         twinitial(Nfreq+1)=100*tmax
       
         ind_wm=0
         ind1_wm=1
              
         if(i_paddleType.eq.3)then  !Paddle has prescribed motion
           if(rank_id.eq.0)then
             print*
             print*,'Opening prescribed paddle file = ',paddle_fileName
           endif
           open(67,file=paddle_fileName)
           n_paddleData = 0
           i_read = 0
           do while(i_read.eq.0)
             n_paddleData = n_paddleData + 1
             if(n_paddleData.gt.20000+1)then
               print*,'Too many timesteps in prescribed paddle motion'
               stop
             endif
             read(67,*,END = 68)time_paddle(n_paddleData),
     &                x_paddle(n_paddleData),u_paddle(n_paddleData)
             if(i_read.eq.0)then
               i_read = i_read - 1
             endif
68           i_read = i_read + 1
           enddo
           close(67)
           n_paddleData = n_paddleData - 1
           if(rank_id.eq.0)then
             print*
             print*,'Sample print-out of prescribed paddle motion'
             print*,'  n_paddleData = ',n_paddleData
             print*,'  i,  time_paddle(i),    x_paddle(i),  u_paddle(i)'
             do i=1,10
               print*,i,time_paddle(i),x_paddle(i),u_paddle(i)
             enddo
             print*
           endif
         endif
         
       else
       
         nwavemaker_ini=1  ! If nwavemaker_ini > nwavemaker_end the loop 
         nwavemaker_end=0  ! in AC doesn't work 
       
       endif       
       close(66) 


c      ---  Open Raichlen Wedge Input Files --
       open(77,file='Tsunami_Landslide.txt')
       read(77,*) iopt_RaichlenWedge
       if(iopt_RaichlenWedge.eq.1)then
         read(77,*)bslope
         if(rank_id.eq.0)then
           print*,'-- Opening Raichlen Wedge Input Files --'
           print*
         endif
         open(unit=78,file='Benchmark_4_run30.txt')
         open(unit=79,file='Benchmark_4_initialPositions.dat')
         read(78,*) i_RBend
         if(rank_id.eq.0)then
           print*,'Number of time measurements, i_RBend ',i_RBend
         endif
         do i = 1,i_RBend
           read(78,*)RBtime(i),RBxpos(i)
           RBxpos(i) = RBxpos(i)*0.01   !conversion from cm to m
         end do
         do i = nbf+1,nb
           read(79,*)xp_Wedge_initial(i-nbf), yp_Wedge_initial(i-nbf),
     &               zp_Wedge_initial(i-nbf)
         end do
         if(rank_id.eq.0)then
           print*,'Wedge info loaded'
           print*
         endif
       end if
       close(77) 
       close(78)
       close(79) 
c      ---------------------------------------

c      ---  Open Floating Body Input Files --
       open(77,file=MovingObjectsFile)  !open(77,file='Floating_Bodies.txt')
       read(77,*) iopt_FloatingBodies
       if(iopt_FloatingBodies.eq.1)then
         read(77,*)nbfm
         if(rank_id.eq.0)then
           print*
           print*,'-- Opening Floating Body Input Files --'
           write(*,*)'Reading in ', MovingObjectsFile
         endif
         i_FB_finish = 0
         i_ini = nbfm + 1
         num_FB_counter = 0
         do while(i_FB_finish.eq.0)
           read(77,*,END = 76)i_num_FB
           if(i_num_FB.gt.num_FB_max)then
             print*,'Number of floating Bodies exceeds max value'
             print*,'num_FB.gt.num_FB_max'
             print*,'Adjust num_FB_max in common.3D, num_FB_max = ',
     &          num_FB_max
             stop
           endif
           read(77,*)bigMass(i_num_FB)
           read(77,*)bigInertiaXX(i_num_FB),
     &               bigInertiaYY(i_num_FB),
     &               bigInertiaZZ(i_num_FB)
           read(77,*)XcylinderDimension(i_num_FB),
     &               YcylinderDimension(i_num_FB),
     &               ZcylinderDimension(i_num_FB)
           read(77,*)cylinderDensity(i_num_FB)
           read(77,*)FB_SpecificWeight(i_num_FB)
           read(77,*)friction_coeff(i_num_FB)
           read(77,*)Box_XC(i_num_FB),Box_YC(i_num_FB),Box_ZC(i_num_FB)
           read(77,*)bigU(i_num_FB),bigV(i_num_FB),bigW(i_num_FB),
     &       bigOmegaX(i_num_FB),bigOmegaY(i_num_FB),bigOmegaZ(i_num_FB)
           read(77,*)nb_FB(i_num_FB)
           if(rank_id.eq.0)then
             print*,'i_num_FB    ',i_num_FB
             print*,'bigMass     ',bigMass(i_num_FB)
             print*,'bigInertiaXX,YY,ZZ  ',bigInertiaXX(i_num_FB),
     &                                     bigInertiaYY(i_num_FB),
     &                                     bigInertiaZZ(i_num_FB)
             print*,'XcylinderDimension ',XcylinderDimension(i_num_FB)
             print*,'YcylinderDimension ',YcylinderDimension(i_num_FB)
             print*,'ZcylinderDimension ',ZcylinderDimension(i_num_FB)
             print*,'cylinderDensity   ',cylinderDensity(i_num_FB)
             print*,'SpecificWeight    ',FB_SpecificWeight(i_num_FB)
             print*,'friction_coeff     ',friction_coeff(i_num_FB)
             print*,'Initial Conditions:'
             print*,'Box_XC, Box_YC, Box_ZC  ',
     &               Box_XC(i_num_FB),Box_YC(i_num_FB),Box_ZC(i_num_FB)
             print*,'bigU  , bigV  , bigW    ',
     &               bigU(i_num_FB), bigV(i_num_FB), bigW(i_num_FB) 
             print*,'OmegaX, OmegaY, OmegaZ  ',
     &               bigOmegaX(i_num_FB),bigOmegaY(i_num_FB),
     &               bigOmegaZ(i_num_FB)
             print*,'nb_FB        ',nb_FB(i_num_FB)
             print*
           endif   !End of:  if(rank_id.eq.0)then
           if(i_num_FB.eq.1)then
             nb_FB_local(i_num_FB) = nbfm_local
           else
             nb_FB_local(i_num_FB) = nb_FB_local(i_num_FB-1)
           endif
           do i_absolute = i_ini,nb_FB(i_num_FB)
             i_FB_Pointer_Info(i_absolute) = i_num_FB   !This is global for all procs
             xp_temp = BP_xyz_Data(i_absolute,1)
             yp_temp = BP_xyz_Data(i_absolute,2)
             zp_temp = BP_xyz_Data(i_absolute,3)
             if(xp_temp.ge.xmin_rank.and.xp_temp.lt.xmax_rank.and.
     &          yp_temp.ge.ymin_rank.and.yp_temp.lt.ymax_rank.and.
     &          zp_temp.ge.zmin_rank.and.zp_temp.lt.zmax_rank)then
               nb_FB_local(i_num_FB) = nb_FB_local(i_num_FB) + 1
               if(nb_FB_local(i_num_FB).gt.nbfreem_local)then
                 print*
                 print*,'ERROR in getdata_MPI_3D.f'
                 print*,'nb_FB_local(i_num_FB).gt.nbfreem_local'
                 print*,'rank_id  ',rank_id
                 print*,'i_num_FB ',i_num_FB
                 print*,'i_ini, nb_FB(i_num_FB), i_absolute ',
     &                   i_ini, nb_FB(i_num_FB), i_absolute
                 print*,'nb_FB_local(i_num_FB) ',nb_FB_local(i_num_FB)
                 print*,'nbfreem_local           ',nbfreem_local
                 print*,'xmin_rank, xmax_rank, xp_temp',
     &                   xmin_rank, xmax_rank, xp_temp            
                 do ii = 1,i_num_FB
                   print*,'FB ii, nb_FB_local(ii) ',ii,nb_FB_local(ii)
                 enddo
                 print*
                 stop
               endif
             endif
           end do                      
           i_ini = nb_FB(i_num_FB) + 1
           num_FB_counter = num_FB_counter + 1
           u_parallel_max = cs0*1.0e-4  !Threshold sliding velocity to activate dynamic friction force
           one_over_u_parallel_max = 1.0 / u_parallel_max
           
           !Determine whether to exit loop
           if(i_FB_finish.eq.0)then
             i_FB_finish = i_FB_finish - 1
           endif
76         i_FB_finish = i_FB_finish + 1
           !print*
           
         end do
         num_FB = num_FB_counter
         !nstart = nbfm_local + 1
         nstart = nbfreem_local + 1    !CHECK THIS!!!!!!!!!!!!!!!!!!
         if(rank_id.eq.0)then
           print*,'Number of Floating Bodies, num_FB ',num_FB
           print*,'nbfm_local, nstart = nbfreem_local + 1 ',
     &             nbfm_local,nstart
           do i_num_FB = 1,num_FB
             if(i_num_FB.eq.1)then
               i_FB_start = nbfm_local + 1
             else
               i_FB_start = nb_FB_local(i_num_FB-1) + 1
             end if
             print*,i_num_FB, i_FB_start, nb_FB_local(i_num_FB)
           enddo
           print*,'--- Floating Body info loaded ---'
           print*
         endif
       end if
       close(77) 
       do i_num_FB = 1,num_FB
         if(i_num_FB.eq.1)then
           i_FB_start = nbfm_local + 1
         else
           i_FB_start = nb_FB_local(i_num_FB-1) + 1
         end if
         do ipcount = i_FB_start,nb_FB_local(i_num_FB)
           ii = ip_index_BP_local_3(ipcount-nbfm_local)
           i_absolute = iabsolute_BP_Pointer_Index(ii)
           xp_temp = BP_xyz_Data(i_absolute,1)
           yp_temp = BP_xyz_Data(i_absolute,2)
           zp_temp = BP_xyz_Data(i_absolute,3)
           xp_minus_R0(ii) = xp_temp - Box_XC(i_num_FB)
           yp_minus_R0(ii) = yp_temp - Box_YC(i_num_FB)
           zp_minus_R0(ii) = zp_temp - Box_ZC(i_num_FB)
           !- Debugging Code -
           if(ii.eq.-1274.and.i_num_FB.eq.7)then
             print*
             print*,'ii, i_absolute, i_num_FB ',ii, i_absolute, i_num_FB
             print*,'xp(ii), zp(ii) ',xp(ii),zp(ii)
             print*,'xp_temp, zp_temp ',xp_temp,zp_temp
             print*,'BP_xyz_Data(1-2) ',
     &               BP_xyz_Data(i_absolute,1),BP_xyz_Data(i_absolute,2)
             print*,'Box_XC, Box_ZC ',Box_XC(i_num_FB),Box_ZC(i_num_FB)
             print*,'xp_minus_R0(ii), zp_minus_R0(ii) ',
     &               xp_minus_R0(ii),zp_minus_R0(ii)
             print*
             stop
           endif
           
         end do
       enddo 

      !-- Screen Printout ---------------------------------------- 
      if(1.eq.2)then                    
       do i=0,n_procs-1
         if(i.eq.rank_id)then
          write(*,*)'rank_id, num_FB, nbfm_local, nbfreem_local',
     &               rank_id, num_FB, nbfm_local, nbfreem_local
         end if
         call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
       end do
       do i=0,n_procs-1
         if(i.eq.rank_id.and.1.eq.2)then
            write(*,*)'rank_id, num_FB, nbfm_local, nbfreem_local',
     &                 rank_id, num_FB, nbfm_local, nbfreem_local
           do i_num_FB = 1,num_FB
             if(i_num_FB.eq.1)then
               i_FB_start = nbfm_local + 1
             else
               i_FB_start = nb_FB_local(i_num_FB-1) + 1
             end if
             write(*,*)
     &           'rank_id, i_num_FB, i_FB_start, nb_FB_local(i_num_FB)',
     &            rank_id, i_num_FB, i_FB_start, nb_FB_local(i_num_FB)
             write(*,*)
     &           'Box_XC(i_num_FB), Box_YC(i_num_FB), Box_ZC(i_num_FB)',
     &            Box_XC(i_num_FB), Box_YC(i_num_FB), Box_ZC(i_num_FB)
             do ipcount = i_FB_start, nb_FB_local(i_num_FB)
               ii = ip_index_BP_local_3(ipcount-nbfm_local)
               i_absolute = iabsolute_BP_Pointer_Index(ii)
               xp_temp = BP_xyz_Data(i_absolute,1)
               yp_temp = BP_xyz_Data(i_absolute,2)
               zp_temp = BP_xyz_Data(i_absolute,3)
               print*,ipcount, ii, i_absolute,
     &                i_FB_Pointer_Info(i_absolute), xp_temp, zp_temp,
     &                xp_minus_R0(ii),zp_minus_R0(ii)
             enddo
           enddo
         end if
         call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
       end do
       !stop
      endif   !End of:  if(1.eq.2)then
c     ---------------------------------------

c     -----------------------------
      if(iopt_gate          .eq.1.or.
     &   iopt_wavemaker     .eq.1.or.
     &   iopt_RaichlenWedge .eq.1.or.
     &   iopt_FloatingBodies.eq.1) then
        iopt_movingObject = 1
      else
        iopt_movingObject = 0           
      endif
      if(rank_id.eq.0)then
        print*
        print*,'Moving Objects: iopt_movingObject ',iopt_movingObject
        print*
      endif
       
c     --- End of Loading Moving Object Files ---

c     --- PeriodicOBs X-DIRECTION INFLOW --------
      if(i_periodicOBs(1).eq.1)then
        flow_in_old = 0.0
        U_in = 0.000   !Bluff Body case
      end if
c     -------------------------------------------

       !--  Sub-Particle Scale (SPS) Turbulent Stress Terms --     
       !- Smag = (0.12*dp)**2  -
       dp=sqrt(dx0*dx0 + dy0*dy0 + dz0*dz0)/3.0
       Smag = (0.12*dp)**2 
       oneThird  = 1.0/3.0
       twoThirds = 2.0/3.0
       Blin_const = twoThirds*0.0066*dp*dp
       
       vortmax=0.0
       vortmin=0.0
       densitymax=1000.0
       densitymin=1000.0
C
       if(rank_id.eq.0)then
         write(*,*)' All ',np,' initial points read successfully'
       endif
       
       pi = 4.d0*datan(1.d0)
       twopi=2.*pi

C     The extent of all particles is the same but it could be different
c    (1= boundary-boundary; 3= fluid-fluid; 2 boundary-fluid)
 
       if(rank_id.eq.0)then
         print*
         print*,' -- Kernel Information --'
         print*,'Kernel Choice = ',i_kernel
         print*
       endif
       
       !Different Kernel Smoothing Lengths

       two_h  = 2.0*h            
       four_h = 4.0*h
       six_h  = 6.0*h            
       h_over_100 = 0.01*h        
       h_over_1000 = 0.001*h        
       rr2_min = 1.e-18     
		 
c 			3D Kernel
c.... coefficients for the spline Kernel W(r)
c.... coefficients for the derivative W_r (r,h) of the spline Kernel
c	(See Liu's Book 2003)	      
       
         h2=h*h
         fourh2=4.*h2

       
         if (i_kernel.eq.1) then !3D Gaussian 
c                    Wab=      a2*exp(-q2/gauss2)              gaussian kernel
c                              0
c                    W_r=      f1*q*exp(-q2/gauss2)   derivative of gaussian kernel
c                              0
           gauss=1.
           gauss2=gauss*gauss                           
           a1 = 1./(pi**1.5)
           a2 = a1/(h*h*h)
           aa = a1/(h*h*h*h)
           adh=a2
           f1 = -2.*aa/gauss2
       
           if(rank_id.eq.0)then
             write(*,*) 'Gaussian kernel'
             write(*,*) a2,f1
           endif
       
           !deltap_g=sqrt(2.)/2    
           deltap2=0.5
           Wdeltap=a2*exp(-deltap2/gauss2)
           od_Wdeltap=1./Wdeltap
           if(rank_id.eq.0)write(*,*) od_Wdeltap
       
       
         elseif (i_kernel.eq.2) then !3D Quadratic 
c               Wab=      b1*(0.25*q*q-q+1)       	quadratic spline-kernel
c   	 	  0
c               W_r=      e1*(0.5*q-1)   derivative of quadratic spline-kernel
c            	  0
           a1 = 1./pi
           a2 = a1/(h*h*h)
           aa = a1/(h*h*h*h)
           adh=b1
           b1 = 15.*a2/16.
           e1 = 15.*aa/16.

           if(rank_id.eq.0)then
             write(*,*) 'Quadratic Kernel',aa
             write(*,*) 'b1,e1 ', b1,e1
           endif

         elseif(i_kernel.eq.3)then !3D Cubic Spline
       
c              Wab=      a2*(1-1.5*q*q+0.75*q*q*q)
c                        a24*(2-q)*(2-q)*(2-q)           cubic spline-kernel
c                        0
c              W_r=      c1*q + d1*q*q
c                        c2*(2-q)**2   derivative of cubic spline-kernel
c                        0
       
           a1 = 1./pi
           a2 = a1/(h*h*h)
           aa = a1/(h*h*h*h)
           adh=a2  
           a24 = 0.25*a2
       
           c1 = -3.*aa
           d1 = 9.*aa/4.
           c2 = -3.*aa/4.
       
           if(rank_id.eq.0)then
             write(*,*) 'cubic spline',i,aa,a24 
             write(*,*) c1,a2,d1
           endif

c          W(Delta_p): used to calculate fab to eliminate the
c                      Tensile Instability. We'll consider
c                      Delta_p=h/1.3 as suggested by Monaghan

           deltap=1./1.5    
           Wdeltap=a2*(1.-1.5*deltap*deltap+
     +        0.75*deltap*deltap*deltap)
           od_Wdeltap=1./Wdeltap
           if(rank_id.eq.0)write(*,*) od_Wdeltap
       
         elseif (i_kernel.eq.5) then  !3D Wendland Quintic
       
       
!             W=Awen*(1-qq/2)**4*(2*qq+1) 0<=r<=2*h
!             dw/dr=Bwen*qq*(1-qq/2)**3. 0<=r<=2*h
!             Awen(i)=7/(4*pi*h3)
!             Bwen(i)=-35/(4*pi*h4)

           Awen=0.41778/(h2*h)
           Bwen=-2.08891/(h2*h2)
           adh=Awen                            
           if(rank_id.eq.0)then
             write(*,*) 'Wendland kernel'
             write(*,*) Awen,Bwen
           endif
       
          !deltap_g=1/2	
           deltap=0.5
           Wdeltap=Awen*((1.0-deltap*0.5)**4.0)*(2.0*deltap+1.0)
           od_Wdeltap=1./Wdeltap
           if(rank_id.eq.0)write(*,*) od_Wdeltap
             
         else
           write(*,*) 'i_kernel=',i_kernel,
     +      ' is not a valid option !!!'
         endif

       if(i_kernel.eq.1)then            ! gaussian kernel
         adh=a2
       else if(i_kernel.eq.2)then		  ! quadratic kernel
         adh=b1
       else if(i_kernel.eq.3)then		  ! cubic kernel
         adh=a2
       else if(i_kernel.eq.5)then		  ! Wendland kernel
         adh=Awen
       endif

c
c ,,,, viscosity term eta2
c
       eta  = 0.1*h
       eta2 = eta*eta
       
c      -- Add small border region to prevent error --
c      -- when calculating icell.. in divide       --
       if(i_periodicOBs(1).ne.1.and.(.NOT.iCartTop_periodicity(1)))then
         xb_max = xb_max +h  !+ 0.1*h
         xb_min = xb_min -h  !- 0.1*h
       endif
       if(i_periodicOBs(2).ne.1.and.(.NOT.iCartTop_periodicity(2)))then
         yb_max = yb_max +h  !+ 0.1*h
         yb_min = yb_min -h  !- 0.1*h
       endif
       if(i_periodicOBs(3).ne.1.and.(.NOT.iCartTop_periodicity(3)))then
         zb_max = zb_max *1.8   !zb_max = zb_max + 0.1*h
         zb_min = zb_min -h  !- 0.1*h
       endif
c
c  ... determine xmin,xmax,ymin,ymax,zmin,zmax
       !- Limits of domain -       
c       xp_max_container = xmax
c       xp_min_container = xmin
c       yp_max_container = ymax
c       yp_min_container = ymin
c       zp_min_container = zmin
       xmax_container = xb_max 
       xmin_container = xb_min 
       ymax_container = yb_max 
       ymin_container = yb_min 
       zmax_container = zb_max
       zmin_container = zb_min
       
       !Periodic correction
       if(i_periodicOBs(1).eq.1.or.iCartTop_periodicity(1))then
         xmin_container = xmin_global
         xmax_container = xmax_global
       endif
       xmax_container_double = dble(xmax_container)
       xmin_container_double = dble(xmin_container)
       if(i_periodicOBs(2).eq.1.or.iCartTop_periodicity(2))then
         ymin_global = yb_min
         ymax_global = yb_max
         ymin_container = ymin_global
         ymax_container = ymax_global
       endif
       ymax_container_double = dble(ymax_container)
       ymin_container_double = dble(ymin_container)
       if(i_periodicOBs(3).eq.1.or.iCartTop_periodicity(3))then
         zmin_global = zb_min
         zmax_global = zb_max
         zmin_container = zmin_global
         zmax_container = zmax_global
       endif
       zmax_container_double = dble(zmax_container)
       zmin_container_double = dble(zmin_container)
       if(rank_id.eq.0)then
         print*
         write(*,*)'xmin_container, xmax_container = ',
     &              xmin_container, xmax_container
         write(*,*)'ymin_container, ymax_container = ',
     &              ymin_container, ymax_container
         write(*,*)'zmin_container, zmax_container = ',
     &              zmin_container, zmax_container
         print*
       endif
                     
       if(iopt_wavemaker.eq.1.and.i_paddleType.eq.2)then
         !xmin for piston-flap paddle extends further back
         !than initial xmin
         !xmin = X_PaddleCentre - 1.5*stroke
         if(rank_id.eq.0)then
          print*,'Correcting xmin for paddle '
          print*,'Current xmin   = ',xmin
          print*,'X_PaddleCentre = ',X_PaddleCentre
          print*,'stroke         = ',stroke
          print*
         endif
         xmin_check = X_PaddleCentre - 1.5*stroke
         if(xmin_check.lt.xmin)then
           xmin = xmin_check
         endif
       end if
       
       zmax_ini=zmax  ! used to keep moving obstacles 
                      ! inside the initial boundaries
       
       ! To place particles in a convenient place that leave the domain
       !xtrash=2.*xb_max
       !ytrash=0.
       !ztrash=0.
       if(iCartTop_periodicity(1))then
         xtrash=0.0
       else
         xtrash=2.*xb_max
       endif
       if(iCartTop_periodicity(2))then
         ytrash=0.0
       else
         ytrash=-yb_max
       endif
       if(iCartTop_periodicity(3))then
         ztrash=0.0
       else
         ztrash=-zb_max
       endif


      !--- MPI Code ---
      if(ymax.lt.yb_max)ymax=yb_max
      if(ymin.gt.yb_min)ymin=yb_min

      zmax_container = zb_max
      zmax_container_double = dble(zmax_container)

      if(rank_id.eq.0)then
       print*
       print*,'i_periodicOBs'
       print*,'X-Direction: ',i_periodicOBs(1)
       print*, 'xb_min ',xb_min,
     &         'xb_max ',xb_max
       print*,'Y-Direction: ',i_periodicOBs(2)
       print*, 'yb_min ',yb_min,
     &         'yb_max ',yb_max
       print*,'Z-Direction: ',i_periodicOBs(3)
       print*, 'zb_min ',zb_min,
     &         'zb_max ',zb_max
       print*
       print*
       print*,'i_periodicOBs'
       print*,'X-Direction: ',i_periodicOBs(1)
       print*, 'xmin_container ',xmin_container,
     &         'xmax_container ',xmax_container
       print*,'Y-Direction: ',i_periodicOBs(2)
       print*, 'ymin_container ',ymin_container,
     &         'ymax_container ',ymax_container
       print*,'Z-Direction: ',i_periodicOBs(3)
       print*, 'zmin_container ',zmin_container,
     &         'zmax_container ',zmax_container
       print*
       print*
       print*,'i_periodicOBs'
       print*,'X-Direction: ',i_periodicOBs(1)
       print*, 'xmin_container_double ',xmin_container_double
       print*, 'xmax_container_double ',xmax_container_double
       print*,'Y-Direction: ',i_periodicOBs(2)
       print*, 'ymin_container_double ',ymin_container_double
       print*, 'ymax_container_double ',ymax_container_double
       print*,'Z-Direction: ',i_periodicOBs(3)
       print*, 'zmin_container_double ',zmin_container_double
       print*, 'zmax_container_double ',zmax_container_double
       print*
      end if
      !stop

      zmin_global = zb_min
      zmax_global = zb_max

      xmin_local = xmin_rank - 2.0*h
      xmax_local = xmax_rank + 2.0*h

c      ymin_rank  = ymin
c      ymax_rank  = ymax
c     ymin_local = ymin_rank
c     ymax_local = ymax_rank

      if(ndim.eq.1)then
        !- y-dir -
        if(ymin.lt.real(ymin_container_double))then   !Correct these for more general topographies
          ymin_rank  = ymin
        else
          ymin_rank  = real(ymin_container_double)
        end if
        if(ymax.gt.real(ymax_container_double))then   !Correct these for more general topographies
          ymax_rank  = ymax
        else
          ymax_rank  = real(ymax_container_double)
        end if
        !- y-dir -
        if(zmin.lt.real(zmin_container_double))then   !Correct these for more general topographies
          zmin_rank  = zmin
        else
          zmin_rank  = real(zmin_container_double)
        end if
        if(zmax.gt.real(zmax_container_double))then   !Correct these for more general topographies
          zmax_rank  = zmax
        else
          zmax_rank  = real(zmax_container_double)
        end if
      endif
      if(ndim.eq.2)then
        if(ymin.lt.real(ymin_container_double))then   !Correct these for more general topographies
          ymin_rank  = ymin
        else
          ymin_rank  = real(ymin_container_double)
        end if
        if(ymax.gt.real(ymax_container_double))then   !Correct these for more general topographies
          ymax_rank  = ymax
        else
          ymax_rank  = real(ymax_container_double)
        end if
      endif
      ymin_local = ymin_rank - 2.0*h
      ymax_local = ymax_rank + 2.0*h
      zmin_local = zmin_rank - 2.0*h
      zmax_local = zmax_rank + 2.0*h

      xmin_localDouble = xmin_rankDouble - 2d0*h
      xmax_localDouble = xmax_rankDouble + 2d0*h
      ymin_localDouble = ymin_rankDouble - 2d0*h
      ymax_localDouble = ymax_rankDouble + 2d0*h
      zmin_localDouble = zmin_rankDouble - 2d0*h
      zmax_localDouble = zmax_rankDouble + 2d0*h
      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point

!       if(rank_id.eq.0)then
!         print*,
!      &  'rank_id, xmin_local, xmax_local, '
!      &        //' ymin_local, ymax_local, '
!      &        //' zmin_local, zmax_local  '
!       end if
!       call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point 
!       do i=0,n_procs -1
!         if(i.eq.rank_id)then
!           print*,
!      &     rank_id, xmin_local, xmax_local,
!      &              ymin_local, ymax_local,
!      &              zmin_local, zmax_local 
!         end if
!         call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
!       end do
!       call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point 

c
c  ... determine number of cells
c
      one_over_h  = 1.0/h
      one_over_2h = 1.0/(2.0*h)
       
      ncx = int( (xmax-xmin)*one_over_2h ) + 1
      ncy = int( (ymax-ymin)*one_over_2h ) + 1
      ncz = int( (zmax-zmin)*one_over_2h ) + 1
       
      ncx_global = int( (xmax_global-xmin_global)/(2.*h) ) + 1
      ncy_global = int( (ymax_global-ymin_global)/(2.*h) ) + 1
      ncz_global = int( (zmax_global-zmin_global)/(2.*h) ) + 1

      ncx_local  = nint( (xmax_local -xmin_local )/(2.*h) ) !+ 1
      if(ndim.eq.1)then
        if(.NOT.iCartTop_periodicity(1).and.
     &     .NOT.iCartTop_periodicity(2).and.
     &     .NOT.iCartTop_periodicity(3))then
          ncz_local  = nint( (zmax_local -zmin_local )/(2.*h) ) + 1
          ncy_local  = nint( (ymax_local -ymin_local )/(2.*h) ) + 1
        else
          if(.NOT.iCartTop_periodicity(2))then
            ncy_local  = nint( (ymax_local -ymin_local )/(2.*h) ) + 1
          else
            ncy_local  = nint( (ymax_local -ymin_local )/(2.*h) )
          endif
          if(.NOT.iCartTop_periodicity(3))then
            ncz_local  = nint( (zmax_local -zmin_local )/(2.*h) ) + 1
          else
            ncz_local  = nint( (zmax_local -zmin_local )/(2.*h) )
          endif
        endif
      elseif(ndim.eq.2)then
        ncz_local  = nint( (zmax_local -zmin_local )/(2.*h) )
        ncy_local  = nint( (ymax_local -ymin_local )/(2.*h) ) + 1    !<======= Why is this a problem? Use of NINT!
      elseif(ndim.eq.3)then
        ncz_local  = nint( (zmax_local -zmin_local )/(2.*h) )
        ncy_local  = nint( (ymax_local -ymin_local )/(2.*h) )    !<======= Why is this a problem? Use of NINT!
      endif     
       
      !- Adjustment for MPI X-Periodicity -
      if(iCartTop_periodicity(1))then
        if(rank_idx.eq.n_procs_x-1)then
          if(abs(xmax_rank - xmax_global).gt.2.0*h)then
            if(rank_idx.eq.0)then
              print*,'Problem with periodicity'
              print*,'abs(xmax_rank - xmax_global).gt.2.0*h'
              print*,'rank_id, rank_idx ',rank_id, rank_idx
              print*,'xmax_rank      ',xmax_rank
              print*,'xmax_global    ',xmax_global          
              !stop
              print*,'Reducing xmax_rank by successive 2h'
            endif
            i_xmax_rank_Check = 1
            do while (i_xmax_rank_Check.eq.1)
              xmax_rank = xmax_rank - two_h
              ncx_local = ncx_local - 1
              if(abs(xmax_rank - xmax_global).lt.1.02*two_h)then
                i_xmax_rank_Check = 0
              endif
              if(rank_idx.eq.0)then
                print*,'xmax_rank, ncx_local, i_xmax_rank_Check ',
     &                  xmax_rank, ncx_local, i_xmax_rank_Check
              endif
            enddo
            if(rank_idx.eq.0)print*,'- Adjusted xmax_rank = ',xmax_rank
          end if
          if(abs(xmax_rank - xmax_global).gt.0.02*two_h)then
          
            if(rank_idx.eq.0)then
              print*
              print*,'Adjusting length of final Rank'
              print*,'for MPI X-Periodicity'
              print*
            endif          
  
            num_2h_finalXRank = 
     &                1+int((xmax_global - xmin_local)*one_over_2h)
     
            if(rank_idx.eq.0)then
              print*,'- Initial State -'
              print*,'xmin_rank ',xmin_rank
              print*,'xmax_rank ',xmax_rank
              print*,'xlength_rank ',xlength_rank
              print*,'xmax_global ',xmax_global
              print*,'ncx_local   ',ncx_local
              print*,'num_2h_finalXRank ',num_2h_finalXRank
            endif

            if(ncx_local.gt.num_2h_finalXRank)then
          
             if(rank_idx.eq.0)print*,' --> Lengthening final rank by 2h'
             icell_2h_limit_finalXRank = num_2h_finalXRank - 1
            
            elseif(ncx_local.lt.num_2h_finalXRank)then
          
              if(rank_idx.eq.0)print*,' --> Keeping final rank length'
              icell_2h_limit_finalXRank = num_2h_finalXRank
            
              !Error Catching
              if(icell_2h_limit_finalXRank.ne.ncx_local - 1)then
                print*
                print*,'ERROR in getdata'
                print*,'icell_2h_limit_finalXRank.ne.ncx_local - 1'
                print*,'icell_2h_limit_finalXRank ',
     &                  icell_2h_limit_finalXRank
                print*,'ncx_local                 ',ncx_local
                stop
              endif              
            endif            
            ncx_local = icell_2h_limit_finalXRank + 1
            xmax_rank = xmax_global
            if(rank_idx.eq.0)then
              print*,'- Adjusted/Final State -'
              print*,'xmin_rank ',xmin_rank
              print*,'xmax_rank ',xmax_rank
              print*,'xmax_global ',xmax_global
              print*,'icell_2h_limit_finalXRank ',
     &                icell_2h_limit_finalXRank
              print*,'xmin_local, ncx_local ',xmin_local, ncx_local
              print*,'xmax_local, ncx_local ',xmax_local, ncx_local
              print*
            endif
          else
            !No change to 2h boxes
          endif     
        endif                  
      endif
      !- Adjustment for MPI Y-Periodicity -
      if(iCartTop_periodicity(2))then
        if(rank_idy.eq.n_procs_y-1)then
          if(abs(ymax_rank - ymax_global).gt.2.0*h)then
            if(rank_idx.eq.0.and.rank_idz.eq.0)then
              print*,'Problem with periodicity'
              print*,'abs(ymax_rank - ymax_global).gt.2.0*h'
              print*,'rank_id, rank_idy ',rank_id, rank_idy
              print*,'ymax_rank      ',ymax_rank
              print*,'ymax_global    ',ymax_global        
              !stop
              print*,'Reducing ymax_rank by successive 2h'
            endif
            i_ymax_rank_Check = 1
            do while (i_ymax_rank_Check.eq.1)
              ymax_rank = ymax_rank - two_h
              ncy_local = ncy_local - 1
              if(abs(ymax_rank - ymax_global).lt.1.02*two_h)then
                i_ymax_rank_Check = 0
              endif
              if(rank_idx.eq.0.and.rank_idz.eq.0)then
                print*,'ymax_rank, ncy_local, i_ymax_rank_Check ',
     &                  ymax_rank, ncy_local, i_ymax_rank_Check
              endif
            enddo
            if(rank_idx.eq.0.and.rank_idz.eq.0)then
              print*,'- Adjusted ymax_rank = ',ymax_rank
            endif
          end if
          if(abs(ymax_rank - ymax_global).gt.0.02*two_h)then
          
            if(rank_idx.eq.0.and.rank_idz.eq.0)then
              print*
              print*,'Adjusting length of final Rank'
              print*,'for MPI Y-Periodicity'
              print*
            endif        
    
            num_2h_finalYRank = 
     &                1+int((ymax_global - ymin_local)*one_over_2h)
     
            if(rank_idx.eq.0.and.rank_idz.eq.0)then
              print*,'- Initial State -'
              print*,'ymin_rank ',ymin_rank
              print*,'ymax_rank ',ymax_rank
              print*,'ymin_local ',ymin_local
              print*,'ymax_local ',ymax_local
              print*,'ylength_rank ',ylength_rank
              print*,'ymax_global ',ymax_global
              print*,'ncy_local   ',ncy_local
              print*,'num_2h_finalYRank ',num_2h_finalYRank
            endif

            if(ncy_local.gt.num_2h_finalYRank)then
          
             if(rank_idx.eq.0.and.rank_idz.eq.0)then
               print*,' --> Lengthening final rank by 2h'
             endif
             icell_2h_limit_finalYRank = num_2h_finalYRank - 1
            
            elseif(ncy_local.lt.num_2h_finalYRank)then
          
              if(rank_idx.eq.0.and.rank_idz.eq.0)then
                print*,' --> Keeping final rank length'
              endif
              icell_2h_limit_finalYRank = num_2h_finalYRank
            
              !Error Catching
              if(icell_2h_limit_finalYRank.ne.ncy_local - 1)then
                print*
                print*,'ERROR in getdata'
                print*,'icell_2h_limit_finalYRank.ne.ncy_local - 1'
                print*,'icell_2h_limit_finalYRank ',
     &                  icell_2h_limit_finalYRank
                print*,'ncy_local                 ',ncy_local
                stop
              endif              
            endif            
            ncy_local = icell_2h_limit_finalYRank + 1
            ymax_rank = ymax_global
            if(rank_idx.eq.0.and.rank_idz.eq.0)then
              print*,'- Adjusted/Final State -'
              print*,'ymin_rank ',ymin_rank
              print*,'ymax_rank ',ymax_rank
              print*,'ymax_global ',ymax_global
              print*,'icell_2h_limit_finalYRank ',
     &                icell_2h_limit_finalyRank
              print*,'ymin_local, ncy_local ',ymin_local, ncy_local
              print*,'ymax_local, ncy_local ',ymax_local, ncy_local
              print*
            endif
          else
            !No change to 2h boxes
          endif     
        endif                  
      endif
      !- Adjustment for MPI Z-Periodicity -
      if(iCartTop_periodicity(3))then
        if(rank_idz.eq.n_procs_z-1)then
          if(abs(zmax_rank - zmax_global).gt.2.0*h)then
            if(rank_idx.eq.0.and.rank_idy.eq.0)then
              print*,'Problem with periodicity'
              print*,'abs(zmax_rank - zmax_global).gt.2.0*h'
              print*,'rank_id, rank_idz ',rank_id, rank_idz
              print*,'zmax_rank      ',zmax_rank
              print*,'zmax_global    ',zmax_global        
              !stop
              print*,'Reducing zmax_rank by successive 2h'
            endif
            i_zmax_rank_Check = 1
            do while (i_zmax_rank_Check.eq.1)
              zmax_rank = zmax_rank - two_h
              ncz_local = ncz_local - 1
              if(abs(zmax_rank - zmax_global).lt.1.02*two_h)then
                i_zmax_rank_Check = 0
              endif
              if(rank_idx.eq.0.and.rank_idy.eq.0)then
                print*,'zmax_rank, ncz_local, i_zmax_rank_Check ',
     &                  zmax_rank, ncz_local, i_zmax_rank_Check
              endif
            enddo
            if(rank_idx.eq.0.and.rank_idy.eq.0)then
              print*,'- Adjusted zmax_rank = ',zmax_rank
            endif
          end if
          if(abs(zmax_rank - zmax_global).gt.0.02*two_h)then
          
            if(rank_idx.eq.0.and.rank_idy.eq.0)then
              print*
              print*,'Adjusting length of final Rank'
              print*,'for MPI Z-Periodicity'
              print*
            endif        
    
            num_2h_finalZRank = 
     &                1+int((zmax_global - zmin_local)*one_over_2h)
     
            if(rank_idx.eq.0.and.rank_idy.eq.0)then
              print*,'- Initial State -'
              print*,'zmin_rank ',zmin_rank
              print*,'zmax_rank ',zmax_rank
              print*,'zlength_rank ',zlength_rank
              print*,'zmax_global ',zmax_global
              print*,'ncz_local   ',ncz_local
              print*,'num_2h_finalZRank ',num_2h_finalZRank
            endif

            if(ncz_local.gt.num_2h_finalZRank)then
          
             if(rank_idx.eq.0.and.rank_idy.eq.0)then
               print*,' --> Lengthening final rank by 2h'
             endif
             icell_2h_limit_finalZRank = num_2h_finalZRank - 1
            
            elseif(ncz_local.lt.num_2h_finalZRank)then
          
              if(rank_idx.eq.0.and.rank_idy.eq.0)then
                print*,' --> Keeping final rank length'
              endif
              icell_2h_limit_finalZRank = num_2h_finalZRank
            
              !Error Catching
              if(icell_2h_limit_finalZRank.ne.ncz_local - 1)then
                print*
                print*,'ERROR in getdata'
                print*,'icell_2h_limit_finalZRank.ne.ncz_local - 1'
                print*,'icell_2h_limit_finalZRank ',
     &                  icell_2h_limit_finalZRank
                print*,'ncz_local                 ',ncz_local
                stop
              endif              
            endif            
            ncz_local = icell_2h_limit_finalZRank + 1
            zmax_rank = zmax_global
            if(rank_idx.eq.0.and.rank_idy.eq.0)then
              print*,'- Adjusted/Final State -'
              print*,'zmin_rank ',zmin_rank
              print*,'zmax_rank ',zmax_rank
              print*,'zmax_global ',zmax_global
              print*,'icell_2h_limit_finalZRank ',
     &                icell_2h_limit_finalZRank
              print*,'zmin_local, ncz_local ',zmin_local, ncz_local
              print*,'zmax_local, ncz_local ',zmax_local, ncz_local
              print*
            endif
          else
            !No change to 2h boxes
          endif     
        endif                  
      endif
      
      !- Periodic Correction -
      if(i_periodicOBs(1).eq.1)then
        ncx_min = int((xmax_container-xmin)*one_over_2h)
        if(ncx_local.gt.ncx_min)ncx_local = ncx_min
        !print*,'Rank=',rank_id,'Corrected ncx for X-Periodicity'
        if(rank_id.eq.0)then
          print*,'Correcting ncx for all ranks for X-Periodicity'
        endif
      endif
      if(i_periodicOBs(2).eq.1)then
        ncy_min = int((ymax_container-ymin)*one_over_2h)
        if(ncy_local.gt.ncy_min)ncy_local = ncy_min
        !print*,'Rank=',rank_id,'Corrected ncy for Y-Periodicity'
        if(rank_id.eq.0)then
          print*,'Correcting ncy for all ranks for Y-Periodicity'
        endif
      endif
      if(i_periodicOBs(3).eq.1)then
        ncz_min = int((zmax_container-zmin)*one_over_2h)
        if(ncz_local.gt.ncz_min)ncz_local = ncz_min
        !print*,'Rank=',rank_id,'Corrected ncz for Z-Periodicity'
        if(rank_id.eq.0)then
          print*,'Correcting ncz for all ranks for Z-Periodicity'
        endif
      endif
         
      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      nsheet_global = ncx_global*ncy_global ! Number of cells in entire XY sheet
      nct_global = nsheet_global

      nsheet_local  = ncx_local*ncy_local ! Number of cells in a XY sheet
      nct_local = nsheet_local*ncz_local
      nct_ini_local=nct_local
       
496   format(a41,i4,4(' ',i5,' '))
c      if(rank_id.eq.0)then
c        print*
c        print*,'ncx_global   , ncy_global ',ncx_global,ncy_global
c        print*,'nsheet_global, nct_global ',nsheet_global, nct_global
c        print*
c      end if
      call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point

      if(1.eq.2)then  !Set to 1.eq.1 to activate screen printout
       do i=0,n_procs-1
        if(i.eq.rank_id)then
c          write(*,496)'rank_id, ncx_local, ncy_local, ncz_local ',
c     &                 rank_id, ncx_local, ncy_local, ncz_local
          print*,rank_id, ncx_local, ncy_local, ncz_local, 
     &                    nsheet_local, nct_local
        end if
        call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
       end do
       call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
       do i=0,n_procs-1
        if(i.eq.rank_id)then
c          write(*,496)'rank_id, nsheet_local, nct_local ',
c     &                 rank_id, nsheet_local, nct_local
        end if
        call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
       end do
       call MPI_BARRIER(grid_comm, ierr)   !Synchronise all processes to this point
      endif

      if(nct_local .ge. nct_max) then
        print*
        print*,'ERROR in getdata.f'
        print*,'No. of cells exceeds nct_max in common.3D'
        print*,'rank_id  ',rank_id
        print*,'nct_local ',nct_local
        print*,'nct_max   ',nct_max
        print*
        call MPI_ABORT(MPI_COMM_WORLD, rc, ierr)
        stop
      endif 

c
c     -- determine numbers to be used in the marching --
c
c      !-- Original 3-D Call numbers --
c      ncall1=ncx-1        !North-West
c      ncall2=ncx+1        !North-East
c      ncall3=nsheet-1     !Up & West
c      ncall4=nsheet+1     !Up & East
c      ncall5=nsheet+ncx   !Up & North
c      ncall6=ncall5-1     !Up & North-West
c      ncall7=ncall5+1     !Up & North-East
c      ncall8=nsheet-ncx   !Up & South
c      ncall9=ncall8-1     !Up & South-West
c      ncall10=ncall8+1    !Up & South-East
       
      !-- New 3-D Call numbers --
      ncall1  = -ncx_local+1               !South-East
      ncall2  =  ncx_local+1               !North-East
      ncall3  = -nsheet_local+1            !East       & Down
      ncall4  =  nsheet_local+1            !East       & Up
      ncall5  =  nsheet_local+ncx_local    !North      & Up
      ncall6  = -nsheet_local+ncx_local +1 !North-East & Down
      ncall7  =  ncall5+1                  !North-East & Up
      ncall8  =  nsheet_local-ncx_local    !South      & Up
      ncall9  = -nsheet_local-ncx_local+1  !South-East & Down
      ncall10 =  ncall8+1                  !South-East & Up
       
      ncall2_SE = -ncx_local+1
      ncy_start = 1
      ncy_finish = ncy_local
c      
c     --- Periodic ncall numbers for Y-direction periodicity ---
c       ncall11 = ncx - nsheet      !North Y-Periodic
c       ncall12 = ncx-1 - nsheet    !North-West Y-Periodic
c       ncall13 = ncx+1 - nsheet    !North-East Y-Periodic
c       ncall14 = ncx - 2*nsheet    !Down & North Y-Periodic
c       ncall15 = ncx-1 - 2*nsheet  !Down & North-West Y-Periodic
c       ncall16 = ncx+1 - 2*nsheet  !Down & North-East Y-Periodic
c       ncall17 = ncx               !Up & North Y-Periodic
c       ncall18 = ncx-1             !Up & North-West Y-Periodic
c       ncall19 = ncx+1             !Up & North-East Y-Periodic
        
      !-- Adaptive Simulation Update domain lengths of neighbouring processes --
      if(i_MPI_Adapt.eq.1)then
        nFP_local = np_local - nb_local*mod(iBC,2)
        nFP_local_East = 0
        nFP_local_West = 0
        if(n_procs_x.gt.1)then
          xmin_rank_East = xmax_rank
          call MPI_SENDRECV(
     &      nFP_local      , 1, MPI_INTEGER, west, 1,
     &      nFP_local_East , 1, MPI_INTEGER, east, 1,
     &      grid_comm, status, ierr)
          call MPI_SENDRECV(
     &      nFP_local      , 1, MPI_INTEGER, east, 1,
     &      nFP_local_West , 1, MPI_INTEGER, west, 1,
     &      grid_comm, status, ierr)
          call MPI_SENDRECV(
     &      xmax_rank        , 1, MPI_REAL, west, 1,
     &      xmax_rank_East   , 1, MPI_REAL, east, 1,
     &      grid_comm, status, ierr)
        endif  
        nFP_local_North = 0
        nFP_local_South = 0
        if(n_procs_y.gt.1)then
          ymin_rank_North = ymax_rank
          call MPI_SENDRECV(
     &      nFP_local      , 1, MPI_INTEGER, south, 1,
     &      nFP_local_North, 1, MPI_INTEGER, north, 1,
     &      grid_comm, status, ierr)
          call MPI_SENDRECV(
     &      nFP_local      , 1, MPI_INTEGER, north, 1,
     &      nFP_local_South, 1, MPI_INTEGER, south, 1,
     &      grid_comm, status, ierr)
          call MPI_SENDRECV(
     &      ymax_rank        , 1, MPI_REAL, south, 1,
     &      ymax_rank_North  , 1, MPI_REAL, north, 1,
     &      grid_comm, status, ierr)
        endif  
        nFP_local_Above = 0
        nFP_local_Below = 0
        if(n_procs_z.gt.1)then
          zmin_rank_Above = zmax_rank
          call MPI_SENDRECV(
     &      nFP_local      , 1, MPI_INTEGER, below, 1,
     &      nFP_local_Above, 1, MPI_INTEGER, above, 1,
     &      grid_comm, status, ierr)
          call MPI_SENDRECV(
     &      nFP_local      , 1, MPI_INTEGER, above, 1,
     &      nFP_local_Below, 1, MPI_INTEGER, below, 1,
     &      grid_comm, status, ierr)
          call MPI_SENDRECV(
     &      zmax_rank        , 1, MPI_REAL, below, 1,
     &      zmax_rank_Above  , 1, MPI_REAL, above, 1,
     &      grid_comm, status, ierr)
        endif  
       endif 

      
      !- Identify Extent of MPI_Datatypes -
      call MPI_TYPE_EXTENT(MPI_REAL            , iextent_REAL, ierr)
      call MPI_TYPE_EXTENT(MPI_DOUBLE_PRECISION, iextent_DBLE, ierr)
      if(rank_id.eq.0)then
        print*
        print*,'-- Precision of XYZ Variables --'
        print*,'iextent_REAL ',iextent_REAL
        print*,'iextent_DBLE ',iextent_DBLE
        print*,'kind(0.0)    ',kind(0.0)
        print*,'kind(0D0)    ',kind(0D0)
        print*,'kind_XYZ     ',kind_XYZ
        if(kind_XYZ.eq.iextent_REAL)then
          print*,'--> Using SINGLE PRECISION for XYZ variables'
        elseif(kind_XYZ.eq.iextent_DBLE)then
          print*,'--> Using DOUBLE PRECISION for XYZ variables'
        endif
        if(iextent_REAL.ne.kind(0.0))then
          print*
          print*,'ERROR in getdata_MPI_3D.f '
          print*,'iextent_REAL.ne.kind(0.0) '
          print*,'iextent_REAL ',iextent_REAL
          print*,'kind(0.0)    ',kind(0.0)
          stop
        elseif(iextent_DBLE.ne.kind(0D0))then
          print*
          print*,'ERROR in getdata_MPI_3D.f '
          print*,'iextent_DBLE.ne.kind(0D0) '
          print*,'iextent_DBLE ',iextent_DBLE
          print*,'kind(0D0)    ',kind(0D0)
          stop
        endif
      endif
      if(kind_XYZ.eq.kind(0.0))then
        iextent_XYZ   = iextent_REAL
        iextent_Ptemp = iextent_REAL
        MPI_TYPE_XYZ  = MPI_REAL
      elseif(kind_XYZ.eq.kind(0D0))then
        iextent_XYZ   = iextent_DBLE
        iextent_Ptemp = iextent_REAL
        MPI_TYPE_XYZ  = MPI_DOUBLE_PRECISION
      else
        print*
        if(rank_id.eq.0)then
          print*,'ERROR in getdata_MPI_2D.f'
          print*,'kind_XYZ.ne.kind(0.0)'
          print*,'kind_XYZ.ne.kind(0D0)'
          print*,'kind_XYZ     ',kind_XYZ
          print*,'kind(0.0)    ',kind(0.0)
          print*,'kind(0D0)    ',kind(0D0)
        endif
        stop
      endif
                
      !--- Create Derived DataTypes ---
      !-- SendRecv_Data.f --
      call MPI_TYPE_VECTOR(3, nGuestmax, nGuestmax, MPI_TYPE_XYZ, 
     &                     iP_xyzDataTypeA, ierr)   !Note: Use of MPI_TYPE_XYZ
      call MPI_TYPE_COMMIT(iP_xyzDataTypeA, ierr)
      call MPI_TYPE_VECTOR(23, nGuestmax, nGuestmax, MPI_REAL,  
     &                     iP_DataTypeSR , ierr)
      call MPI_TYPE_COMMIT(iP_DataTypeSR , ierr)
      call MPI_TYPE_VECTOR(13, nGuestmax, nGuestmax, MPI_REAL,  
     &                     iBP_DataType, ierr)
      call MPI_TYPE_COMMIT(iBP_DataType, ierr)
      call MPI_TYPE_VECTOR(6, nGuestmax, nGuestmax, MPI_REAL,  
     &                     iTau_DataType, ierr)
      call MPI_TYPE_COMMIT(iTau_DataType, ierr)
      call MPI_TYPE_VECTOR(1, 4, 4, MPI_INTEGER,  
     &                     iInt_IntegerType4, ierr)
      call MPI_TYPE_COMMIT(iInt_IntegerType4, ierr)
      !-- SendRecv_Data_Conservative.f --
      call MPI_TYPE_VECTOR(38, nGuestmax, nGuestmax, MPI_REAL,  
     &                     iP_DataTypeSRC, ierr)
      call MPI_TYPE_COMMIT(iP_DataTypeSRC, ierr)
      !-- update_accnSummations.f --
      call MPI_TYPE_VECTOR(22, nGuestmax, nGuestmax, MPI_REAL,  
     &                     iaccn_DataTypeUA , ierr)
      call MPI_TYPE_COMMIT(iaccn_DataTypeUA , ierr)
      !-- update_accnSummations_Conservative.f --
      call MPI_TYPE_VECTOR(32, nGuestmax, nGuestmax, MPI_REAL,  
     &                     iaccn_DataTypeUAC, ierr)
      call MPI_TYPE_COMMIT(iaccn_DataTypeUAC, ierr)
      !-- SendRecv_updatedKernelSummations.f --
      call MPI_TYPE_VECTOR(5, nGuestmax, nGuestmax, MPI_REAL,  
     &                     isumW_DataType, ierr)
      call MPI_TYPE_COMMIT(isumW_DataType, ierr)
      !-- update_MLS_Summations.f --
      call MPI_TYPE_VECTOR(16,nGuestmax, nGuestmax, MPI_REAL,  
     &                     iMLS_DataType1, ierr)
      call MPI_TYPE_COMMIT(iMLS_DataType1, ierr)
      !-- SendRecv_MLS_Matrices.f --
      call MPI_TYPE_VECTOR(4, nGuestmax, nGuestmax, MPI_REAL,  
     &                     iMLS_DataType2, ierr)
      call MPI_TYPE_COMMIT(iMLS_DataType2, ierr)
      !-- SendRecv_filteredDensities.f --
      call MPI_TYPE_VECTOR(5, nGuestmax, nGuestmax, MPI_REAL,  
     &                     i_filteredDensityType, ierr)
      call MPI_TYPE_COMMIT(i_filteredDensityType, ierr)
      !-- update_KGC_Summations.f --
      call MPI_TYPE_VECTOR(9, nGuestmax, nGuestmax, MPI_REAL,  
     &                     iKGC_DataType1, ierr)
      call MPI_TYPE_COMMIT(iKGC_DataType1, ierr)
      !-- SendRecv_KGC_Matrices.f --
      call MPI_TYPE_VECTOR(9, nGuestmax, nGuestmax, MPI_REAL,  
     &                     iKGC_DataType2, ierr)
      call MPI_TYPE_COMMIT(iKGC_DataType2, ierr)
      !-- index_check.f --
      call MPI_TYPE_VECTOR(3, nm_max, nm_max, MPI_TYPE_XYZ,  
     &                     iP_xyzDataTypeB, ierr)   !Note: Use of MPI_TYPE_XYZ
      call MPI_TYPE_COMMIT(iP_xyzDataTypeB, ierr)
      call MPI_TYPE_VECTOR(31, nm_max, nm_max, MPI_REAL,  
     &                     iP_DataTypeIC , ierr)
      call MPI_TYPE_COMMIT(iP_DataTypeIC , ierr)
      call MPI_TYPE_VECTOR(5, nm_max, nm_max, MPI_REAL,  
     &                     iP_DataTypeV, ierr)
      call MPI_TYPE_COMMIT(iP_DataTypeV, ierr)
      call MPI_TYPE_VECTOR(1, 5, 5, MPI_INTEGER,  
     &                     iInt_IntegerType5, ierr)
      call MPI_TYPE_COMMIT(iInt_IntegerType5, ierr)
c      !-- index_check_Conservative.f --
      call MPI_TYPE_VECTOR(45, nm_max, nm_max, MPI_REAL,  
     &                     iP_DataTypeICC, ierr)
      call MPI_TYPE_COMMIT(iP_DataTypeICC, ierr)
      !-- update_BPInfo_onRoot.f --
      call MPI_TYPE_VECTOR(3, nb_max, nb_max, MPI_TYPE_XYZ,  
     &                     iBP_xyz_Data_Type, ierr)
      call MPI_TYPE_COMMIT(iBP_xyz_Data_Type      , ierr)
      !-- rigid_body_motion_MPI_2D.f --
      call MPI_TYPE_VECTOR(3, num_FB_max, num_FB_max, MPI_TYPE_XYZ,  
     &                     irigidBody_Data_Type1 , ierr)   !Note: Use of MPI_TYPE_XZ
      call MPI_TYPE_COMMIT(irigidBody_Data_Type1 , ierr)
      call MPI_TYPE_VECTOR(12, num_FB_max, num_FB_max, MPI_REAL,  
     &                     irigidBody_Data_Type2 , ierr)
      call MPI_TYPE_COMMIT(irigidBody_Data_Type2 , ierr)
      !-- update_vorticitySummations.f --
      call MPI_TYPE_VECTOR(6 , nGuestmax, nGuestmax, MPI_REAL,  
     &                     ivort_DataType , ierr)
      call MPI_TYPE_COMMIT(ivort_DataType , ierr)


      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      if(rank_id.eq.0)then
        print*
        print*,'getdata.f finished '
        print*,'Root Processor, rank_id = ',rank_id
        print*,'i_MPI_Adapt      ',i_MPI_Adapt
!         print*,'nbf_local        ',nbf_local
!         print*,'nbfm_local       ',nbfm_local
!         print*,'nbfreem_local    ',nbfreem_local
!         print*,'nb_local         ',nb_local
!         print*,'np_local         ',np_local
!         print*,'ncx_local        ',ncx_local
!         print*,'ncz_local        ',ncz_local
!         print*,'nct_local        ',nct_local
!         print*,'nsheet_local     ',nsheet_local
        print*
      end if
      
      
      !- Optimise MPI Partitions once at beginning of simulation -
      if(i_MPI_Adapt.eq.1.and.n_procs.gt.1)then
        xrank_length_max = 6.05*h
        yrank_length_max = xrank_length_max
        zrank_length_max = xrank_length_max
        call Adapt_MPI_ini

        !i_MPI_Adapt = 0
      endif
      
      !stop
              
      return
      end
       
c     ___________________
