c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.


      subroutine step
c
      include 'common.3D'

      dt2 = 0.5*dt

c	Symplectic Method

c  ...  compute acceleration
c
      
c      !-- Debug Code------
c      itime_check = 10e8   !0    !10e8   !0    !
c      i_rank_check = 0
c      i_ParticleCheck = 2139  !2283   !697      
      
      if(rank_id.eq.0.and.itime/10*10 .eq. itime) then
        write(*,*) 'In step:   time = ',time,' itime = ',itime
      endif
       
       nb_image_local      = nb_local
       np_image_local      = np_local
       nbf_image_local     = nbf_local
       nbfm_image_local    = nbfm_local
       nbfreem_image_local = nbfreem_local
       nbp1_local = nb_local + 1
       nfbp1_local = nbf_local + 1     

c      !- Diagnostic Info -
c      if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
c        print*
c        print*,'In step_Symplectic.f BEFORE anything'
c        i =  i_ParticleCheck
c        print*,'i, xp, zp ',i,xp(i),zp(i)
c        print*,'up, wp    ',up(i),wp(i)
c        print*,'rhop(i) ',rhop(i)
c        print*,'p(i)    ',p(i)
c        print*,'sum_wab(i) ',sum_wab(i)
c        print*,'pVol(i) ',pVol(i)
c        if(i.lt.nbp1)then
c          print*,'xnb, znb    ',xnb(i),znb(i)
c          print*,'xtb, ztb    ',xtb(i),ztb(i)
c
c        endif
c        print*,'nb_local ',nb_local
c        print*,'np_local ',np_local
c        print*,'nbf_image_local       = ',nbf_image_local
c        print*,'nbfm_image_local = ',nbfm_image_local
c        print*,'nbfreem_image_local     = ',nbfreem_image_local
c        print*,'nb_image_local ',nb_image_local
c        print*,'np_image_local ',np_image_local
c        if(1.eq.2)then
c          !-- Image Print-out --
c          do ipcount=1,np_local
c            if(ipcount.le.nbf_local)then
c              i = ip_index_BP_local_1(ipcount)
c            else if(ipcount.le.nbfm_local)then
c              i = ip_index_BP_local_2(ipcount-nbf_local)
c            else if(ipcount.le.nbfreem_local)then
c              i = ip_index_BP_local_3(ipcount-nbfm_local)
c            else
c              i = ip_index_FP_local(ipcount-nb_local)
c            end if
c            print*,'ipcount -> i, Type, xp, zp',
c     &                  ipcount,i,i_particleType(i),xp(i),zp(i)
c          end do
c        endif
c       print*
c      end if
       
c     --- Primary Divide for Resident Fluid Particles only ---
       i_resident_0 = 1  !Resident Moving Particles
       call check_limits_3D      
       call ini_divide(2)
       call divide(nbp1_local,np_local,2,i_resident_0)   !3rd argument = kind_p)  

c      --- Primary Divide for Resident Moving Boundary Particles only ---
       !call recover_list   !Why here nad not below? (see step_predictor_corrector_MPI_2D.f)
       if(iopt_movingObject.eq.1)then
         call recover_list
         call divide(nbfp1_local,nb_local,1,i_resident_0)   !3rd argument = kind_p)
       endif

      call divide_ParallelPrep(1)      !argument 0/1 selects densityFilter option

      
      call ac         


c      !-- Debug Code------
c      if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
c        print*
c        print*,'AFTER AC, PREDICTOR, before CORRECT'
c        print*,'rank_id, itime, dt ',rank_id, itime, dt
c        i = i_ParticleCheck  
c        print*,'i = ',i
c        print*,'xp, zp  ',xp(i),zp(i)
c        print*,'up, wp  ',up(i),wp(i)
c        print*,'rhop, p,  pVol, pm ',rhop(i),p(i) ,pVol(i),pm(i)
c        print*,'rhoo, po, Volo, pm ',rhoo(i),po(i),Volo(i),pm(i)
c        print*,'VolTotalE   , VolTotalEo ',
c     &          VolTotalE(i), VolTotalEo(i) 
c        print*,'aTE(i) ',aTE(i)
c        print*,'TEp, TotalE ',TEp(i),TotalE(i)
c        print*,'ar(i), aVol(i) ',ar(i), aVol(i)
c        print*,'Volrhoo(i), Volrho(i) ',Volrhoo(i), Volrho(i) 
c        print*,'ax(i), Volrhou(i) ',ax(i), Volrhou(i)
cc       print*,'ay(i), Volrhov(i) '       
c        print*,'az(i), Volrhow(i) ',az(i), Volrhow(i)
c        print*,'pVol(i), Volo(i) ',pVol(i), Volo(i)
c        print*,'dudx_CSPH(i)',dudx_CSPH(i)
c        print*,'dudz_CSPH(i)',dudz_CSPH(i)
c        print*,'dwdx_CSPH(i)',dwdx_CSPH(i)
c        print*,'dwdz_CSPH(i)',dwdz_CSPH(i)
c        print*,'drhodx_CSPH(i)',drhodx_CSPH(i)
cc       print*,'drhody_CSPH(i)',drhody_CSPH(i)
c        print*,'drhodz_CSPH(i)',drhodz_CSPH(i)
c        print*,'sum_wab(i) ',sum_wab(i)
c        write(*,859)'ax(i) ',ax(i)
cc       write(*,859)'ay(i) '
c        write(*,859)'az(i) ',az(i)
c      endif
c
c  ... compute corrections to:
c         (a) rate of change of velocity due to
c             (i)  body forces, and
c             (ii) boundary forces
c
c         (b) rate of change of position (free-surface, XSPH)
c
C
      call correct


c	To calculate time step 
      if (ivar_dt.eq.1) then
	    call variable_time_step  
	    ddt_p=dt_new
      endif
	

c
c  ... predictor
c

      do ipcount=nstart,np_local
         call ipcount_to_i(ipcount,i)
         xo(i)   = xp(i)
         yo(i)   = yp(i)        
         zo(i)   = zp(i)
         uo(i)   = up(i)
         vo(i)   = vp(i)       
         wo(i)   = wp(i)
         po(i)   = p(i)
         rhoo(i) = rhop(i)
         TEo(i)  = TEp(i)

      enddo

      do ipcount=nb_local+1,np_local
         call ipcount_to_i(ipcount,i)
         rhop(i) = rhoo(i) + dt2*rdot(i)
         pVol(i) = pm(i)/rhop(i)
         TEp(i)=TEo(i)+dt2*TEdot(i)
         call equation_of_state(rhop(i),TEp(i),p(i),cs(i))
      end do
      
      
      if(iBC.eq.2)then	!Hughes & Grahams 2009 correction 
         nstep_DBC=nstep_DBC+1
         iDBC=0
         if(mod(nstep_DBC,ndt_DBCPerform).eq.0)then
           do ipcount=1,nb_local
              call ipcount_to_i(ipcount,i)
              rhop(i) = rhoo(i) + dt2*rdot(i)
              if (rhop(i).lt.rho0) rhop(i)=rho0
              pVol(i) = pm(i)/rhop(i)
              TEp(i)=TEo(i)+dt2*TEdot(i)
              call equation_of_state(rhop(i),TEp(i),p(i),cs(i))
           enddo  
           iDBC=1
           nstep_DBC=0
         endif
      endif 

      
      do ipcount=nb_local+1,np_local
         i = ip_index_FP_local(ipcount-nb_local)
         
         xp(i) = xo(i) + dt2*xdot(i)
         yp(i) = yo(i) + dt2*ydot(i)        
         zp(i) = zo(i) + dt2*zdot(i)
        
         up(i) = uo(i) + dt2*udot(i)
         vp(i) = vo(i) + dt2*vdot(i)         
         wp(i) = wo(i) + dt2*wdot(i)
         
      enddo
      
     
c      !-- Debug Code------
c      if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
c        print*
c        print*,'AFTER CORRECT, PREDICTOR, before movingOBJECTS'
c        print*,'rank_id, itime, dt ',rank_id, itime, dt
c        i = i_ParticleCheck  
c        print*,'i = ',i
c        print*,'xp, zp  ',xp(i),zp(i)
c        print*,'up, wp  ',up(i),wp(i)
c        print*,'rhop, p,  pVol, pm ',rhop(i),p(i) ,pVol(i),pm(i)
c        print*,'rhoo, po, Volo, pm ',rhoo(i),po(i),Volo(i),pm(i)
c        print*,'VolTotalE   , VolTotalEo ',
c     &          VolTotalE(i), VolTotalEo(i) 
c        print*,'aTE(i) ',aTE(i)
c        print*,'TEp, TotalE ',TEp(i),TotalE(i)
c        print*,'ar(i), aVol(i) ',ar(i), aVol(i)
c        print*,'Volrhoo(i), Volrho(i) ',Volrhoo(i), Volrho(i) 
c        print*,'ax(i), Volrhou(i) ',ax(i), Volrhou(i)
cc       print*,'ay(i), Volrhov(i) '       
c        print*,'az(i), Volrhow(i) ',az(i), Volrhow(i)
c        print*,'pVol(i), Volo(i) ',pVol(i), Volo(i)
c        print*,'dudx_CSPH(i)',dudx_CSPH(i)
c        print*,'dudz_CSPH(i)',dudz_CSPH(i)
c        print*,'dwdx_CSPH(i)',dwdx_CSPH(i)
c        print*,'dwdz_CSPH(i)',dwdz_CSPH(i)
c        print*,'drhodx_CSPH(i)',drhodx_CSPH(i)
cc       print*,'drhody_CSPH(i)',drhody_CSPH(i)
c        print*,'drhodz_CSPH(i)',drhodz_CSPH(i)
c        print*,'sum_wab(i) ',sum_wab(i)
c        write(*,859)'ax(i) ',ax(i)
cc       write(*,859)'ay(i) '
c        write(*,859)'az(i) ',az(i)
cc       !stop
c      end if
c      !---------------------

      call movingObjects(0)
      if(iBC.eq.1.and.iopt_FloatingBodies.eq.1)then   !Repulsive Force BC
        i_particleTypeChoice = 3   !Free-moving BPs
        call updateNormals_3D(nbfreem_local+1,nb_local,
     &                          i_particleTypeChoice)   
      end if

c
c  ...  corrector
c
       nb_image_local = nb_local
       np_image_local = np_local
       nbf_image_local       = nbf_local
       nbfm_image_local = nbfm_local
       nbfreem_image_local     = nbfreem_local
       nbp1_local  = nb_local + 1
       nfbp1_local = nbf_local + 1     
      
c     --- Primary Divide for Resident Fluid Particles only ---
       i_resident_0 = 1  !Resident Moving Particles
       call check_limits_3D      
       call ini_divide(2)
       call divide(nbp1_local,np_local,2,i_resident_0)   !3rd argument = kind_p)  

c      --- Primary Divide for Resident Moving Boundary Particles only ---
       !call recover_list   !Why here nad not below? (see step_predictor_corrector_MPI_2D.f)
       if(iopt_movingObject.eq.1)then
         call recover_list
         call divide(nbfp1_local,nb_local,1,i_resident_0)   !3rd argument = kind_p)
       endif

      call divide_ParallelPrep(0)   !argument 0/1 selects densityFilter option

      
      call ac
      call correct

c      !-- Debug Code------
c      if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
c        print*
c        print*,'AFTER CORRECT, CORRECTOR, before movingOBJECTS'
c        print*,'rank_id, itime, dt ',rank_id, itime, dt
c        i = i_ParticleCheck  
c        print*,'i = ',i
c        print*,'xp, zp  ',xp(i),zp(i)
c        print*,'up, wp  ',up(i),wp(i)
c        print*,'rhop, p,  pVol, pm ',rhop(i),p(i) ,pVol(i),pm(i)
c        print*,'rhoo, po, Volo, pm ',rhoo(i),po(i),Volo(i),pm(i)
c        print*,'VolTotalE   , VolTotalEo ',
c     &          VolTotalE(i), VolTotalEo(i) 
c        print*,'aTE(i) ',aTE(i)
c        print*,'TEp, TotalE ',TEp(i),TotalE(i)
c        print*,'ar(i), aVol(i) ',ar(i), aVol(i)
c        print*,'Volrhoo(i), Volrho(i) ',Volrhoo(i), Volrho(i) 
c        print*,'ax(i), Volrhou(i) ',ax(i), Volrhou(i)
cc       print*,'ay(i), Volrhov(i) '       
c        print*,'az(i), Volrhow(i) ',az(i), Volrhow(i)
c        print*,'pVol(i), Volo(i) ',pVol(i), Volo(i)
c        print*,'dudx_CSPH(i)',dudx_CSPH(i)
c        print*,'dudz_CSPH(i)',dudz_CSPH(i)
c        print*,'dwdx_CSPH(i)',dwdx_CSPH(i)
c        print*,'dwdz_CSPH(i)',dwdz_CSPH(i)
c        print*,'drhodx_CSPH(i)',drhodx_CSPH(i)
cc       print*,'drhody_CSPH(i)',drhody_CSPH(i)
c        print*,'drhodz_CSPH(i)',drhodz_CSPH(i)
c        print*,'sum_wab(i) ',sum_wab(i)
c        write(*,859)'ax(i) ',ax(i)
cc       write(*,859)'ay(i) '
c        write(*,859)'az(i) ',az(i)
c      endif

      !-- Perform final integration correction --
      do ipcount=nb_local+1,np_local
            call ipcount_to_i(ipcount,i)
            epsilon_rdot = -rdot(i)/rhop(i)
            rhop(i)  = rhoo(i) *
     &            (2.0 - epsilon_rdot*dt)/(2.0 + epsilon_rdot*dt)
            pVol(i) = pm(i)/rhop(i)
            !- Thermal Energy -
            TEp(i) = TEp(i) + dt2*TEdot(i)
c  ...      compute pressure using the equation of state
            call equation_of_state(rhop(i),TEp(i),p(i),cs(i))
      end do
      
      if(iBC.eq.2)then
        if(iDBC.eq.1)then	!Hughes & Grahams 2009 correction 
           do ipcount=1,nb_local
            call ipcount_to_i(ipcount,i)
            epsilon_rdot = -rdot(i)/rhop(i)
            rhop(i)  = rhoo(i) *
     &            (2.0 - epsilon_rdot*dt)/(2.0 + epsilon_rdot*dt)
            if (rhop(i).lt.rho0) rhop(i)=rho0
            pVol(i) = pm(i)/rhop(i)
            !- Thermal Energy -
            TEp(i) = TEp(i) + dt2*TEdot(i)
c  ...      compute pressure using the equation of state
            call equation_of_state(rhop(i),TEp(i),p(i),cs(i))
           enddo
        endif
      endif 
      
      
      do ipcount=nb_local+1,np_local
        i = ip_index_FP_local(ipcount-nb_local)
                 
        up(i) = uo(i) + dt*udot(i)
        vp(i) = vo(i) + dt*vdot(i)
        wp(i) = wo(i) + dt*wdot(i)
      
        xp(i) = xo(i) + dt2*(uo(i) + up(i))
        yp(i) = yo(i) + dt2*(vo(i) + vp(i))
        zp(i) = zo(i) + dt2*(wo(i) + wp(i))
         
      enddo

      do ipcount=nstart,np_local
         call ipcount_to_i(ipcount,i)
c  ...   Compute thermal energy
         VolTotalE(i) = VolTotalE(i) + dt2*aTE(i)
         TotalE(i) = VolTotalE(i) / pVol(i)
         TEp(i) = (TotalE(i)/rhop(i))
     &           - 0.5*(up(i)*up(i) + vp(i)*vp(i) + wp(i)*wp(i))
c  ...   compute pressure using the equation of state
         call equation_of_state(rhop(i),TEp(i),p(i),cs(i))
      enddo

c      if (ivar_dt.eq.1) then
c           call variable_time_step
c     &           (rank_id, n_procs, ierr, east, west, grid_comm)  
c          ddt_c=dt_new
c          dt=min(ddt_p,ddt_c)  !Time step to be used in next loop
c      endif
             
      call movingObjects(1)

      if (ivar_dt.eq.1) then
          call variable_time_step  
          ddt_c=dt_new
          dt=min(ddt_p,ddt_c)  !Time step to be used in next loop
      endif

c      !- Diagnostic Info -
c      if(itime.ge.itime_check.and.rank_id.eq.0)then
c        print*
c        print*,'In STEP_symplectic.f before INDEX_CHECK.f'
c        i =  i_ParticleCheck
c        print*,'itime, rank_id ',itime, rank_id
c        print*,'i, xp, zp ',i,xp(i),zp(i)
c        print*,'i, up, wp ',i,up(i),wp(i)
c        print*,'rhop(i) ',rhop(i)
c        print*,'p(i)    ',p(i)
c        print*,'sum_wab(i) ',sum_wab(i)
c        print*
c      end if
c      !stop
      
      
      call index_check_EastWest
      if(i_call_UpDown    .eq.1) call index_check_UpDown
      if(i_call_NorthSouth.eq.1) call index_check_NorthSouth  !3-D only

c     Normals are calculated in subroutine updateNormals
      if(iBC.eq.1)then   !Repulsive Force BC
       i_particleTypeChoice = 0
       if(i_MPI_Adapt.eq.1)then
         nbf_uN_start = 1             !All BPs
       else
         nbf_uN_start = nbf_local+1   !All moving BPs
       endif
       call updateNormals_3D(nbf_uN_start,nb_local,i_particleTypeChoice)   
      end if

c      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
c      if(itime.ge.itime_check.and.rank_id.eq.i_rank_check)then
c        print*
c        print*,'Accn Check, AFTER CORRECT, CORRECTOR'
c        print*,'rank_id, itime ',rank_id, itime
c        i = i_ParticleCheck  
c        print*,'i ',i
c        print*,'xp, zp  ',xp(i),zp(i)
c        print*,'up, wp  ',up(i),wp(i)
c        print*,'rhop, p,  pVol, pm ',rhop(i),p(i) ,pVol(i),pm(i)
c        print*,'rhoo, po, Volo, pm ',rhoo(i),po(i),Volo(i),pm(i)
c        print*,'VolTotalE   , VolTotalEo ',
c     &          VolTotalE(i), VolTotalEo(i) 
c        print*,'aTE(i) ',aTE(i)
c        print*,'TEp, TotalE ',TEp(i),TotalE(i)
c        print*,'ar(i), aVol(i) ',ar(i), aVol(i)
c        print*,'Volrhoo(i), Volrho(i) ',Volrhoo(i), Volrho(i) 
c        print*,'ax(i), Volrhou(i) ',ax(i), Volrhou(i)
c        print*,'az(i), Volrhow(i) ',az(i), Volrhow(i)
c        print*,'pVol(i), Volo(i) ',pVol(i), Volo(i)
c        print*,'dudx_CSPH(i)',dudx_CSPH(i)
c        print*,'dudz_CSPH(i)',dudz_CSPH(i)
c        print*,'dwdx_CSPH(i)',dwdx_CSPH(i)
c        print*,'dwdz_CSPH(i)',dwdz_CSPH(i)
c        print*,'drhodx_CSPH(i)',drhodx_CSPH(i)
c        print*,'drhodz_CSPH(i)',drhodz_CSPH(i)
c        print*,'sum_wab(i) ',sum_wab(i)
c        write(*,859)'ax(i) ',ax(i)
c        write(*,859)'az(i) ',az(i)
c        if(1.eq.2)then
c         i = 8822   !469
c         print*
c         print*,'i = ',i
c         print*,'xp, zp  ',xp(i),zp(i)
c         print*,'up, wp  ',up(i),wp(i)
c         print*,'rhop, p,  pVol, pm ',rhop(i),p(i) ,pVol(i),pm(i)
c         print*,'rhoo, po, Volo, pm ',rhoo(i),po(i),Volo(i),pm(i)
c         print*,'VolTotalE   , VolTotalEo ',
c     &           VolTotalE(i), VolTotalEo(i) 
c         print*,'aTE(i) ',aTE(i)
c         print*,'TEp, TotalE ',TEp(i),TotalE(i)
c         print*,'ar(i), aVol(i) ',ar(i), aVol(i)
c         print*,'Volrhoo(i), Volrho(i) ',Volrhoo(i), Volrho(i) 
c         print*,'ax(i), Volrhou(i) ',ax(i), Volrhou(i)
c         print*,'pVol(i), Volo(i) ',pVol(i), Volo(i)
c        endif
c        if(itime.eq.1)stop
c        !stop
c      end if
859     format(a11,' ',e24.16)        
      
      
      end
c