c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine update_MLS_Summations_fromWest
c
      include 'common.3D'
             
      real A_MLS_going_back_East(nGuestmax,16)
      real A_MLS_back_from_West(nGuestmax,16) 

      itime_check = 10e8   !0   !10e8   !0   !
      
!      !- Diagnostic Info -
!       if(itime.ge.itime_check)then
!         if(rank_id.eq.0)then
!           print*
!           print*,'In update_kernelSummations'
!           print*,'Cartesian Topology'
!         end if
!         do i=0,n_procs-1
!           if(itime.ge.itime_check.and.i.eq.rank_id-1)then   !if(i.eq.rank_id)then
!             write(*,*),'rank_id, east, west ',rank_id, east, west 
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!       end if
      
      !-- Zero non-communicating processes --
      if(rank_idx.eq.0
     &   .and.(.NOT.iCartTop_periodicity(1)))then
        nb_going_West = 0
        np_going_West = 0
        if(n_procs_x.eq.1)then
          nb_going_East = 0
          np_going_East = 0
        end if
      else if(rank_idx.eq.n_procs_x-1
     &   .and.(.NOT.iCartTop_periodicity(1)))then
        nb_going_East = 0
        np_going_East = 0
        if(n_procs_x.eq.1)then
          nb_going_West = 0
          np_going_West = 0
        end if
      end if

!      !- Diagnostic Info -
!       if(itime.ge.itime_check.and.rank_id.eq.0)then
!         print*
!         print*,'In update_kernelSummations'
!         print*
!         print*,'rank_id        ',rank_id
!         print*,'nb_local       ',nb_local
!         print*,'np_local       ',np_local
!         print*,'nb_from_East   ',nb_from_East
!         print*,'np_from_East   ',np_from_East
!         print*,'nb_from_West   ',nb_from_West
!         print*,'np_from_West   ',np_from_West
!         print*,'nb_image_local ',nb_image_local
!         print*,'np_image_local ',np_image_local        
!         print*,'nb_going_East   ',nb_going_East
!         print*,'np_going_East   ',np_going_East
!         print*,'nb_going_West   ',nb_going_West
!         print*,'np_going_West   ',np_going_West
!         print*,'east, west      ',east, west 
!       end if
!       if(itime.ge.itime_check.and.rank_id.eq.5)then
!         print*,'In update_kernelSummations'
!         print*
!         print*,'rank_id        ',rank_id
!         print*,'nb_local       ',nb_local
!         print*,'np_local       ',np_local
!         print*,'nb_from_East   ',nb_from_East
!         print*,'np_from_East   ',np_from_East
!         print*,'nb_from_West   ',nb_from_West
!         print*,'np_from_West   ',np_from_West
!         print*,'nb_image_local ',nb_image_local
!         print*,'np_image_local ',np_image_local        
!         print*,'nb_going_East   ',nb_going_East
!         print*,'np_going_East   ',np_going_East
!         print*,'nb_going_West   ',nb_going_West
!         print*,'np_going_West   ',np_going_West
!         print*,'east, west      ',east, west 
!       end if
                
      !--- PREPARE DATA PACKAGES FOR SENDRECVing ---

      !-- Pack Particle data to be sent back East--
c      if(itime.ge.itime_check.and.rank_id.eq.0)then
c        print*
c        print*,'Particles being sent back East'
c        print*,'rank_id ',rank_id
c        print*,'np_from_East ',np_from_East
c        print*,'kk_highest ',kk_highest
cc        print*,
cc     &  'ii, i_image, xp_going_back_East(ii), yp_going_back_East(ii)'
c        print*,
c     &  'ii,  i_image, xp, yp, zp(i_image), sum_wab_going_back_East(ii)'
c      end if
        do ii = 1,np_from_East
          !i_image = kk_highest + np_from_West + ii
          i_image = kk_highest + ii
          A_MLS_going_back_East(ii, 1) = A_MLS(i_image,1,1)            
          A_MLS_going_back_East(ii, 2) = A_MLS(i_image,1,2)            
          A_MLS_going_back_East(ii, 3) = A_MLS(i_image,1,3)            
          A_MLS_going_back_East(ii, 4) = A_MLS(i_image,1,4)            
          A_MLS_going_back_East(ii, 5) = A_MLS(i_image,2,1)            
          A_MLS_going_back_East(ii, 6) = A_MLS(i_image,2,2)            
          A_MLS_going_back_East(ii, 7) = A_MLS(i_image,2,3)            
          A_MLS_going_back_East(ii, 8) = A_MLS(i_image,2,4)            
          A_MLS_going_back_East(ii, 9) = A_MLS(i_image,3,1)            
          A_MLS_going_back_East(ii,10) = A_MLS(i_image,3,2)            
          A_MLS_going_back_East(ii,11) = A_MLS(i_image,3,3) 
          A_MLS_going_back_East(ii,12) = A_MLS(i_image,3,4) 
          A_MLS_going_back_East(ii,13) = A_MLS(i_image,4,1)            
          A_MLS_going_back_East(ii,14) = A_MLS(i_image,4,2)            
          A_MLS_going_back_East(ii,15) = A_MLS(i_image,4,3) 
          A_MLS_going_back_East(ii,16) = A_MLS(i_image,4,4) 
c          if(itime.ge.itime_check.and.rank_id.eq.0)then
c            print*,
c     &      ii,i_image,xp(i_image),yp(i_image),zp(i_image)
c          end if         
        end do                

      
      !Send data back East
        call MPI_SENDRECV(
     &    A_MLS_going_back_East, 1  , iMLS_DataType1, east, 0,
     &    A_MLS_back_from_West , 1  , iMLS_DataType1, west, 0,
     &    grid_comm, status, ierr)
      
c      call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      
      !-- Unpack Data & Update summations on original processors
      
      !-- UnPack Particle data originally sent West --
c      if(itime.ge.itime_check.and.rank_id.eq.0)then
c        print*,'Unpacking data originally sent West'
c        !print*,'Checking xy-positions'
c        !print*,'ii, i, xp_check, yp_check, xp(i), yp(i)'
c        print*,'np_going_West ',np_going_West
c        print*,'Summing sum_wab'
c        print*,'ii, i, sum_wab(i), A_MLS_back_from_West(ii,1)'
c      end if
        nbfm_start    = nbf_in_lx_2 + 1
        nbfreem_start = nbfm_in_lx_2 + 1
        nFP_start     = nb_going_West + 1
        do ii=1,np_going_West     !do ii=1,np_in_lx_2
          if(ii.lt.nbfm_start)then        
            i = iBP_going_West_1(ii)
          elseif(ii.lt.nbfreem_start)then        
            i = iBP_going_West_2(ii-nbf0_in_lx_2)
          elseif(ii.lt.nFP_start)then        
            i = iBP_going_West_3(ii-(nbf0_in_lx_2+nbfm0_in_lx_2))
          !if(ii.le.nb_going_West)then        
          !  i = iBP_going_West(ii)
          else
            i = iFP_going_West(ii-nb_going_West)
          end if 
          A_MLS(i,1,1) = A_MLS(i,1,1) + A_MLS_back_from_West(ii, 1)
          A_MLS(i,1,2) = A_MLS(i,1,2) + A_MLS_back_from_West(ii, 2)
          A_MLS(i,1,3) = A_MLS(i,1,3) + A_MLS_back_from_West(ii, 3)
          A_MLS(i,1,4) = A_MLS(i,1,4) + A_MLS_back_from_West(ii, 4)
          A_MLS(i,2,1) = A_MLS(i,2,1) + A_MLS_back_from_West(ii, 5)
          A_MLS(i,2,2) = A_MLS(i,2,2) + A_MLS_back_from_West(ii, 6)
          A_MLS(i,2,3) = A_MLS(i,2,3) + A_MLS_back_from_West(ii, 7)
          A_MLS(i,2,4) = A_MLS(i,2,4) + A_MLS_back_from_West(ii, 8)
          A_MLS(i,3,1) = A_MLS(i,3,1) + A_MLS_back_from_West(ii, 9)
          A_MLS(i,3,2) = A_MLS(i,3,2) + A_MLS_back_from_West(ii,10)
          A_MLS(i,3,3) = A_MLS(i,3,3) + A_MLS_back_from_West(ii,11)
          A_MLS(i,3,4) = A_MLS(i,3,4) + A_MLS_back_from_West(ii,12)
          A_MLS(i,4,1) = A_MLS(i,4,1) + A_MLS_back_from_West(ii,13)
          A_MLS(i,4,2) = A_MLS(i,4,2) + A_MLS_back_from_West(ii,14)
          A_MLS(i,4,3) = A_MLS(i,4,3) + A_MLS_back_from_West(ii,15)
          A_MLS(i,4,4) = A_MLS(i,4,4) + A_MLS_back_from_West(ii,16)
c          if(itime.ge.itime_check.and.rank_id.eq.0)then
c            !print*
c            !write(*,495),ii, i, xp_check, yp_check 
c            !write(*,495),ii, i, xp(i), yp(i)
c            write(*,494),ii, i, sum_wab(i), sum_wab_back_from_West(ii)
c          end if        
        end do


c494   format(2(i5,'    '),4(f12.6,'    '))      
c495   format(2(i5,'    '),4(e12.6,'    '))      
      
        
      end subroutine
