c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine update_Shepard_Summations_fromBelow
c
      include 'common.3D'

      real sum_wab_going_back_Above(nGuestmax)           
      real sum_wab_back_from_Below(nGuestmax)   
                   
      real rhop_sum_going_back_Above(nGuestmax)         
      real rhop_sum_back_from_Below(nGuestmax) 
              
      itime_check = 10e8   !0   !10e8   !0   !
      
!      !- Diagnostic Info -
!       if(itime.ge.itime_check)then
!         if(rank_id.eq.0)then
!           print*
!           print*,'In update_kernelSummations'
!           print*,'Cartesian Topology'
!         end if
!         do i=0,n_procs-1
!           if(itime.ge.itime_check.and.i.eq.rank_id-1)then   !if(i.eq.rank_id)then
!             write(*,*),'rank_id, above, below ',rank_id, above, below 
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!       end if
      
      !-- Zero non-communicating processes --
      if(rank_idz.eq.0
     &   .and.(.NOT.iCartTop_periodicity(3)))then
        nb_going_Below = 0
        np_going_Below = 0
        if(n_procs_z.eq.1)then
          nb_going_Above = 0
          np_going_Above = 0
        end if
      else if(rank_idz.eq.n_procs_z-1
     &   .and.(.NOT.iCartTop_periodicity(3)))then
        nb_going_Above = 0
        np_going_Above = 0
        if(n_procs_z.eq.1)then
          nb_going_Below = 0
          np_going_Below = 0
        end if
      end if

!      !- Diagnostic Info -
!       if(itime.ge.itime_check.and.rank_id.eq.0)then
!         print*
!         print*,'In update_kernelSummations'
!         print*
!         print*,'rank_id        ',rank_id
!         print*,'nb_local       ',nb_local
!         print*,'np_local       ',np_local
!         print*,'nb_from_Above   ',nb_from_Above
!         print*,'np_from_Above   ',np_from_Above
!         print*,'nb_from_Below   ',nb_from_Below
!         print*,'np_from_Below   ',np_from_Below
!         print*,'nb_image_local ',nb_image_local
!         print*,'np_image_local ',np_image_local        
!         print*,'nb_going_Above   ',nb_going_Above
!         print*,'np_going_Above   ',np_going_Above
!         print*,'nb_going_Below   ',nb_going_Below
!         print*,'np_going_Below   ',np_going_Below
!         print*,'above, below      ',above, below 
!       end if
!       if(itime.ge.itime_check.and.rank_id.eq.5)then
!         print*,'In update_kernelSummations'
!         print*
!         print*,'rank_id        ',rank_id
!         print*,'nb_local       ',nb_local
!         print*,'np_local       ',np_local
!         print*,'nb_from_Above   ',nb_from_Above
!         print*,'np_from_Above   ',np_from_Above
!         print*,'nb_from_Below   ',nb_from_Below
!         print*,'np_from_Below   ',np_from_Below
!         print*,'nb_image_local ',nb_image_local
!         print*,'np_image_local ',np_image_local        
!         print*,'nb_going_Above   ',nb_going_Above
!         print*,'np_going_Above   ',np_going_Above
!         print*,'nb_going_Below   ',nb_going_Below
!         print*,'np_going_Below   ',np_going_Below
!         print*,'above, below      ',above, below 
!       end if
                
      !--- PREPARE DATA PACKAGES FOR SENDRECVing ---

      !-- Pack Particle data to be sent back Above--
c      if(itime.ge.itime_check.and.rank_id.eq.0)then
c        print*
c        print*,'Particles being sent back Above'
c        print*,'rank_id ',rank_id
c        print*,'np_from_Above ',np_from_Above
c        print*,'kk_highest ',kk_highest
cc        print*,
cc     &  'ii, i_image, xp_going_back_Above(ii), yp_going_back_Above(ii)'
c        print*,
c     &  'ii,  i_image, xp, yp, zp(i_image), sum_wab_going_back_Above(ii)'
c      end if
      do ii = 1,np_from_Above
        !i_image = kk_highest + np_from_Below + ii
        i_image = kk_highest_after_SR_toWest + ii
        sum_wab_going_back_Above(ii)   = sum_wab(i_image)                    
        rhop_sum_going_back_Above(ii)  = rhop_sum(i_image)
c        if(itime.ge.itime_check.and.rank_id.eq.0)then
c          print*,
c     &    ii,i_image,xp(i_image),zp(i_image),
c     &    sum_wab_going_back_Above(ii)
c        end if         
      end do                

      
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      !--- SendRecv kernel summation information back to original processors ---
      
      !Send data back Above
      call MPI_SENDRECV(
     &   sum_wab_going_back_Above, np_from_Above  , MPI_REAL, above, 0,
     &   sum_wab_back_from_Below , np_going_Below , MPI_REAL, below, 0,
     &   grid_comm, status, ierr)
      call MPI_SENDRECV(
     &   rhop_sum_going_back_Above, np_from_Above , MPI_REAL, above, 0,
     &   rhop_sum_back_from_Below , np_going_Below, MPI_REAL, below, 0,
     &   grid_comm, status, ierr)
      
      !-- Unpack Data & Update summations on original processors
      
      !-- UnPack Particle data originally sent Below --
c      if(itime.ge.itime_check.and.rank_id.eq.0)then
c        print*,'Unpacking data originally sent Below'
c        print*,'np_going_Below ',np_going_Below
c        print*,'Summing sum_wab'
c        print*,'ii, i, sum_wab(i), sum_wab_back_from_Below(ii)'
c      end if
      nbfm_start    = nbf_in_lz_2 + 1
      nbfreem_start = nbfm_in_lz_2 + 1
      nFP_start     = nb_going_Below + 1
      do ii=1,np_going_Below     !do ii=1,np_in_lz_2
        if(ii.lt.nbfm_start)then        
          i = iBP_going_Below_1(ii)
        elseif(ii.lt.nbfreem_start)then        
          i = iBP_going_Below_2(ii-nbf0_in_lz_2)
        elseif(ii.lt.nFP_start)then        
          i = iBP_going_Below_3(ii-(nbf0_in_lz_2+nbfm0_in_lz_2))
        !if(ii.le.nb_going_Below)then        
        !  i = iBP_going_Below(ii)
        else
          i = iFP_going_Below(ii-nb_going_Below)
        end if 
        sum_wab(i)   = sum_wab(i) + sum_wab_back_from_Below(ii)        
        rhop_sum(i)  = rhop_sum(i) + rhop_sum_back_from_Below(ii)
c        if(itime.ge.itime_check.and.rank_id.eq.0)then
c          !print*
c          !write(*,495),ii, i, xp_check, yp_check 
c          !write(*,495),ii, i, xp(i), yp(i)
c          write(*,494),ii, i, sum_wab(i), sum_wab_back_from_Below(ii)
c        end if        
      end do


c494   format(2(i5,'    '),4(f12.6,'    '))      
c495   format(2(i5,'    '),4(e12.6,'    '))      
      
        
      end subroutine
