c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Dr Alejandro Crespo, Dr Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine update_accnSummations_fromBelow

      include 'common.3D'

      !-- Derived DataTypes --
      real accn_data_going_back_Above(nGuestmax,32)
      real accn_data_back_from_Below(nGuestmax,32)

      itime_check = 10e8   !0   !10e8

!      !- Diagnostic Info -
!       if(itime.ge.itime_check)then
!         if(rank_id.eq.0)then
!           print*,'In update_accnSummations'
!           print*,'Cartesian Topology'
!         end if
!         call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         do i=0,n_procs-1
!           if(i.eq.-rank_id-1)then   !if(i.eq.rank_id)then
!             write(*,*),'rank_id, above, below ',rank_id, above, below 
!           end if
!           call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
!         end do
!       
!         !-- Zero non-communicating processes --
!         if(rank_idz.eq.0
!      &     .and.(.NOT.iCartTop_periodicity(3)))then
!           nb_going_Below = 0
!           np_going_Below = 0
!           if(n_procs_z.eq.1)then
!             nb_going_Above = 0
!             np_going_Above = 0
!           end if
!         else if(rank_idz.eq.n_procs_z-1
!      &     .and.(.NOT.iCartTop_periodicity(3)))then
!           nb_going_Above = 0
!           np_going_Above = 0
!           if(n_procs_z.eq.1)then
!             nb_going_Below = 0
!             np_going_Below = 0
!           end if
!         end if
! 
!         if(rank_id.eq.0)then
!           print*,'In update_accnSummations'
!           print*
!           print*,'rank_id        ',rank_id
!           print*,'nb_local       ',nb_local
!           print*,'np_local       ',np_local
!           print*,'nb_from_Above  ',nb_from_Above
!           print*,'np_from_Above  ',np_from_Above
!           print*,'nb_from_Below  ',nb_from_Below
!           print*,'np_from_Below  ',np_from_Below
!           print*,'nb_image_local ',nb_image_local
!           print*,'np_image_local ',np_image_local        
!           print*,'nb_going_Above ',nb_going_Above
!           print*,'np_going_Above ',np_going_Above
!           print*,'nb_going_Below ',nb_going_Below
!           print*,'np_going_Below ',np_going_Below
!           print*,'above, below   ',above, below 
!         end if
!         if(rank_id.eq.-11)then
!           print*,'In update_accnSummations'
!           print*
!           print*,'rank_id        ',rank_id
!           print*,'nb_local       ',nb_local
!           print*,'np_local       ',np_local
!           print*,'nb_from_Above  ',nb_from_Above
!           print*,'np_from_Above  ',np_from_Above
!           print*,'nb_from_Below  ',nb_from_Below
!           print*,'np_from_Below  ',np_from_Below
!           print*,'nb_image_local ',nb_image_local
!           print*,'np_image_local ',np_image_local        
!           print*,'nb_going_Above ',nb_going_Above
!           print*,'np_going_Above ',np_going_Above
!           print*,'nb_going_Below ',nb_going_Below
!           print*,'np_going_Below ',np_going_Below
!           print*,'above, below   ',above, below 
!         end if
!       end if   !End of:  if(itime.ge.itime_check)then

      !-- Error Catching --
      if(np_from_Above.gt.nGuestmax)then
        print*
        print*,'In update_accnSummations.f '
        print*,'np_from_Above.gt.nGuestmax'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_from_Above ',np_from_Above
        stop
      end if
      if(np_from_Below.gt.nGuestmax)then
        print*
        print*,'In update_accnSummations.f '
        print*,'np_from_Below.gt.nGuestmax'
        print*,'rank_id, itime ',rank_id, itime
        print*,'np_from_Below ',np_from_Below
        stop
      end if
                
      !--- PREPARE DATA PACKAGES FOR SENDRECVing ---
      !-- Pack Particle data to be sent back Above--
c      if(itime.ge.itime_check)then
c        if(rank_id.eq.0)then
c          print*
c          print*,'Particles being sent back Above'
c          print*,'rank_id ',rank_id
c          print*,'np_from_Above ',np_from_Above
c          print*,
c     &  'ii, i_image, xp_going_back_Above(ii), zp_going_back_Above(ii), 
c     &ax(i_image), accn_data_going_back_Above(ii)'
c        end if
c      end if
      do ii = 1,np_from_Above
        !i_image = kk_highest + np_from_Below + ii
        i_image = kk_highest_after_SR_toWest + ii
        accn_data_going_back_Above(ii,1)    = ax(i_image) 
        accn_data_going_back_Above(ii,2)    = ay(i_image)
        accn_data_going_back_Above(ii,3)    = az(i_image)            
        accn_data_going_back_Above(ii,4)    = ar(i_image)            
        accn_data_going_back_Above(ii,5)    = aVol(i_image)            
        accn_data_going_back_Above(ii,6)    = ux(i_image)            
        accn_data_going_back_Above(ii,7)    = vx(i_image)
        accn_data_going_back_Above(ii,8)    = wx(i_image)            
        accn_data_going_back_Above(ii,9)    = dudx_CSPH(i_image)            
        accn_data_going_back_Above(ii,10)   = dudy_CSPH(i_image)
        accn_data_going_back_Above(ii,11)   = dudz_CSPH(i_image)            
        accn_data_going_back_Above(ii,12)   = dvdx_CSPH(i_image)
        accn_data_going_back_Above(ii,13)   = dvdy_CSPH(i_image)
        accn_data_going_back_Above(ii,14)   = dvdz_CSPH(i_image)
        accn_data_going_back_Above(ii,15)   = dwdx_CSPH(i_image)            
        accn_data_going_back_Above(ii,16)   = dwdy_CSPH(i_image)
        accn_data_going_back_Above(ii,17)   = dwdz_CSPH(i_image)            
        accn_data_going_back_Above(ii,18)   = drhodx_CSPH(i_image)            
        accn_data_going_back_Above(ii,19)   = drhody_CSPH(i_image)
        accn_data_going_back_Above(ii,20)   = drhodz_CSPH(i_image)            
        accn_data_going_back_Above(ii,21)   = drhoudx_CSPH(i_image)            
        accn_data_going_back_Above(ii,22)   = drhoudy_CSPH(i_image)
        accn_data_going_back_Above(ii,23)   = drhoudz_CSPH(i_image)            
        accn_data_going_back_Above(ii,24)   = drhovdx_CSPH(i_image)
        accn_data_going_back_Above(ii,25)   = drhovdy_CSPH(i_image)
        accn_data_going_back_Above(ii,26)   = drhovdz_CSPH(i_image)
        accn_data_going_back_Above(ii,27)   = drhowdx_CSPH(i_image)            
        accn_data_going_back_Above(ii,28)   = drhowdy_CSPH(i_image)
        accn_data_going_back_Above(ii,29)   = drhowdz_CSPH(i_image)            
        accn_data_going_back_Above(ii,30)   = dTotalEdx_CSPH(i_image)            
        accn_data_going_back_Above(ii,31)   = dTotalEdy_CSPH(i_image)
        accn_data_going_back_Above(ii,32)   = dTotalEdz_CSPH(i_image)            
c        if(itime.ge.itime_check.and.rank_id.eq.0)then
c          print*,
c     &    ii, i_image, xp(i_image), zp(i_image),
c     &    ax(i_image), accn_data_going_back_Above(ii,1)
c        end if         
      end do           

      
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      !--- SendRecv acceleration summation information back to original processors ---
       
c      !Send data back Above
      !---Combined SendRecv to Above Neighbour ---
      call MPI_SENDRECV(
     &   accn_data_going_back_Above, 1  , iaccn_DataTypeUAC, above, 101,
     &   accn_data_back_from_Below , 1  , iaccn_DataTypeUAC, below, 101,
     &   grid_comm, status, ierr)
     
      !call MPI_BARRIER(MPI_COMM_WORLD, ierr)   !Synchronise all processes to this point
      
      
      !-- Unpack Data & Update summations on original processors
      
      !-- UnPack Particle data originally sent Below --
c      if(itime.ge.itime_check.and.rank_id.eq.0)then
c        print*,'Unpacking data originally sent Below'
c        print*,'np_going_Below ',np_going_Below
c        !print*,'Checking xy-positions'
c        !print*,'ii, i, xp_check, yp_check, xp(i), yp(i)'
c        print*,'ii, i, xp_check, zp_check, xp(i), zp(i),
c     &ax(i),accn_data_back_from_Below(ii)'
c      end if
      nbfm_start    = nbf_in_lz_2 + 1
      nbfreem_start = nbfm_in_lz_2 + 1
      nFP_start     = nb_going_Below + 1
      do ii=1,np_going_Below     !do ii=1,np_in_lz_2
        if(ii.lt.nbfm_start)then        
          i = iBP_going_Below_1(ii)
        elseif(ii.lt.nbfreem_start)then        
          i = iBP_going_Below_2(ii-nbf0_in_lz_2)
        elseif(ii.lt.nFP_start)then        
          i = iBP_going_Below_3(ii-(nbf0_in_lz_2+nbfm0_in_lz_2))
        !if(ii.le.nb_going_Below)then        
        !  i = iBP_going_Below(ii)
        else
          i = iFP_going_Below(ii-nb_going_Below)
        end if 
c        if(itime.ge.itime_check.and.rank_id.eq.0)then
c         write(*,495),ii,i,xp(i),zp(i),ax(i),
c     &     accn_data_back_from_Below(ii,1)
c       end if        
       ax(i)  = ax(i) + accn_data_back_from_Below(ii,1)
       ay(i)  = ay(i) + accn_data_back_from_Below(ii,2)
       az(i)  = az(i) + accn_data_back_from_Below(ii,3)
       ar(i)   = ar(i)  + accn_data_back_from_Below(ii,4)
       aVol(i)    = aVol(i)   + accn_data_back_from_Below(ii,5)
       ux(i)      = ux(i)     + accn_data_back_from_Below(ii,6)
       vx(i)      = vx(i)     + accn_data_back_from_Below(ii,7)
       wx(i)      = wx(i)     + accn_data_back_from_Below(ii,8)
       dudx_CSPH(i) = dudx_CSPH(i) + accn_data_back_from_Below(ii,9)
       dudy_CSPH(i) = dudy_CSPH(i) + accn_data_back_from_Below(ii,10)
       dudz_CSPH(i) = dudz_CSPH(i) + accn_data_back_from_Below(ii,11)
       dvdx_CSPH(i) = dvdx_CSPH(i) + accn_data_back_from_Below(ii,12)
       dvdy_CSPH(i) = dvdy_CSPH(i) + accn_data_back_from_Below(ii,13)
       dvdz_CSPH(i) = dvdz_CSPH(i) + accn_data_back_from_Below(ii,14)
       dwdx_CSPH(i) = dwdx_CSPH(i) + accn_data_back_from_Below(ii,15)
       dwdy_CSPH(i) = dwdy_CSPH(i) + accn_data_back_from_Below(ii,16)
       dwdz_CSPH(i) = dwdz_CSPH(i) + accn_data_back_from_Below(ii,17)
       drhodx_CSPH(i) = drhodx_CSPH(i)+accn_data_back_from_Below(ii,18)
       drhody_CSPH(i) = drhody_CSPH(i)+accn_data_back_from_Below(ii,19)
       drhodz_CSPH(i) = drhodz_CSPH(i)+accn_data_back_from_Below(ii,20)
       drhoudx_CSPH(i) =drhoudx_CSPH(i)+accn_data_back_from_Below(ii,21)
       drhoudy_CSPH(i) =drhoudy_CSPH(i)+accn_data_back_from_Below(ii,22)
       drhoudz_CSPH(i) =drhoudz_CSPH(i)+accn_data_back_from_Below(ii,23)
       drhovdx_CSPH(i) =drhovdx_CSPH(i)+accn_data_back_from_Below(ii,24)
       drhovdy_CSPH(i) =drhovdy_CSPH(i)+accn_data_back_from_Below(ii,25)
       drhovdz_CSPH(i) =drhovdz_CSPH(i)+accn_data_back_from_Below(ii,26)
       drhowdx_CSPH(i) =drhowdx_CSPH(i)+accn_data_back_from_Below(ii,27)
       drhowdy_CSPH(i) =drhowdy_CSPH(i)+accn_data_back_from_Below(ii,28)
       drhowdz_CSPH(i) =drhowdz_CSPH(i)+accn_data_back_from_Below(ii,29)
       dTotalEdx_CSPH(i) = 
     &                dTotalEdx_CSPH(i)+accn_data_back_from_Below(ii,30)
       dTotalEdy_CSPH(i) =  
     &                dTotalEdy_CSPH(i)+accn_data_back_from_Below(ii,31) 
       dTotalEdz_CSPH(i) = 
     &                dTotalEdz_CSPH(i)+accn_data_back_from_Below(ii,32)
      end do


495   format(2(i5,'  '),4(e12.6,'  '))      
      
      !stop
        
      end subroutine
