c    "Copyright 2010 Prof. Robert Dalrymple, Prof. M. Gomez Gesteira, Dr Benedict Rogers, 
c     Alejandro Crespo, Muthukumar Narayanaswamy, Dr Shan Zou, Dr Andrea Panizzo "
c
c    This file is part of SPHYSICS.
c
c    SPHYSICS is free software; you can redistribute it and/or modify
c    it under the terms of the GNU General Public License as published by
c    the Free Software Foundation; either version 3 of the License, or
c    (at your option) any later version.
c
c    SPHYSICS is distributed in the hope that it will be useful,
c    but WITHOUT ANY WARRANTY; without even the implied warranty of
c    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c    GNU General Public License for more details.
c
c    You should have received a copy of the GNU General Public License
c    along with this program.  If not, see <http://www.gnu.org/licenses/>.

      subroutine viscosity(dot,drx,dry,drz,dux,duy,duz,rr2,
     +	          cbar,robar,one_over_rhobar,i,j,j1,j2,term2i,term2j)

      include 'common.3D'  	


      tau_xx_c = tau_xx_uno_rho2(i)+tau_xx_uno_rho2(j)
      tau_xy_c = tau_xy_uno_rho2(i)+tau_xy_uno_rho2(j)
      tau_xz_c = tau_xz_uno_rho2(i)+tau_xz_uno_rho2(j)
      tau_yy_c = tau_yy_uno_rho2(i)+tau_yy_uno_rho2(j)
      tau_yz_c = tau_yz_uno_rho2(i)+tau_yz_uno_rho2(j)
      tau_zz_c = tau_zz_uno_rho2(i)+tau_zz_uno_rho2(j)

	
               ax(i) = ax(i) + pm(j)*
     &             (tau_xx_c*frxi  
     &            + tau_xy_c*fryi
     &            + tau_xz_c*frzi)
               ay(i) = ay(i) + pm(j)*
     &             (tau_xy_c*frxi  
     &            + tau_yy_c*fryi
     &            + tau_yz_c*frzi)  
               az(i) = az(i) + pm(j)*
     &             (tau_xz_c*frxi  
     &            + tau_yz_c*fryi  
     &            + tau_zz_c*frzi)

               ax(j) = ax(j) - pm(i)*
     &             (tau_xx_c*frxj  
     &            + tau_xy_c*fryj
     &            + tau_xz_c*frzj)
               ay(j) = ay(j) - pm(i)*
     &             (tau_xy_c*frxj  
     &            + tau_yy_c*fryj
     &            + tau_yz_c*frzj)  
               az(j) = az(j) - pm(i)*
     &             (tau_xz_c*frxj  
     &            + tau_yz_c*fryj  
     &            + tau_zz_c*frzj)
c         -----------------

c         --- Viscous Diffusion terms (Lo & Shao 2002) ---

          tempi = 2.*viscos_val*one_over_rhobar*
     &    ((drx*frxi+dry*fryi+drz*frzi)/(rr2 + eta2))
          tempj = 2.*viscos_val*one_over_rhobar*
     &    ((drx*frxj+dry*fryj+drz*frzj)/(rr2 + eta2))


          ax(i) = ax(i) + pm(j)*tempi*dux
          ay(i) = ay(i) + pm(j)*tempi*duy
          az(i) = az(i) + pm(j)*tempi*duz

          ax(j) = ax(j) - pm(i)*tempj*dux
          ay(j) = ay(j) - pm(i)*tempj*duy
          az(j) = az(j) - pm(i)*tempj*duz
 
          term2i=- 0.5 * tempi *( dux*dux+duy*duy+duz*duz)-
     +    0.5*((dux*(tau_xx_c*frxi+ tau_xy_c*fryi+ tau_xz_c*frzi)+
     +          duy*(tau_xy_c*frxi+ tau_yy_c*fryi+ tau_yz_c*frzi)+
     +          duz*(tau_xz_c*frxi+ tau_yz_c*fryi+ tau_zz_c*frzi)))

          term2j=- 0.5 * tempj *( dux*dux+duy*duy+duz*duz)-
     +    0.5*((dux*(tau_xx_c*frxj+ tau_xy_c*fryj+ tau_xz_c*frzj)+
     +          duy*(tau_xy_c*frxj+ tau_yy_c*fryj+ tau_yz_c*frzj)+
     +          duz*(tau_xz_c*frxj+ tau_yz_c*fryj+ tau_zz_c*frzj)))

	return
	end
